
/* parser generated by jison 0.6.1-215 */

/*
 * Returns a Parser object of the following structure:
 *
 *  Parser: {
 *    yy: {}     The so-called "shared state" or rather the *source* of it;
 *               the real "shared state" `yy` passed around to
 *               the rule actions, etc. is a derivative/copy of this one,
 *               not a direct reference!
 *  }
 *
 *  Parser.prototype: {
 *    yy: {},
 *    EOF: 1,
 *    TERROR: 2,
 *
 *    trace: function(errorMessage, ...),
 *
 *    JisonParserError: function(msg, hash),
 *
 *    quoteName: function(name),
 *               Helper function which can be overridden by user code later on: put suitable
 *               quotes around literal IDs in a description string.
 *
 *    originalQuoteName: function(name),
 *               The basic quoteName handler provided by JISON.
 *               `cleanupAfterParse()` will clean up and reset `quoteName()` to reference this function
 *               at the end of the `parse()`.
 *
 *    describeSymbol: function(symbol),
 *               Return a more-or-less human-readable description of the given symbol, when
 *               available, or the symbol itself, serving as its own 'description' for lack
 *               of something better to serve up.
 *
 *               Return NULL when the symbol is unknown to the parser.
 *
 *    symbols_: {associative list: name ==> number},
 *    terminals_: {associative list: number ==> name},
 *    nonterminals: {associative list: rule-name ==> {associative list: number ==> rule-alt}},
 *    terminal_descriptions_: (if there are any) {associative list: number ==> description},
 *    productions_: [...],
 *
 *    performAction: function parser__performAction(yytext, yyleng, yylineno, yyloc, yystate, yysp, yyvstack, yylstack, yystack, yysstack),
 *
 *               The function parameters and `this` have the following value/meaning:
 *               - `this`    : reference to the `yyval` internal object, which has members (`$` and `_$`)
 *                             to store/reference the rule value `$$` and location info `@$`.
 *
 *                 One important thing to note about `this` a.k.a. `yyval`: every *reduce* action gets
 *                 to see the same object via the `this` reference, i.e. if you wish to carry custom
 *                 data from one reduce action through to the next within a single parse run, then you
 *                 may get nasty and use `yyval` a.k.a. `this` for storing you own semi-permanent data.
 *
 *                 `this.yy` is a direct reference to the `yy` shared state object.
 *
 *                 `%parse-param`-specified additional `parse()` arguments have been added to this `yy`
 *                 object at `parse()` start and are therefore available to the action code via the
 *                 same named `yy.xxxx` attributes (where `xxxx` represents a identifier name from
 *                 the %parse-param` list.
 *
 *               - `yytext`  : reference to the lexer value which belongs to the last lexer token used
 *                             to match this rule. This is *not* the look-ahead token, but the last token
 *                             that's actually part of this rule.
 *
 *                 Formulated another way, `yytext` is the value of the token immediately preceeding
 *                 the current look-ahead token.
 *                 Caveats apply for rules which don't require look-ahead, such as epsilon rules.
 *
 *               - `yyleng`  : ditto as `yytext`, only now for the lexer.yyleng value.
 *
 *               - `yylineno`: ditto as `yytext`, only now for the lexer.yylineno value.
 *
 *               - `yyloc`   : ditto as `yytext`, only now for the lexer.yylloc lexer token location info.
 *
 *                               WARNING: since jison 0.4.18-186 this entry may be NULL/UNDEFINED instead
 *                               of an empty object when no suitable location info can be provided.
 *
 *               - `yystate` : the current parser state number, used internally for dispatching and
 *                               executing the action code chunk matching the rule currently being reduced.
 *
 *               - `yysp`    : the current state stack position (a.k.a. 'stack pointer')
 *
 *                 This one comes in handy when you are going to do advanced things to the parser
 *                 stacks, all of which are accessible from your action code (see the next entries below).
 *
 *                 Also note that you can access this and other stack index values using the new double-hash
 *                 syntax, i.e. `##$ === ##0 === yysp`, while `##1` is the stack index for all things
 *                 related to the first rule term, just like you have `$1`, `@1` and `#1`.
 *                 This is made available to write very advanced grammar action rules, e.g. when you want
 *                 to investigate the parse state stack in your action code, which would, for example,
 *                 be relevant when you wish to implement error diagnostics and reporting schemes similar
 *                 to the work described here:
 *
 *                 + Pottier, F., 2016. Reachability and error diagnosis in LR(1) automata.
 *                   In Journées Francophones des Languages Applicatifs.
 *
 *                 + Jeffery, C.L., 2003. Generating LR syntax error messages from examples.
 *                   ACM Transactions on Programming Languages and Systems (TOPLAS), 25(5), pp.631–640.
 *
 *               - `yyrulelength`: the current rule's term count, i.e. the number of entries occupied on the stack.
 *
 *                 This one comes in handy when you are going to do advanced things to the parser
 *                 stacks, all of which are accessible from your action code (see the next entries below).
 *
 *               - `yyvstack`: reference to the parser value stack. Also accessed via the `$1` etc.
 *                             constructs.
 *
 *               - `yylstack`: reference to the parser token location stack. Also accessed via
 *                             the `@1` etc. constructs.
 *
 *                             WARNING: since jison 0.4.18-186 this array MAY contain slots which are
 *                             UNDEFINED rather than an empty (location) object, when the lexer/parser
 *                             action code did not provide a suitable location info object when such a
 *                             slot was filled!
 *
 *               - `yystack` : reference to the parser token id stack. Also accessed via the
 *                             `#1` etc. constructs.
 *
 *                 Note: this is a bit of a **white lie** as we can statically decode any `#n` reference to
 *                 its numeric token id value, hence that code wouldn't need the `yystack` but *you* might
 *                 want access this array for your own purposes, such as error analysis as mentioned above!
 *
 *                 Note that this stack stores the current stack of *tokens*, that is the sequence of
 *                 already parsed=reduced *nonterminals* (tokens representing rules) and *terminals*
 *                 (lexer tokens *shifted* onto the stack until the rule they belong to is found and
 *                 *reduced*.
 *
 *               - `yysstack`: reference to the parser state stack. This one carries the internal parser
 *                             *states* such as the one in `yystate`, which are used to represent
 *                             the parser state machine in the *parse table*. *Very* *internal* stuff,
 *                             what can I say? If you access this one, you're clearly doing wicked things
 *
 *               - `...`     : the extra arguments you specified in the `%parse-param` statement in your
 *                             grammar definition file.
 *
 *    table: [...],
 *               State transition table
 *               ----------------------
 *
 *               index levels are:
 *               - `state`  --> hash table
 *               - `symbol` --> action (number or array)
 *
 *                 If the `action` is an array, these are the elements' meaning:
 *                 - index [0]: 1 = shift, 2 = reduce, 3 = accept
 *                 - index [1]: GOTO `state`
 *
 *                 If the `action` is a number, it is the GOTO `state`
 *
 *    defaultActions: {...},
 *
 *    parseError: function(str, hash, ExceptionClass),
 *    yyError: function(str, ...),
 *    yyRecovering: function(),
 *    yyErrOk: function(),
 *    yyClearIn: function(),
 *
 *    constructParseErrorInfo: function(error_message, exception_object, expected_token_set, is_recoverable),
 *               Helper function **which will be set up during the first invocation of the `parse()` method**.
 *               Produces a new errorInfo 'hash object' which can be passed into `parseError()`.
 *               See it's use in this parser kernel in many places; example usage:
 *
 *                   var infoObj = parser.constructParseErrorInfo('fail!', null,
 *                                     parser.collect_expected_token_set(state), true);
 *                   var retVal = parser.parseError(infoObj.errStr, infoObj, parser.JisonParserError);
 *
 *    originalParseError: function(str, hash, ExceptionClass),
 *               The basic `parseError` handler provided by JISON.
 *               `cleanupAfterParse()` will clean up and reset `parseError()` to reference this function
 *               at the end of the `parse()`.
 *
 *    options: { ... parser %options ... },
 *
 *    parse: function(input[, args...]),
 *               Parse the given `input` and return the parsed value (or `true` when none was provided by
 *               the root action, in which case the parser is acting as a *matcher*).
 *               You MAY use the additional `args...` parameters as per `%parse-param` spec of this grammar:
 *               these extra `args...` are added verbatim to the `yy` object reference as member variables.
 *
 *               WARNING:
 *               Parser's additional `args...` parameters (via `%parse-param`) MAY conflict with
 *               any attributes already added to `yy` by the jison run-time;
 *               when such a collision is detected an exception is thrown to prevent the generated run-time
 *               from silently accepting this confusing and potentially hazardous situation!
 *
 *               The lexer MAY add its own set of additional parameters (via the `%parse-param` line in
 *               the lexer section of the grammar spec): these will be inserted in the `yy` shared state
 *               object and any collision with those will be reported by the lexer via a thrown exception.
 *
 *    cleanupAfterParse: function(resultValue, invoke_post_methods, do_not_nuke_errorinfos),
 *               Helper function **which will be set up during the first invocation of the `parse()` method**.
 *               This helper API is invoked at the end of the `parse()` call, unless an exception was thrown
 *               and `%options no-try-catch` has been defined for this grammar: in that case this helper MAY
 *               be invoked by calling user code to ensure the `post_parse` callbacks are invoked and
 *               the internal parser gets properly garbage collected under these particular circumstances.
 *
 *    yyMergeLocationInfo: function(first_index, last_index, first_yylloc, last_yylloc, dont_look_back),
 *               Helper function **which will be set up during the first invocation of the `parse()` method**.
 *               This helper API can be invoked to calculate a spanning `yylloc` location info object.
 *
 *               Note: %epsilon rules MAY specify no `first_index` and `first_yylloc`, in which case
 *               this function will attempt to obtain a suitable location marker by inspecting the location stack
 *               backwards.
 *
 *               For more info see the documentation comment further below, immediately above this function's
 *               implementation.
 *
 *    lexer: {
 *        yy: {...},           A reference to the so-called "shared state" `yy` once
 *                             received via a call to the `.setInput(input, yy)` lexer API.
 *        EOF: 1,
 *        ERROR: 2,
 *        JisonLexerError: function(msg, hash),
 *        parseError: function(str, hash, ExceptionClass),
 *        setInput: function(input, [yy]),
 *        input: function(),
 *        unput: function(str),
 *        more: function(),
 *        reject: function(),
 *        less: function(n),
 *        pastInput: function(n),
 *        upcomingInput: function(n),
 *        showPosition: function(),
 *        test_match: function(regex_match_array, rule_index, ...),
 *        next: function(...),
 *        lex: function(...),
 *        begin: function(condition),
 *        pushState: function(condition),
 *        popState: function(),
 *        topState: function(),
 *        _currentRules: function(),
 *        stateStackSize: function(),
 *        cleanupAfterLex: function()
 *
 *        options: { ... lexer %options ... },
 *
 *        performAction: function(yy, yy_, $avoiding_name_collisions, YY_START, ...),
 *        rules: [...],
 *        conditions: {associative list: name ==> set},
 *    }
 *  }
 *
 *
 *  token location info (@$, _$, etc.): {
 *    first_line: n,
 *    last_line: n,
 *    first_column: n,
 *    last_column: n,
 *    range: [start_number, end_number]
 *               (where the numbers are indexes into the input string, zero-based)
 *  }
 *
 * ---
 *
 * The `parseError` function receives a 'hash' object with these members for lexer and
 * parser errors:
 *
 *  {
 *    text:        (matched text)
 *    token:       (the produced terminal token, if any)
 *    token_id:    (the produced terminal token numeric ID, if any)
 *    line:        (yylineno)
 *    loc:         (yylloc)
 *  }
 *
 * parser (grammar) errors will also provide these additional members:
 *
 *  {
 *    expected:    (array describing the set of expected tokens;
 *                  may be UNDEFINED when we cannot easily produce such a set)
 *    state:       (integer (or array when the table includes grammar collisions);
 *                  represents the current internal state of the parser kernel.
 *                  can, for example, be used to pass to the `collect_expected_token_set()`
 *                  API to obtain the expected token set)
 *    action:      (integer; represents the current internal action which will be executed)
 *    new_state:   (integer; represents the next/planned internal state, once the current
 *                  action has executed)
 *    recoverable: (boolean: TRUE when the parser MAY have an error recovery rule
 *                  available for this particular error)
 *    state_stack: (array: the current parser LALR/LR internal state stack; this can be used,
 *                  for instance, for advanced error analysis and reporting)
 *    value_stack: (array: the current parser LALR/LR internal `$$` value stack; this can be used,
 *                  for instance, for advanced error analysis and reporting)
 *    location_stack: (array: the current parser LALR/LR internal location stack; this can be used,
 *                  for instance, for advanced error analysis and reporting)
 *    yy:          (object: the current parser internal "shared state" `yy`
 *                  as is also available in the rule actions; this can be used,
 *                  for instance, for advanced error analysis and reporting)
 *    lexer:       (reference to the current lexer instance used by the parser)
 *    parser:      (reference to the current parser instance)
 *  }
 *
 * while `this` will reference the current parser instance.
 *
 * When `parseError` is invoked by the lexer, `this` will still reference the related *parser*
 * instance, while these additional `hash` fields will also be provided:
 *
 *  {
 *    lexer:       (reference to the current lexer instance which reported the error)
 *  }
 *
 * When `parseError` is invoked by the parser due to a **JavaScript exception** being fired
 * from either the parser or lexer, `this` will still reference the related *parser*
 * instance, while these additional `hash` fields will also be provided:
 *
 *  {
 *    exception:   (reference to the exception thrown)
 *  }
 *
 * Please do note that in the latter situation, the `expected` field will be omitted as
 * this type of failure is assumed not to be due to *parse errors* but rather due to user
 * action code in either parser or lexer failing unexpectedly.
 *
 * ---
 *
 * You can specify parser options by setting / modifying the `.yy` object of your Parser instance.
 * These options are available:
 *
 * ### options which are global for all parser instances
 *
 *  Parser.pre_parse: function(yy)
 *                 optional: you can specify a pre_parse() function in the chunk following
 *                 the grammar, i.e. after the last `%%`.
 *  Parser.post_parse: function(yy, retval, parseInfo) { return retval; }
 *                 optional: you can specify a post_parse() function in the chunk following
 *                 the grammar, i.e. after the last `%%`. When it does not return any value,
 *                 the parser will return the original `retval`.
 *
 * ### options which can be set up per parser instance
 *
 *  yy: {
 *      pre_parse:  function(yy)
 *                 optional: is invoked before the parse cycle starts (and before the first
 *                 invocation of `lex()`) but immediately after the invocation of
 *                 `parser.pre_parse()`).
 *      post_parse: function(yy, retval, parseInfo) { return retval; }
 *                 optional: is invoked when the parse terminates due to success ('accept')
 *                 or failure (even when exceptions are thrown).
 *                 `retval` contains the return value to be produced by `Parser.parse()`;
 *                 this function can override the return value by returning another.
 *                 When it does not return any value, the parser will return the original
 *                 `retval`.
 *                 This function is invoked immediately before `parser.post_parse()`.
 *
 *      parseError: function(str, hash, ExceptionClass)
 *                 optional: overrides the default `parseError` function.
 *      quoteName: function(name),
 *                 optional: overrides the default `quoteName` function.
 *  }
 *
 *  parser.lexer.options: {
 *      pre_lex:  function()
 *                 optional: is invoked before the lexer is invoked to produce another token.
 *                 `this` refers to the Lexer object.
 *      post_lex: function(token) { return token; }
 *                 optional: is invoked when the lexer has produced a token `token`;
 *                 this function can override the returned token value by returning another.
 *                 When it does not return any (truthy) value, the lexer will return
 *                 the original `token`.
 *                 `this` refers to the Lexer object.
 *
 *      ranges: boolean
 *                 optional: `true` ==> token location info will include a .range[] member.
 *      flex: boolean
 *                 optional: `true` ==> flex-like lexing behaviour where the rules are tested
 *                 exhaustively to find the longest match.
 *      backtrack_lexer: boolean
 *                 optional: `true` ==> lexer regexes are tested in order and for invoked;
 *                 the lexer terminates the scan when a token is returned by the action code.
 *      xregexp: boolean
 *                 optional: `true` ==> lexer rule regexes are "extended regex format" requiring the
 *                 `XRegExp` library. When this `%option` has not been specified at compile time, all lexer
 *                 rule regexes have been written as standard JavaScript RegExp expressions.
 *  }
 */

        
    
            var Elysion = (function () {


// See also:
// http://stackoverflow.com/questions/1382107/whats-a-good-way-to-extend-error-in-javascript/#35881508
// but we keep the prototype.constructor and prototype.name assignment lines too for compatibility
// with userland code which might access the derived class in a 'classic' way.
function JisonParserError(msg, hash) {
    Object.defineProperty(this, 'name', {
        enumerable: false,
        writable: false,
        value: 'JisonParserError'
    });

    if (msg == null) msg = '???';

    Object.defineProperty(this, 'message', {
        enumerable: false,
        writable: true,
        value: msg
    });

    this.hash = hash;

    var stacktrace;
    if (hash && hash.exception instanceof Error) {
        var ex2 = hash.exception;
        this.message = ex2.message || msg;
        stacktrace = ex2.stack;
    }
    if (!stacktrace) {
        if (Error.hasOwnProperty('captureStackTrace')) {        // V8/Chrome engine
            Error.captureStackTrace(this, this.constructor);
        } else {
            stacktrace = (new Error(msg)).stack;
        }
    }
    if (stacktrace) {
        Object.defineProperty(this, 'stack', {
            enumerable: false,
            writable: false,
            value: stacktrace
        });
    }
}

if (typeof Object.setPrototypeOf === 'function') {
    Object.setPrototypeOf(JisonParserError.prototype, Error.prototype);
} else {
    JisonParserError.prototype = Object.create(Error.prototype);
}
JisonParserError.prototype.constructor = JisonParserError;
JisonParserError.prototype.name = 'JisonParserError';




        // helper: reconstruct the productions[] table
        function bp(s) {
            var rv = [];
            var p = s.pop;
            var r = s.rule;
            for (var i = 0, l = p.length; i < l; i++) {
                rv.push([
                    p[i],
                    r[i]
                ]);
            }
            return rv;
        }
    


        // helper: reconstruct the defaultActions[] table
        function bda(s) {
            var rv = {};
            var d = s.idx;
            var g = s.goto;
            for (var i = 0, l = d.length; i < l; i++) {
                var j = d[i];
                rv[j] = g[i];
            }
            return rv;
        }
    


        // helper: reconstruct the 'goto' table
        function bt(s) {
            var rv = [];
            var d = s.len;
            var y = s.symbol;
            var t = s.type;
            var a = s.state;
            var m = s.mode;
            var g = s.goto;
            for (var i = 0, l = d.length; i < l; i++) {
                var n = d[i];
                var q = {};
                for (var j = 0; j < n; j++) {
                    var z = y.shift();
                    switch (t.shift()) {
                    case 2:
                        q[z] = [
                            m.shift(),
                            g.shift()
                        ];
                        break;

                    case 0:
                        q[z] = a.shift();
                        break;

                    default:
                        // type === 1: accept
                        q[z] = [
                            3
                        ];
                    }
                }
                rv.push(q);
            }
            return rv;
        }
    


        // helper: runlength encoding with increment step: code, length: step (default step = 0)
        // `this` references an array
        function s(c, l, a) {
            a = a || 0;
            for (var i = 0; i < l; i++) {
                this.push(c);
                c += a;
            }
        }

        // helper: duplicate sequence from *relative* offset and length.
        // `this` references an array
        function c(i, l) {
            i = this.length - i;
            for (l += i; i < l; i++) {
                this.push(this[i]);
            }
        }

        // helper: unpack an array using helpers and data, all passed in an array argument 'a'.
        function u(a) {
            var rv = [];
            for (var i = 0, l = a.length; i < l; i++) {
                var e = a[i];
                // Is this entry a helper function?
                if (typeof e === 'function') {
                    i++;
                    e.apply(rv, a[i]);
                } else {
                    rv.push(e);
                }
            }
            return rv;
        }
    

var parser = {
    // Code Generator Information Report
    // ---------------------------------
    //
    // Options:
    //
    //   default action mode: ............. ["classic","merge"]
    //   test-compile action mode: ........ "parser:*,lexer:*"
    //   try..catch: ...................... true
    //   default resolve on conflict: ..... true
    //   on-demand look-ahead: ............ false
    //   error recovery token skip maximum: 3
    //   yyerror in parse actions is: ..... NOT recoverable,
    //   yyerror in lexer actions and other non-fatal lexer are:
    //   .................................. NOT recoverable,
    //   debug grammar/output: ............ false
    //   has partial LR conflict upgrade:   true
    //   rudimentary token-stack support:   false
    //   parser table compression mode: ... 2
    //   export debug tables: ............. false
    //   export *all* tables: ............. false
    //   module type: ..................... commonjs
    //   parser engine type: .............. lalr
    //   output main() in the module: ..... true
    //   has user-specified main(): ....... false
    //   has user-specified require()/import modules for main():
    //   .................................. false
    //   number of expected conflicts: .... 0
    //
    //
    // Parser Analysis flags:
    //
    //   no significant actions (parser is a language matcher only):
    //   .................................. false
    //   uses yyleng: ..................... false
    //   uses yylineno: ................... false
    //   uses yytext: ..................... false
    //   uses yylloc: ..................... false
    //   uses ParseError API: ............. false
    //   uses YYERROR: .................... false
    //   uses YYRECOVERING: ............... false
    //   uses YYERROK: .................... false
    //   uses YYCLEARIN: .................. false
    //   tracks rule values: .............. true
    //   assigns rule values: ............. true
    //   uses location tracking: .......... true
    //   assigns location: ................ true
    //   uses yystack: .................... false
    //   uses yysstack: ................... false
    //   uses yysp: ....................... true
    //   uses yyrulelength: ............... false
    //   uses yyMergeLocationInfo API: .... true
    //   has error recovery: .............. false
    //   has error reporting: ............. false
    //
    // --------- END OF REPORT -----------

trace: function no_op_trace() { },
JisonParserError: JisonParserError,
yy: {},
options: {
  type: "lalr",
  hasPartialLrUpgradeOnConflict: true,
  errorRecoveryTokenDiscardCount: 3
},
symbols_: {
  "!": 7,
  "!=": 64,
  "!==": 62,
  "$accept": 0,
  "$end": 1,
  "%": 9,
  "&": 14,
  "&&": 71,
  "(": 21,
  ")": 22,
  ")>": 135,
  "*": 8,
  "**": 55,
  "+": 4,
  "++": 51,
  ",": 15,
  "-": 5,
  "--": 52,
  ".": 23,
  "...": 77,
  ":": 20,
  "::": 27,
  ";": 18,
  "<": 12,
  "<(": 134,
  "<<": 58,
  "<=": 66,
  "==": 63,
  "===": 61,
  ">": 11,
  ">=": 65,
  ">>": 59,
  ">>>": 60,
  "?": 19,
  "??": 72,
  "@": 3,
  "AND": 68,
  "ARGUMENT": 142,
  "AS": 139,
  "ASYNC": 33,
  "AT": 140,
  "AWAIT": 37,
  "Access": 242,
  "AlphaNum": 218,
  "Arg": 178,
  "ArgList": 177,
  "Arguments": 176,
  "Array": 244,
  "ArrayArg": 248,
  "ArrayList": 246,
  "Assign": 235,
  "AssignKeyword": 237,
  "Assignable": 238,
  "Assignment": 236,
  "BOOL": 121,
  "BREAK": 92,
  "Block": 182,
  "BlockExpression": 194,
  "Body": 159,
  "CALL_END": 76,
  "CALL_START": 75,
  "CASE": 94,
  "CATCH": 103,
  "CHAIN": 45,
  "CLASS": 78,
  "COMPOUND_AND": 50,
  "COMPOUND_OR": 93,
  "CONST": 153,
  "CONTINUE": 145,
  "Case": 189,
  "Cases": 188,
  "Catch": 198,
  "Class": 180,
  "ClassConstructor?": 181,
  "Clause": 169,
  "Clauses": 190,
  "Code": 163,
  "Compare": 173,
  "DEFAULT": 90,
  "DEFAULTS": 118,
  "DIVISION": 57,
  "DO": 34,
  "Declaration": 273,
  "DeclarationKeyword": 271,
  "Declarations": 272,
  "Declare": 270,
  "EITHER": 46,
  "EITHER_OR": 49,
  "ELSE": 110,
  "EOF": 1,
  "EXISTS": 41,
  "EXPORT": 156,
  "EXTENDS": 79,
  "Else": 202,
  "ElseOtherwise": 205,
  "Export": 277,
  "ExportList": 280,
  "ExportName": 282,
  "ExportNames": 281,
  "Exportable": 283,
  "Expression": 161,
  "FINALLY": 102,
  "FOR": 83,
  "FOR_AS": 98,
  "FOR_AT": 97,
  "FOR_FROM": 96,
  "FOR_IN": 87,
  "FOR_OF": 86,
  "FROM": 141,
  "FUNCTION": 133,
  "FUNC_DIRECTIVE": 28,
  "FUNC_EXISTS": 74,
  "Finally": 197,
  "For": 185,
  "ForAny": 192,
  "ForAssignable": 186,
  "ForExpression": 183,
  "FuncBody": 228,
  "FuncHeader": 230,
  "FuncSpecifiers": 229,
  "Function": 227,
  "GET": 137,
  "IDENTIFIER": 144,
  "IF": 95,
  "IMPORT": 155,
  "IN": 143,
  "INCLUDES": 43,
  "INDENT": 38,
  "INDEX_END": 116,
  "INDEX_START": 115,
  "INFINITY": 120,
  "INSTANCEOF": 67,
  "INTERFACE": 147,
  "INTERPOLATION_END": 129,
  "INTERPOLATION_START": 128,
  "IS": 47,
  "ISNT": 48,
  "Identifier": 240,
  "Identifier?": 257,
  "If": 193,
  "IfBlock": 203,
  "IfUnless": 204,
  "Import": 275,
  "Import(FROM)": 276,
  "ImportList": 279,
  "ImportName": 285,
  "ImportNames": 284,
  "Interface": 252,
  "InterfaceBody": 253,
  "InterfaceKeyword?": 256,
  "InterfaceProperties": 254,
  "InterfaceProperty": 255,
  "Interpolation": 222,
  "Interpolations": 221,
  "Invocation": 175,
  "JointExpression": 184,
  "LET": 152,
  "LOOP": 108,
  "Label": 162,
  "Line": 160,
  "Literal": 217,
  "Logical": 174,
  "Loop": 201,
  "MATH_BIN": 44,
  "MathPostfix": 171,
  "MathPrefix": 170,
  "Multicheck": 165,
  "MulticheckClauses": 168,
  "MulticheckCombinations": 167,
  "Multicondition": 166,
  "NAN": 123,
  "NEW": 113,
  "NEWLINE": 26,
  "NOT": 54,
  "NULL": 122,
  "NUMBER": 124,
  "New": 207,
  "OR": 69,
  "OTHERWISE": 111,
  "OUDENT": 157,
  "OUTDENT": 39,
  "Object": 212,
  "Operation": 164,
  "Operator": 172,
  "OptComma": 179,
  "OptDefault": 278,
  "OptVoids": 249,
  "PARAM_END": 31,
  "PARAM_START": 30,
  "PLUS": 56,
  "POSTCASE": 91,
  "POSTFOR": 88,
  "POSTIF": 99,
  "POSTUNLESS": 100,
  "POSTUNTIL": 107,
  "POSTWHILE": 106,
  "PROPERTY": 114,
  "Param": 234,
  "ParamArray": 243,
  "ParamArrayArg": 247,
  "ParamArrayList": 245,
  "ParamAssignable": 239,
  "ParamIdentifier": 241,
  "ParamList": 233,
  "ParamObject": 211,
  "ParamPropList": 214,
  "ParamPropObj": 216,
  "Params": 232,
  "Parenthetical": 210,
  "PropList": 213,
  "PropObj": 215,
  "READONLY": 148,
  "REGEX": 130,
  "REGEX_END": 132,
  "REGEX_START": 131,
  "RETURN": 154,
  "Regex": 223,
  "RegexInterpolation": 226,
  "RegexInterpolations": 225,
  "RegexWithInterpolations": 224,
  "Return": 274,
  "Root": 158,
  "SET": 138,
  "STATIC": 136,
  "STRING": 125,
  "STRING_END": 127,
  "STRING_START": 126,
  "SUCH": 112,
  "SUPER": 73,
  "SWITCH": 89,
  "SYMBOL_EXISTS": 42,
  "Statement": 251,
  "String": 219,
  "StringWithInterpolations": 220,
  "Super": 208,
  "Switch": 187,
  "TAG": 150,
  "THEN": 32,
  "THIS": 117,
  "THROW": 146,
  "TRY": 101,
  "TYPE": 149,
  "TYPEOF": 36,
  "This": 209,
  "Try": 196,
  "TryBlock": 195,
  "Type": 258,
  "TypeArgument": 264,
  "TypeArguments": 263,
  "TypeArguments?": 231,
  "TypeArray": 268,
  "TypeArrayItems": 269,
  "TypeDeclaration": 259,
  "TypeObjProp": 267,
  "TypeObjProps": 266,
  "TypeObject": 265,
  "TypeSentence": 260,
  "TypeValue": 261,
  "TypeWithArguments": 262,
  "UNDEFINED": 119,
  "UNLESS": 109,
  "UNTIL": 105,
  "VAR": 151,
  "Value": 206,
  "Voids": 250,
  "WHEN": 84,
  "WHETHER": 35,
  "WHILE": 104,
  "WHILST": 85,
  "WITH": 80,
  "WITHIN": 29,
  "When": 191,
  "While": 199,
  "WhileUntil": 200,
  "YIELD": 40,
  "[": 24,
  "]": 25,
  "^": 10,
  "error": 2,
  "{": 16,
  "{{": 81,
  "|": 13,
  "||": 70,
  "}": 17,
  "}}": 82,
  "~": 6,
  "~~": 53
},
terminals_: {
  1: "EOF",
  2: "error",
  3: "@",
  4: "+",
  5: "-",
  6: "~",
  7: "!",
  8: "*",
  9: "%",
  10: "^",
  11: ">",
  12: "<",
  13: "|",
  14: "&",
  15: ",",
  16: "{",
  17: "}",
  18: ";",
  19: "?",
  20: ":",
  21: "(",
  22: ")",
  23: ".",
  24: "[",
  25: "]",
  26: "NEWLINE",
  27: "::",
  28: "FUNC_DIRECTIVE",
  29: "WITHIN",
  30: "PARAM_START",
  31: "PARAM_END",
  32: "THEN",
  33: "ASYNC",
  34: "DO",
  35: "WHETHER",
  36: "TYPEOF",
  37: "AWAIT",
  38: "INDENT",
  39: "OUTDENT",
  40: "YIELD",
  41: "EXISTS",
  42: "SYMBOL_EXISTS",
  43: "INCLUDES",
  44: "MATH_BIN",
  45: "CHAIN",
  46: "EITHER",
  47: "IS",
  48: "ISNT",
  49: "EITHER_OR",
  50: "COMPOUND_AND",
  51: "++",
  52: "--",
  53: "~~",
  54: "NOT",
  55: "**",
  56: "PLUS",
  57: "DIVISION",
  58: "<<",
  59: ">>",
  60: ">>>",
  61: "===",
  62: "!==",
  63: "==",
  64: "!=",
  65: ">=",
  66: "<=",
  67: "INSTANCEOF",
  68: "AND",
  69: "OR",
  70: "||",
  71: "&&",
  72: "??",
  73: "SUPER",
  74: "FUNC_EXISTS",
  75: "CALL_START",
  76: "CALL_END",
  77: "...",
  78: "CLASS",
  79: "EXTENDS",
  80: "WITH",
  81: "{{",
  82: "}}",
  83: "FOR",
  84: "WHEN",
  85: "WHILST",
  86: "FOR_OF",
  87: "FOR_IN",
  88: "POSTFOR",
  89: "SWITCH",
  90: "DEFAULT",
  91: "POSTCASE",
  92: "BREAK",
  93: "COMPOUND_OR",
  94: "CASE",
  95: "IF",
  96: "FOR_FROM",
  97: "FOR_AT",
  98: "FOR_AS",
  99: "POSTIF",
  100: "POSTUNLESS",
  101: "TRY",
  102: "FINALLY",
  103: "CATCH",
  104: "WHILE",
  105: "UNTIL",
  106: "POSTWHILE",
  107: "POSTUNTIL",
  108: "LOOP",
  109: "UNLESS",
  110: "ELSE",
  111: "OTHERWISE",
  112: "SUCH",
  113: "NEW",
  114: "PROPERTY",
  115: "INDEX_START",
  116: "INDEX_END",
  117: "THIS",
  118: "DEFAULTS",
  119: "UNDEFINED",
  120: "INFINITY",
  121: "BOOL",
  122: "NULL",
  123: "NAN",
  124: "NUMBER",
  125: "STRING",
  126: "STRING_START",
  127: "STRING_END",
  128: "INTERPOLATION_START",
  129: "INTERPOLATION_END",
  130: "REGEX",
  131: "REGEX_START",
  132: "REGEX_END",
  133: "FUNCTION",
  134: "<(",
  135: ")>",
  136: "STATIC",
  137: "GET",
  138: "SET",
  139: "AS",
  140: "AT",
  141: "FROM",
  142: "ARGUMENT",
  143: "IN",
  144: "IDENTIFIER",
  145: "CONTINUE",
  146: "THROW",
  147: "INTERFACE",
  148: "READONLY",
  149: "TYPE",
  150: "TAG",
  151: "VAR",
  152: "LET",
  153: "CONST",
  154: "RETURN",
  155: "IMPORT",
  156: "EXPORT",
  157: "OUDENT"
},
TERROR: 2,
    EOF: 1,

    // internals: defined here so the object *structure* doesn't get modified by parse() et al,
    // thus helping JIT compilers like Chrome V8.
    originalQuoteName: null,
    originalParseError: null,
    cleanupAfterParse: null,
    constructParseErrorInfo: null,
    yyMergeLocationInfo: null,



    __error_infos: [],              // INTERNAL USE ONLY: the set of parseErrorInfo objects created since the last cleanup
    __error_recovery_infos: [],     // INTERNAL USE ONLY: the set of parseErrorInfo objects created since the last cleanup

    // APIs which will be set up depending on user action code analysis:
    //yyRecovering: 0,
    //yyErrOk: 0,
    //yyClearIn: 0,

    // Helper APIs
    // -----------

    // Helper function which can be overridden by user code later on: put suitable quotes around
    // literal IDs in a description string.
    quoteName: function parser_quoteName(id_str) {
        return '"' + id_str + '"';
    },

    // Return the name of the given symbol (terminal or non-terminal) as a string, when available.
    //
    // Return NULL when the symbol is unknown to the parser.
    getSymbolName: function parser_getSymbolName(symbol) {
        if (this.terminals_[symbol]) {
            return this.terminals_[symbol];
        }

        // Otherwise... this might refer to a RULE token i.e. a non-terminal: see if we can dig that one up.
        //
        // An example of this may be where a rule's action code contains a call like this:
        //
        //      parser.getSymbolName(#$)
        //
        // to obtain a human-readable name of the current grammar rule.
        var s = this.symbols_;
        for (var key in s) {
            if (s[key] === symbol) {
                return key;
            }
        }
        return null;
    },

    // Return a more-or-less human-readable description of the given symbol, when available,
    // or the symbol itself, serving as its own 'description' for lack of something better to serve up.
    //
    // Return NULL when the symbol is unknown to the parser.
    describeSymbol: function parser_describeSymbol(symbol) {
        if (symbol !== this.EOF && this.terminal_descriptions_ && this.terminal_descriptions_[symbol]) {
            return this.terminal_descriptions_[symbol];
        }
        else if (symbol === this.EOF) {
            return 'end of input';
        }
        var id = this.getSymbolName(symbol);
        if (id) {
            return this.quoteName(id);
        }
        return null;
    },

    // Produce a (more or less) human-readable list of expected tokens at the point of failure.
    //
    // The produced list may contain token or token set descriptions instead of the tokens
    // themselves to help turning this output into something that easier to read by humans
    // unless `do_not_describe` parameter is set, in which case a list of the raw, *numeric*,
    // expected terminals and nonterminals is produced.
    //
    // The returned list (array) will not contain any duplicate entries.
    collect_expected_token_set: function parser_collect_expected_token_set(state, do_not_describe) {
        var TERROR = this.TERROR;
        var tokenset = [];
        var check = {};
        // Has this (error?) state been outfitted with a custom expectations description text for human consumption?
        // If so, use that one instead of the less palatable token set.
        if (!do_not_describe && this.state_descriptions_ && this.state_descriptions_[state]) {
            return [
                this.state_descriptions_[state]
            ];
        }
        for (var p in this.table[state]) {
            p = +p;
            if (p !== TERROR) {
                var d = do_not_describe ? p : this.describeSymbol(p);
                if (d && !check[d]) {
                    tokenset.push(d);
                    check[d] = true;        // Mark this token description as already mentioned to prevent outputting duplicate entries.
                }
            }
        }
        return tokenset;
    },
productions_: bp({
  pop: u([
  158,
  158,
  s,
  [159, 3],
  160,
  160,
  s,
  [161, 11],
  s,
  [162, 3],
  s,
  [163, 15],
  s,
  [164, 21],
  165,
  166,
  167,
  167,
  168,
  168,
  s,
  [169, 3],
  s,
  [170, 8],
  171,
  171,
  s,
  [172, 11],
  s,
  [173, 11],
  s,
  [174, 7],
  s,
  [175, 7],
  s,
  [176, 3],
  s,
  [177, 4],
  s,
  [178, 3],
  179,
  179,
  s,
  [180, 11],
  s,
  [181, 3],
  s,
  [182, 6],
  183,
  183,
  184,
  184,
  s,
  [185, 22],
  186,
  186,
  s,
  [187, 4],
  188,
  188,
  s,
  [189, 10],
  s,
  [190, 3],
  s,
  [191, 3],
  s,
  [192, 3],
  s,
  [193, 9],
  194,
  194,
  s,
  [195, 3],
  196,
  196,
  197,
  197,
  s,
  [198, 5],
  s,
  [199, 7],
  s,
  [200, 4],
  201,
  201,
  s,
  [202, 4],
  s,
  [203, 8],
  204,
  204,
  s,
  [205, 3],
  s,
  [206, 9],
  207,
  208,
  208,
  209,
  s,
  [210, 3],
  211,
  211,
  s,
  [212, 3],
  s,
  [213, 4],
  s,
  [214, 5],
  s,
  [215, 17],
  s,
  [216, 7],
  s,
  [217, 7],
  218,
  218,
  219,
  219,
  220,
  221,
  221,
  222,
  222,
  223,
  223,
  224,
  225,
  225,
  226,
  226,
  s,
  [227, 15],
  s,
  [228, 3],
  s,
  [229, 7],
  s,
  [230, 9],
  s,
  [231, 3],
  232,
  232,
  s,
  [233, 4],
  234,
  235,
  s,
  [236, 4],
  s,
  [237, 3],
  s,
  [238, 6],
  s,
  [239, 5],
  240,
  s,
  [241, 9],
  242,
  242,
  243,
  243,
  s,
  [244, 3],
  s,
  [245, 3],
  s,
  [246, 4],
  247,
  247,
  s,
  [248, 4],
  249,
  249,
  s,
  [250, 3],
  s,
  [251, 12],
  252,
  252,
  s,
  [253, 3],
  s,
  [254, 4],
  s,
  [255, 3],
  s,
  [256, 3],
  257,
  257,
  s,
  [258, 3],
  s,
  [259, 3],
  s,
  [260, 7],
  s,
  [261, 6],
  s,
  [262, 4],
  s,
  [263, 4],
  s,
  [264, 3],
  265,
  265,
  s,
  [266, 4],
  s,
  [267, 5],
  268,
  268,
  s,
  [269, 4],
  270,
  270,
  s,
  [271, 3],
  s,
  [272, 4],
  273,
  273,
  s,
  [274, 4],
  s,
  [275, 8],
  276,
  s,
  [277, 8],
  s,
  [278, 3],
  s,
  [279, 3],
  280,
  280,
  s,
  [281, 3],
  s,
  [282, 6],
  283,
  283,
  s,
  [284, 3],
  s,
  [285, 6]
]),
  rule: u([
  0,
  1,
  3,
  2,
  s,
  [1, 14],
  s,
  [3, 3],
  2,
  5,
  5,
  4,
  5,
  4,
  6,
  5,
  6,
  c,
  [6, 3],
  5,
  s,
  [2, 4],
  3,
  s,
  [2, 5],
  4,
  2,
  4,
  c,
  [11, 3],
  c,
  [32, 4],
  c,
  [37, 3],
  c,
  [23, 5],
  1,
  4,
  1,
  c,
  [62, 15],
  s,
  [1, 25],
  c,
  [58, 4],
  c,
  [73, 4],
  4,
  6,
  1,
  3,
  c,
  [4, 3],
  2,
  2,
  c,
  [122, 3],
  4,
  5,
  c,
  [11, 3],
  7,
  c,
  [109, 3],
  6,
  0,
  2,
  c,
  [18, 3],
  4,
  3,
  5,
  3,
  c,
  [129, 4],
  7,
  8,
  8,
  c,
  [3, 3],
  5,
  5,
  s,
  [6, 4],
  c,
  [11, 3],
  9,
  9,
  c,
  [13, 4],
  7,
  2,
  1,
  5,
  4,
  7,
  c,
  [61, 3],
  c,
  [71, 3],
  c,
  [126, 5],
  c,
  [43, 3],
  c,
  [8, 5],
  c,
  [93, 5],
  5,
  3,
  7,
  s,
  [3, 4],
  1,
  3,
  1,
  c,
  [172, 7],
  2,
  3,
  s,
  [4, 4],
  5,
  3,
  3,
  4,
  c,
  [83, 4],
  c,
  [93, 3],
  c,
  [19, 4],
  c,
  [20, 3],
  c,
  [209, 3],
  6,
  6,
  c,
  [154, 15],
  3,
  4,
  c,
  [74, 3],
  5,
  c,
  [56, 3],
  4,
  5,
  c,
  [148, 4],
  c,
  [153, 5],
  c,
  [18, 5],
  3,
  c,
  [119, 3],
  5,
  c,
  [55, 3],
  c,
  [190, 5],
  2,
  c,
  [38, 4],
  c,
  [77, 5],
  c,
  [297, 8],
  c,
  [58, 3],
  c,
  [7, 9],
  c,
  [93, 4],
  3,
  6,
  4,
  7,
  2,
  5,
  6,
  c,
  [318, 3],
  c,
  [206, 4],
  c,
  [154, 6],
  c,
  [115, 3],
  c,
  [177, 6],
  0,
  3,
  c,
  [74, 3],
  c,
  [251, 5],
  1,
  3,
  5,
  c,
  [149, 6],
  c,
  [124, 5],
  c,
  [65, 4],
  c,
  [97, 6],
  c,
  [23, 3],
  c,
  [335, 3],
  c,
  [104, 3],
  c,
  [292, 6],
  1,
  c,
  [79, 3],
  c,
  [71, 4],
  1,
  c,
  [298, 3],
  c,
  [40, 4],
  c,
  [9, 3],
  c,
  [50, 5],
  4,
  1,
  1,
  4,
  6,
  2,
  3,
  c,
  [171, 5],
  6,
  3,
  4,
  c,
  [29, 3],
  0,
  c,
  [21, 3],
  c,
  [89, 3],
  c,
  [176, 5],
  c,
  [67, 3],
  s,
  [1, 6],
  c,
  [347, 4],
  c,
  [201, 6],
  c,
  [112, 5],
  c,
  [47, 5],
  c,
  [440, 3],
  5,
  1,
  c,
  [277, 3],
  c,
  [68, 4],
  c,
  [155, 4],
  5,
  c,
  [80, 5],
  4,
  5,
  s,
  [7, 3],
  9,
  c,
  [359, 3],
  c,
  [71, 4],
  5,
  c,
  [127, 4],
  0,
  c,
  [170, 4],
  5,
  c,
  [52, 5],
  c,
  [285, 6],
  c,
  [46, 5],
  c,
  [11, 3],
  c,
  [10, 3]
])
}),
performAction: function parser__PerformAction(yyloc, yystate /* action[1] */, yysp, yyvstack, yylstack) {

          /* this == yyval */

          // the JS engine itself can go and remove these statements when `yy` turns out to be unused in any action code!
          var yy = this.yy;
          var yyparser = yy.parser;
          var yylexer = yy.lexer;

          

          switch (yystate) {
case 0:
    /*! Production::    $accept : Root $end */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,-,-,LT,LA,-,-):
    this.$ = yyvstack[yysp - 1];
    this._$ = yylstack[yysp - 1];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,-,-,LT,LA,-,-)
    break;

case 1:
    /*! Production::    Root : %epsilon */

    // default action (generated by JISON mode classic/merge :: 0,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(null, null, null, null, true);
    // END of default action (generated by JISON mode classic/merge :: 0,VT,VA,VU,-,LT,LA,-,-)
    
    
    return this.$ = Object.assign(new yy["Root"]("", ...['EMPTY']), { rule: "", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["", yylstack[yysp]])
    break;

case 2:
    /*! Production::    Root : Body */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    return this.$ = new yy["Root"]("Body", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Body", yylstack[yysp - 1]])
    break;

case 3:
    /*! Production::    Body : Body NEWLINE Line */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,-,-,LT,LA,-,-):
    this.$ = yyvstack[yysp - 2];
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,-,-,LT,LA,-,-)
    
    
    (yyvstack[yysp - 2][1] = [...yyvstack[yysp - 2][1], Object.assign(yyvstack[yysp], { lineCount: yyvstack[yysp - 1] })]) && Object.assign(yyvstack[yysp - 2], { loc: { first_line: yylstack[yysp - 2].first_line, last_line: yylstack[yysp].last_line, first_column: yylstack[yysp - 2].first_column, last_column: yylstack[yysp].last_column } })
    break;

case 4:
    /*! Production::    Body : Body NEWLINE */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(yyvstack[yysp - 1][1][yyvstack[yysp - 1][1].length - 1], { lineCount: yyvstack[yysp] }) && Object.assign(yyvstack[yysp - 1], { loc: { first_line: yylstack[yysp - 1].first_line, last_line: yylstack[yysp].last_line, first_column: yylstack[yysp - 1].first_column, last_column: yylstack[yysp].last_column } })
    break;

case 5:
    /*! Production::    Body : Line */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Body"]("Line", ...[[yyvstack[yysp]]]), { rule: "Line", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Line", yylstack[yysp]])
    break;

case 6:
    /*! Production::    Line : Expression */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Line"]("Expression", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Expression", yylstack[yysp - 1]])
    break;

case 7:
    /*! Production::    Line : Statement */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Line"]("Statement", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Statement", yylstack[yysp - 1]])
    break;

case 8:
    /*! Production::    Expression : Value */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Expression"]("Value", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Value", yylstack[yysp - 1]])
    break;

case 9:
    /*! Production::    Expression : Operation */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Expression"]("Operation", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Operation", yylstack[yysp - 1]])
    break;

case 10:
    /*! Production::    Expression : While */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Expression"]("While", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["While", yylstack[yysp - 1]])
    break;

case 11:
    /*! Production::    Expression : For */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Expression"]("For", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["For", yylstack[yysp - 1]])
    break;

case 12:
    /*! Production::    Expression : Switch */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Expression"]("Switch", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Switch", yylstack[yysp - 1]])
    break;

case 13:
    /*! Production::    Expression : TryBlock */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Expression"]("TryBlock", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["TryBlock", yylstack[yysp - 1]])
    break;

case 14:
    /*! Production::    Expression : Assign */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Expression"]("Assign", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Assign", yylstack[yysp - 1]])
    break;

case 15:
    /*! Production::    Expression : If */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Expression"]("If", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["If", yylstack[yysp - 1]])
    break;

case 16:
    /*! Production::    Expression : Class */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Expression"]("Class", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Class", yylstack[yysp - 1]])
    break;

case 17:
    /*! Production::    Expression : Label */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Expression"]("Label", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Label", yylstack[yysp - 1]])
    break;

case 18:
    /*! Production::    Expression : Code */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Expression"]("Code", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Code", yylstack[yysp - 1]])
    break;

case 19:
    /*! Production::    Label : Identifier "::" Expression */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Label"]("Identifier :: Expression", ...[yyvstack[yysp - 2], yy.Block.wrap(yyvstack[yysp])]), { rule: "Identifier :: Expression", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Identifier", yylstack[yysp - 2]], ["::", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 20:
    /*! Production::    Label : Identifier "::" Statement */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Label"]("Identifier :: Statement", ...[yyvstack[yysp - 2], yy.Block.wrap(yyvstack[yysp])]), { rule: "Identifier :: Statement", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Identifier", yylstack[yysp - 2]], ["::", yylstack[yysp - 1]], ["Statement", yylstack[yysp]])
    break;

case 21:
    /*! Production::    Label : Identifier "::" Block */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Label"]("Identifier :: Block", ...[yyvstack[yysp - 2], yyvstack[yysp]]), { rule: "Identifier :: Block", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Identifier", yylstack[yysp - 2]], ["::", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 22:
    /*! Production::    Code : FUNC_DIRECTIVE Expression */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Code"]("FUNC_DIRECTIVE Expression", ...[null, yyvstack[yysp - 1], yyvstack[yysp]]), { rule: "FUNC_DIRECTIVE Expression", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["FUNC_DIRECTIVE", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 23:
    /*! Production::    Code : WITHIN PARAM_START ParamList PARAM_END Block */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Code"]("WITHIN PARAM_START ParamList PARAM_END Block", ...[yyvstack[yysp - 2], '=>', yyvstack[yysp]]), { rule: "WITHIN PARAM_START ParamList PARAM_END Block", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["WITHIN", yylstack[yysp - 4]], ["PARAM_START", yylstack[yysp - 3]], ["ParamList", yylstack[yysp - 2]], ["PARAM_END", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 24:
    /*! Production::    Code : PARAM_START ParamList PARAM_END FUNC_DIRECTIVE Block */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Code"]("PARAM_START ParamList PARAM_END FUNC_DIRECTIVE Block", ...[yyvstack[yysp - 3], yyvstack[yysp - 1], yyvstack[yysp]]), { rule: "PARAM_START ParamList PARAM_END FUNC_DIRECTIVE Block", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["PARAM_START", yylstack[yysp - 4]], ["ParamList", yylstack[yysp - 3]], ["PARAM_END", yylstack[yysp - 2]], ["FUNC_DIRECTIVE", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 25:
    /*! Production::    Code : PARAM_START PARAM_END FUNC_DIRECTIVE Block */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Code"]("PARAM_START PARAM_END FUNC_DIRECTIVE Block", ...[null, yyvstack[yysp - 1], yyvstack[yysp]]), { rule: "PARAM_START PARAM_END FUNC_DIRECTIVE Block", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["PARAM_START", yylstack[yysp - 3]], ["PARAM_END", yylstack[yysp - 2]], ["FUNC_DIRECTIVE", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 26:
    /*! Production::    Code : PARAM_START ParamList PARAM_END FUNC_DIRECTIVE Expression */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Code"]("PARAM_START ParamList PARAM_END FUNC_DIRECTIVE Expression", ...[yyvstack[yysp - 3], yyvstack[yysp - 1], yyvstack[yysp]]), { rule: "PARAM_START ParamList PARAM_END FUNC_DIRECTIVE Expression", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["PARAM_START", yylstack[yysp - 4]], ["ParamList", yylstack[yysp - 3]], ["PARAM_END", yylstack[yysp - 2]], ["FUNC_DIRECTIVE", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 27:
    /*! Production::    Code : PARAM_START PARAM_END FUNC_DIRECTIVE Expression */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Code"]("PARAM_START PARAM_END FUNC_DIRECTIVE Expression", ...[null, yyvstack[yysp - 1], yyvstack[yysp]]), { rule: "PARAM_START PARAM_END FUNC_DIRECTIVE Expression", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["PARAM_START", yylstack[yysp - 3]], ["PARAM_END", yylstack[yysp - 2]], ["FUNC_DIRECTIVE", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 28:
    /*! Production::    Code : WITHIN PARAM_START ParamList PARAM_END THEN Block */

    // default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 5, yysp);
    // END of default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Code"]("WITHIN PARAM_START ParamList PARAM_END THEN Block", ...[yyvstack[yysp - 3], '=>', yyvstack[yysp - 1]]), { rule: "WITHIN PARAM_START ParamList PARAM_END THEN Block", loc: { first_line: yylstack[yysp - 5].first_line, first_column: yylstack[yysp - 5].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 5].src, type: yylstack[yysp - 5].type } }, {"first":1,"last":6,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["WITHIN", yylstack[yysp - 5]], ["PARAM_START", yylstack[yysp - 4]], ["ParamList", yylstack[yysp - 3]], ["PARAM_END", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 29:
    /*! Production::    Code : WITHIN PARAM_START ParamList PARAM_END Expression */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Code"]("WITHIN PARAM_START ParamList PARAM_END Expression", ...[yyvstack[yysp - 2], '=>', yyvstack[yysp]]), { rule: "WITHIN PARAM_START ParamList PARAM_END Expression", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["WITHIN", yylstack[yysp - 4]], ["PARAM_START", yylstack[yysp - 3]], ["ParamList", yylstack[yysp - 2]], ["PARAM_END", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 30:
    /*! Production::    Code : WITHIN PARAM_START ParamList PARAM_END THEN Expression */

    // default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 5, yysp);
    // END of default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Code"]("WITHIN PARAM_START ParamList PARAM_END THEN Expression", ...[yyvstack[yysp - 3], '=>', yyvstack[yysp]]), { rule: "WITHIN PARAM_START ParamList PARAM_END THEN Expression", loc: { first_line: yylstack[yysp - 5].first_line, first_column: yylstack[yysp - 5].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 5].src, type: yylstack[yysp - 5].type } }, {"first":1,"last":6,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["WITHIN", yylstack[yysp - 5]], ["PARAM_START", yylstack[yysp - 4]], ["ParamList", yylstack[yysp - 3]], ["PARAM_END", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 31:
    /*! Production::    Code : WITHIN PARAM_START PARAM_END Block */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Code"]("WITHIN PARAM_START PARAM_END Block", ...[null, '=>', yyvstack[yysp]]), { rule: "WITHIN PARAM_START PARAM_END Block", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["WITHIN", yylstack[yysp - 3]], ["PARAM_START", yylstack[yysp - 2]], ["PARAM_END", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 32:
    /*! Production::    Code : WITHIN PARAM_START PARAM_END THEN Block */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Code"]("WITHIN PARAM_START PARAM_END THEN Block", ...[null, '=>', yyvstack[yysp]]), { rule: "WITHIN PARAM_START PARAM_END THEN Block", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["WITHIN", yylstack[yysp - 4]], ["PARAM_START", yylstack[yysp - 3]], ["PARAM_END", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 33:
    /*! Production::    Code : WITHIN PARAM_START PARAM_END Expression */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Code"]("WITHIN PARAM_START PARAM_END Expression", ...[null, '=>', yyvstack[yysp]]), { rule: "WITHIN PARAM_START PARAM_END Expression", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["WITHIN", yylstack[yysp - 3]], ["PARAM_START", yylstack[yysp - 2]], ["PARAM_END", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 34:
    /*! Production::    Code : WITHIN PARAM_START PARAM_END THEN Expression */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Code"]("WITHIN PARAM_START PARAM_END THEN Expression", ...[null, '=>', yyvstack[yysp]]), { rule: "WITHIN PARAM_START PARAM_END THEN Expression", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["WITHIN", yylstack[yysp - 4]], ["PARAM_START", yylstack[yysp - 3]], ["PARAM_END", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 35:
    /*! Production::    Code : WITHIN Block */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Code"]("WITHIN Block", ...[null, '=>', yyvstack[yysp]]), { rule: "WITHIN Block", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["WITHIN", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 36:
    /*! Production::    Code : ASYNC Code */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Code"]("ASYNC Code", ...[...yyvstack[yysp].contents]), { rule: "ASYNC Code", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false,"async":true}, { generated: undefined }).setTokens(["ASYNC", yylstack[yysp - 1]], ["Code", yylstack[yysp]])
    break;

case 37:
    /*! Production::    Operation : MathPrefix Expression */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Operation"]("MathPrefix Expression", ...[yyvstack[yysp - 1], yyvstack[yysp]]), { rule: "MathPrefix Expression", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["MathPrefix", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 38:
    /*! Production::    Operation : Expression MathPostfix */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Operation"]("Expression MathPostfix", ...[yyvstack[yysp - 1], yyvstack[yysp]]), { rule: "Expression MathPostfix", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Expression", yylstack[yysp - 1]], ["MathPostfix", yylstack[yysp]])
    break;

case 39:
    /*! Production::    Operation : Expression Operator Expression */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Operation"]("Expression Operator Expression", ...[yyvstack[yysp - 2], yyvstack[yysp - 1], yyvstack[yysp]]), { rule: "Expression Operator Expression", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Expression", yylstack[yysp - 2]], ["Operator", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 40:
    /*! Production::    Operation : "@" Value */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Operation"]("@ Value", ...[yyvstack[yysp]]), { rule: "@ Value", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["@", yylstack[yysp - 1]], ["Value", yylstack[yysp]])
    break;

case 41:
    /*! Production::    Operation : DO Expression */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Operation"]("DO Expression", ...[yyvstack[yysp]]), { rule: "DO Expression", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["DO", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 42:
    /*! Production::    Operation : WHETHER Expression */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Operation"]("WHETHER Expression", ...[yyvstack[yysp]]), { rule: "WHETHER Expression", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["WHETHER", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 43:
    /*! Production::    Operation : TYPEOF Expression */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Operation"]("TYPEOF Expression", ...[yyvstack[yysp]]), { rule: "TYPEOF Expression", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["TYPEOF", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 44:
    /*! Production::    Operation : AWAIT Expression */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Operation"]("AWAIT Expression", ...[yyvstack[yysp]]), { rule: "AWAIT Expression", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["AWAIT", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 45:
    /*! Production::    Operation : AWAIT INDENT Expression OUTDENT */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Operation"]("AWAIT INDENT Expression OUTDENT", ...[yyvstack[yysp - 1]]), { rule: "AWAIT INDENT Expression OUTDENT", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["AWAIT", yylstack[yysp - 3]], ["INDENT", yylstack[yysp - 2]], ["Expression", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 46:
    /*! Production::    Operation : YIELD Expression */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Operation"]("YIELD Expression", ...[yyvstack[yysp]]), { rule: "YIELD Expression", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["YIELD", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 47:
    /*! Production::    Operation : YIELD INDENT Expression OUTDENT */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Operation"]("YIELD INDENT Expression OUTDENT", ...[yyvstack[yysp - 1]]), { rule: "YIELD INDENT Expression OUTDENT", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["YIELD", yylstack[yysp - 3]], ["INDENT", yylstack[yysp - 2]], ["Expression", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 48:
    /*! Production::    Operation : Expression EXISTS */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Operation"]("Expression EXISTS", ...[yyvstack[yysp - 1]]), { rule: "Expression EXISTS", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Expression", yylstack[yysp - 1]], ["EXISTS", yylstack[yysp]])
    break;

case 49:
    /*! Production::    Operation : Expression SYMBOL_EXISTS */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Operation"]("Expression SYMBOL_EXISTS", ...[yyvstack[yysp - 1]]), { rule: "Expression SYMBOL_EXISTS", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Expression", yylstack[yysp - 1]], ["SYMBOL_EXISTS", yylstack[yysp]])
    break;

case 50:
    /*! Production::    Operation : Expression Compare Expression */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Operation"]("Expression Compare Expression", ...[yyvstack[yysp - 2], yyvstack[yysp - 1], yyvstack[yysp]]), { rule: "Expression Compare Expression", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Expression", yylstack[yysp - 2]], ["Compare", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 51:
    /*! Production::    Operation : Expression Logical Expression */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Operation"]("Expression Logical Expression", ...[yyvstack[yysp - 2], yyvstack[yysp - 1], yyvstack[yysp]]), { rule: "Expression Logical Expression", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Expression", yylstack[yysp - 2]], ["Logical", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 52:
    /*! Production::    Operation : Expression INCLUDES Expression */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Operation"]("Expression INCLUDES Expression", ...[yyvstack[yysp - 2], yyvstack[yysp]]), { rule: "Expression INCLUDES Expression", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Expression", yylstack[yysp - 2]], ["INCLUDES", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 53:
    /*! Production::    Operation : Expression MATH_BIN Expression */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Operation"]("Expression MATH_BIN Expression", ...[yyvstack[yysp - 2], yyvstack[yysp - 1], yyvstack[yysp]]), { rule: "Expression MATH_BIN Expression", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Expression", yylstack[yysp - 2]], ["MATH_BIN", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 54:
    /*! Production::    Operation : Expression Multicheck */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Operation"]("Expression Multicheck", ...[yyvstack[yysp - 1], yyvstack[yysp].contents]), { rule: "Expression Multicheck", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Expression", yylstack[yysp - 1]], ["Multicheck", yylstack[yysp]])
    break;

case 55:
    /*! Production::    Operation : Multicondition */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Operation"]("Multicondition", ...[null, yyvstack[yysp].contents]), { rule: "Multicondition", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Multicondition", yylstack[yysp]])
    break;

case 56:
    /*! Production::    Operation : Expression CHAIN Expression */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Operation"]("Expression CHAIN Expression", ...[yyvstack[yysp - 2], yyvstack[yysp], /then\?|\?>/.test(yyvstack[yysp - 1].origin || '')]), { rule: "Expression CHAIN Expression", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Expression", yylstack[yysp - 2]], ["CHAIN", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 57:
    /*! Production::    Operation : Expression CHAIN Block */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Operation"]("Expression CHAIN Block", ...[yyvstack[yysp - 2], yyvstack[yysp], /then\?|\?>/.test(yyvstack[yysp - 1].origin || '')]), { rule: "Expression CHAIN Block", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Expression", yylstack[yysp - 2]], ["CHAIN", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 58:
    /*! Production::    Multicheck : MulticheckCombinations MulticheckClauses */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Multicheck"]("MulticheckCombinations MulticheckClauses", ...[yyvstack[yysp - 1].rule, yyvstack[yysp]]), { rule: "MulticheckCombinations MulticheckClauses", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["MulticheckCombinations", yylstack[yysp - 1]], ["MulticheckClauses", yylstack[yysp]])
    break;

case 59:
    /*! Production::    Multicondition : EITHER MulticheckClauses */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Multicondition"]("EITHER MulticheckClauses", ...[yyvstack[yysp - 1], yyvstack[yysp]]), { rule: "EITHER MulticheckClauses", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["EITHER", yylstack[yysp - 1]], ["MulticheckClauses", yylstack[yysp]])
    break;

case 60:
    /*! Production::    MulticheckCombinations : IS EITHER */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["MulticheckCombinations"]("IS EITHER", ...[yyvstack[yysp - 1]]).setLocation({ first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type }).setTokens(["IS", yylstack[yysp - 2]], ["EITHER", yylstack[yysp - 1]])
    break;

case 61:
    /*! Production::    MulticheckCombinations : ISNT EITHER */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["MulticheckCombinations"]("ISNT EITHER", ...[yyvstack[yysp - 1]]).setLocation({ first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type }).setTokens(["ISNT", yylstack[yysp - 2]], ["EITHER", yylstack[yysp - 1]])
    break;

case 62:
    /*! Production::    MulticheckClauses : MulticheckClauses EITHER_OR Clause */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["MulticheckClauses"]("MulticheckClauses EITHER_OR Clause", ...[...yyvstack[yysp - 2].contents, yyvstack[yysp]]), { rule: "MulticheckClauses EITHER_OR Clause", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["MulticheckClauses", yylstack[yysp - 2]], ["EITHER_OR", yylstack[yysp - 1]], ["Clause", yylstack[yysp]])
    break;

case 63:
    /*! Production::    MulticheckClauses : Clause */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["MulticheckClauses"]("Clause", ...[yyvstack[yysp]]), { rule: "Clause", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Clause", yylstack[yysp]])
    break;

case 64:
    /*! Production::    Clause : Clause COMPOUND_AND Compare Expression */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Clause"]("Clause COMPOUND_AND Compare Expression", ...[...yyvstack[yysp - 3].contents, [yyvstack[yysp], yyvstack[yysp - 1]]]), { rule: "Clause COMPOUND_AND Compare Expression", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Clause", yylstack[yysp - 3]], ["COMPOUND_AND", yylstack[yysp - 2]], ["Compare", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 65:
    /*! Production::    Clause : Expression */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Clause"]("Expression", ...[[yyvstack[yysp]]]), { rule: "Expression", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Expression", yylstack[yysp]])
    break;

case 66:
    /*! Production::    Clause : Compare Expression */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Clause"]("Compare Expression", ...[[yyvstack[yysp], yyvstack[yysp - 1]]]), { rule: "Compare Expression", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Compare", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 67:
    /*! Production::    MathPrefix : "++" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["MathPrefix"]("++", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["++", yylstack[yysp - 1]])
    break;

case 68:
    /*! Production::    MathPrefix : "--" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["MathPrefix"]("--", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["--", yylstack[yysp - 1]])
    break;

case 69:
    /*! Production::    MathPrefix : "+" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["MathPrefix"]("+", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["+", yylstack[yysp - 1]])
    break;

case 70:
    /*! Production::    MathPrefix : "-" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["MathPrefix"]("-", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["-", yylstack[yysp - 1]])
    break;

case 71:
    /*! Production::    MathPrefix : "~" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["MathPrefix"]("~", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["~", yylstack[yysp - 1]])
    break;

case 72:
    /*! Production::    MathPrefix : "~~" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["MathPrefix"]("~~", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["~~", yylstack[yysp - 1]])
    break;

case 73:
    /*! Production::    MathPrefix : NOT */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["MathPrefix"]("NOT", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["NOT", yylstack[yysp - 1]])
    break;

case 74:
    /*! Production::    MathPrefix : "!" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["MathPrefix"]("!", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["!", yylstack[yysp - 1]])
    break;

case 75:
    /*! Production::    MathPostfix : "++" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["MathPostfix"]("++", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["++", yylstack[yysp - 1]])
    break;

case 76:
    /*! Production::    MathPostfix : "--" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["MathPostfix"]("--", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["--", yylstack[yysp - 1]])
    break;

case 77:
    /*! Production::    Operator : "*" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Operator"]("*", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["*", yylstack[yysp - 1]])
    break;

case 78:
    /*! Production::    Operator : "**" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Operator"]("**", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["**", yylstack[yysp - 1]])
    break;

case 79:
    /*! Production::    Operator : "+" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Operator"]("+", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["+", yylstack[yysp - 1]])
    break;

case 80:
    /*! Production::    Operator : PLUS */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Operator"]("PLUS", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["PLUS", yylstack[yysp - 1]])
    break;

case 81:
    /*! Production::    Operator : "-" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Operator"]("-", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["-", yylstack[yysp - 1]])
    break;

case 82:
    /*! Production::    Operator : DIVISION */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Operator"]("DIVISION", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["DIVISION", yylstack[yysp - 1]])
    break;

case 83:
    /*! Production::    Operator : "%" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Operator"]("%", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["%", yylstack[yysp - 1]])
    break;

case 84:
    /*! Production::    Operator : "<<" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Operator"]("<<", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["<<", yylstack[yysp - 1]])
    break;

case 85:
    /*! Production::    Operator : ">>" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Operator"](">>", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens([">>", yylstack[yysp - 1]])
    break;

case 86:
    /*! Production::    Operator : ">>>" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Operator"](">>>", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens([">>>", yylstack[yysp - 1]])
    break;

case 87:
    /*! Production::    Operator : "^" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Operator"]("^", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["^", yylstack[yysp - 1]])
    break;

case 88:
    /*! Production::    Compare : IS */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Compare"]("IS", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["IS", yylstack[yysp - 1]])
    break;

case 89:
    /*! Production::    Compare : "===" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Compare"]("===", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["===", yylstack[yysp - 1]])
    break;

case 90:
    /*! Production::    Compare : ISNT */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Compare"]("ISNT", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["ISNT", yylstack[yysp - 1]])
    break;

case 91:
    /*! Production::    Compare : "!==" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Compare"]("!==", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["!==", yylstack[yysp - 1]])
    break;

case 92:
    /*! Production::    Compare : "==" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Compare"]("==", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["==", yylstack[yysp - 1]])
    break;

case 93:
    /*! Production::    Compare : "!=" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Compare"]("!=", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["!=", yylstack[yysp - 1]])
    break;

case 94:
    /*! Production::    Compare : ">=" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Compare"](">=", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens([">=", yylstack[yysp - 1]])
    break;

case 95:
    /*! Production::    Compare : "<=" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Compare"]("<=", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["<=", yylstack[yysp - 1]])
    break;

case 96:
    /*! Production::    Compare : ">" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Compare"](">", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens([">", yylstack[yysp - 1]])
    break;

case 97:
    /*! Production::    Compare : "<" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Compare"]("<", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["<", yylstack[yysp - 1]])
    break;

case 98:
    /*! Production::    Compare : INSTANCEOF */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Compare"]("INSTANCEOF", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["INSTANCEOF", yylstack[yysp - 1]])
    break;

case 99:
    /*! Production::    Logical : AND */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Logical"]("AND", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["AND", yylstack[yysp - 1]])
    break;

case 100:
    /*! Production::    Logical : OR */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Logical"]("OR", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["OR", yylstack[yysp - 1]])
    break;

case 101:
    /*! Production::    Logical : "||" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Logical"]("||", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["||", yylstack[yysp - 1]])
    break;

case 102:
    /*! Production::    Logical : "&&" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Logical"]("&&", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["&&", yylstack[yysp - 1]])
    break;

case 103:
    /*! Production::    Logical : "|" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Logical"]("|", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["|", yylstack[yysp - 1]])
    break;

case 104:
    /*! Production::    Logical : "&" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Logical"]("&", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["&", yylstack[yysp - 1]])
    break;

case 105:
    /*! Production::    Logical : "??" */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Logical"]("??", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["??", yylstack[yysp - 1]])
    break;

case 106:
    /*! Production::    Invocation : Value Arguments */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Invocation"]("Value Arguments", ...[yyvstack[yysp - 1], yyvstack[yysp]]), { rule: "Value Arguments", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Value", yylstack[yysp - 1]], ["Arguments", yylstack[yysp]])
    break;

case 107:
    /*! Production::    Invocation : SUPER Arguments */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Invocation"]("SUPER Arguments", ...[yyvstack[yysp - 1], yyvstack[yysp]]), { rule: "SUPER Arguments", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["SUPER", yylstack[yysp - 1]], ["Arguments", yylstack[yysp]])
    break;

case 108:
    /*! Production::    Invocation : Value FUNC_EXISTS Arguments */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Invocation"]("Value FUNC_EXISTS Arguments", ...[yyvstack[yysp - 2], yyvstack[yysp]]), { rule: "Value FUNC_EXISTS Arguments", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false,"soak":true}, { generated: undefined }).setTokens(["Value", yylstack[yysp - 2]], ["FUNC_EXISTS", yylstack[yysp - 1]], ["Arguments", yylstack[yysp]])
    break;

case 109:
    /*! Production::    Invocation : SUPER FUNC_EXISTS Arguments */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Invocation"]("SUPER FUNC_EXISTS Arguments", ...[yyvstack[yysp - 2], yyvstack[yysp]]), { rule: "SUPER FUNC_EXISTS Arguments", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false,"soak":true}, { generated: undefined }).setTokens(["SUPER", yylstack[yysp - 2]], ["FUNC_EXISTS", yylstack[yysp - 1]], ["Arguments", yylstack[yysp]])
    break;

case 110:
    /*! Production::    Invocation : "@" SUPER */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Invocation"]("@ SUPER", ...[yyvstack[yysp], new yy.Arguments(null)]), { rule: "@ SUPER", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["@", yylstack[yysp - 1]], ["SUPER", yylstack[yysp]])
    break;

case 111:
    /*! Production::    Invocation : Value String */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Invocation"]("Value String", ...[yyvstack[yysp - 1], yyvstack[yysp]]), { rule: "Value String", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false,"templ":true}, { generated: undefined }).setTokens(["Value", yylstack[yysp - 1]], ["String", yylstack[yysp]])
    break;

case 112:
    /*! Production::    Invocation : Value FUNC_EXISTS String */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Invocation"]("Value FUNC_EXISTS String", ...[yyvstack[yysp - 2], yyvstack[yysp]]), { rule: "Value FUNC_EXISTS String", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false,"templ":true,"soak":true}, { generated: undefined }).setTokens(["Value", yylstack[yysp - 2]], ["FUNC_EXISTS", yylstack[yysp - 1]], ["String", yylstack[yysp]])
    break;

case 113:
    /*! Production::    Arguments : CALL_START CALL_END */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Arguments"]("CALL_START CALL_END", ...[/* */]), { rule: "CALL_START CALL_END", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["CALL_START", yylstack[yysp - 1]], ["CALL_END", yylstack[yysp]])
    break;

case 114:
    /*! Production::    Arguments : CALL_START ArgList OptComma CALL_END */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Arguments"]("CALL_START ArgList OptComma CALL_END", ...[yyvstack[yysp - 2]]), { rule: "CALL_START ArgList OptComma CALL_END", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["CALL_START", yylstack[yysp - 3]], ["ArgList", yylstack[yysp - 2]], ["OptComma", yylstack[yysp - 1]], ["CALL_END", yylstack[yysp]])
    break;

case 115:
    /*! Production::    Arguments : CALL_START INDENT ArgList OptComma OUTDENT CALL_END */

    // default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 5, yysp);
    // END of default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Arguments"]("CALL_START INDENT ArgList OptComma OUTDENT CALL_END", ...[yyvstack[yysp - 3]]), { rule: "CALL_START INDENT ArgList OptComma OUTDENT CALL_END", loc: { first_line: yylstack[yysp - 5].first_line, first_column: yylstack[yysp - 5].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 5].src, type: yylstack[yysp - 5].type } }, {"first":1,"last":6,"typeOf":1,"checkGenerated":false,"indented":true}, { generated: undefined }).setTokens(["CALL_START", yylstack[yysp - 5]], ["INDENT", yylstack[yysp - 4]], ["ArgList", yylstack[yysp - 3]], ["OptComma", yylstack[yysp - 2]], ["OUTDENT", yylstack[yysp - 1]], ["CALL_END", yylstack[yysp]])
    break;

case 116:
    /*! Production::    ArgList : Arg */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["ArgList"]("Arg", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Arg", yylstack[yysp - 1]])
    break;

case 117:
    /*! Production::    ArgList : ArgList "," Arg */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ArgList"]("ArgList , Arg", ...[...yyvstack[yysp - 2].contents, yyvstack[yysp]]), { rule: "ArgList , Arg", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["ArgList", yylstack[yysp - 2]], [",", yylstack[yysp - 1]], ["Arg", yylstack[yysp]])
    break;

case 118:
    /*! Production::    ArgList : ArgList OptComma NEWLINE Arg */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ArgList"]("ArgList OptComma NEWLINE Arg", ...[...yyvstack[yysp - 3].contents, yylstack[yysp - 1].generated, yyvstack[yysp]]), { rule: "ArgList OptComma NEWLINE Arg", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["ArgList", yylstack[yysp - 3]], ["OptComma", yylstack[yysp - 2]], ["NEWLINE", yylstack[yysp - 1]], ["Arg", yylstack[yysp]])
    break;

case 119:
    /*! Production::    ArgList : ArgList OptComma INDENT ArgList OptComma OUTDENT */

    // default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 5, yysp);
    // END of default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ArgList"]("ArgList OptComma INDENT ArgList OptComma OUTDENT", ...[...yyvstack[yysp - 5].contents, false, ...yyvstack[yysp - 2].contents]), { rule: "ArgList OptComma INDENT ArgList OptComma OUTDENT", loc: { first_line: yylstack[yysp - 5].first_line, first_column: yylstack[yysp - 5].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 5].src, type: yylstack[yysp - 5].type } }, {"first":1,"last":6,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["ArgList", yylstack[yysp - 5]], ["OptComma", yylstack[yysp - 4]], ["INDENT", yylstack[yysp - 3]], ["ArgList", yylstack[yysp - 2]], ["OptComma", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 120:
    /*! Production::    Arg : Expression */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Arg"]("Expression", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Expression", yylstack[yysp - 1]])
    break;

case 121:
    /*! Production::    Arg : "..." Expression */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Arg"]("... Expression", ...[yyvstack[yysp]]), { rule: "... Expression", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false,"expansion":true}, { generated: undefined }).setTokens(["...", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 122:
    /*! Production::    Arg : Expression "..." */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Arg"]("Expression ...", ...[yyvstack[yysp - 1]]), { rule: "Expression ...", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false,"expansion":true}, { generated: undefined }).setTokens(["Expression", yylstack[yysp - 1]], ["...", yylstack[yysp]])
    break;

case 123:
    /*! Production::    OptComma : %epsilon */

    // default action (generated by JISON mode classic/merge :: 0,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(null, null, null, null, true);
    // END of default action (generated by JISON mode classic/merge :: 0,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["OptComma"]("", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["", yylstack[yysp - 1]])
    break;

case 124:
    /*! Production::    OptComma : "," */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["OptComma"](",", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens([",", yylstack[yysp - 1]])
    break;

case 125:
    /*! Production::    Class : CLASS Identifier ClassConstructor? */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Class"]("CLASS Identifier ClassConstructor?", ...[yyvstack[yysp - 1], false, false, yylstack[yysp - 2].origin === "class*", yyvstack[yysp].unwrap]), { rule: "CLASS Identifier ClassConstructor?", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp - 1].last_line, last_column: yylstack[yysp - 1].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["CLASS", yylstack[yysp - 2]], ["Identifier", yylstack[yysp - 1]], ["ClassConstructor?", yylstack[yysp]])
    break;

case 126:
    /*! Production::    Class : CLASS Identifier ClassConstructor? Block */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Class"]("CLASS Identifier ClassConstructor? Block", ...[yyvstack[yysp - 2], false, yyvstack[yysp][1], yylstack[yysp - 3].origin === "class*", yyvstack[yysp - 1].unwrap]), { rule: "CLASS Identifier ClassConstructor? Block", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["CLASS", yylstack[yysp - 3]], ["Identifier", yylstack[yysp - 2]], ["ClassConstructor?", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 127:
    /*! Production::    Class : CLASS Identifier ClassConstructor? THEN Block */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Class"]("CLASS Identifier ClassConstructor? THEN Block", ...[yyvstack[yysp - 3], false, yyvstack[yysp][1], yylstack[yysp - 4].origin === "class*", yyvstack[yysp - 2].unwrap]), { rule: "CLASS Identifier ClassConstructor? THEN Block", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["CLASS", yylstack[yysp - 4]], ["Identifier", yylstack[yysp - 3]], ["ClassConstructor?", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 128:
    /*! Production::    Class : CLASS ClassConstructor? Block */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Class"]("CLASS ClassConstructor? Block", ...[undefined, false, yyvstack[yysp][1], yylstack[yysp - 2].origin === "class*", yyvstack[yysp - 1].unwrap]), { rule: "CLASS ClassConstructor? Block", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["CLASS", yylstack[yysp - 2]], ["ClassConstructor?", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 129:
    /*! Production::    Class : CLASS ClassConstructor? THEN Block */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Class"]("CLASS ClassConstructor? THEN Block", ...[undefined, false, yyvstack[yysp][1], yylstack[yysp - 3].origin === "class*", yyvstack[yysp - 2].unwrap]), { rule: "CLASS ClassConstructor? THEN Block", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["CLASS", yylstack[yysp - 3]], ["ClassConstructor?", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 130:
    /*! Production::    Class : CLASS Identifier ClassConstructor? EXTENDS Value Block */

    // default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 5, yysp);
    // END of default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Class"]("CLASS Identifier ClassConstructor? EXTENDS Value Block", ...[yyvstack[yysp - 4], yyvstack[yysp - 1], yyvstack[yysp][1], yylstack[yysp - 5].origin === "class*", yyvstack[yysp - 3].unwrap]), { rule: "CLASS Identifier ClassConstructor? EXTENDS Value Block", loc: { first_line: yylstack[yysp - 5].first_line, first_column: yylstack[yysp - 5].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 5].src, type: yylstack[yysp - 5].type } }, {"first":1,"last":6,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["CLASS", yylstack[yysp - 5]], ["Identifier", yylstack[yysp - 4]], ["ClassConstructor?", yylstack[yysp - 3]], ["EXTENDS", yylstack[yysp - 2]], ["Value", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 131:
    /*! Production::    Class : CLASS Identifier ClassConstructor? EXTENDS Value THEN Block */

    // default action (generated by JISON mode classic/merge :: 7,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 6, yysp);
    // END of default action (generated by JISON mode classic/merge :: 7,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Class"]("CLASS Identifier ClassConstructor? EXTENDS Value THEN Block", ...[yyvstack[yysp - 5], yyvstack[yysp - 2], yyvstack[yysp][1], yylstack[yysp - 6].origin === "class*", yyvstack[yysp - 4].unwrap]), { rule: "CLASS Identifier ClassConstructor? EXTENDS Value THEN Block", loc: { first_line: yylstack[yysp - 6].first_line, first_column: yylstack[yysp - 6].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 6].src, type: yylstack[yysp - 6].type } }, {"first":1,"last":7,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["CLASS", yylstack[yysp - 6]], ["Identifier", yylstack[yysp - 5]], ["ClassConstructor?", yylstack[yysp - 4]], ["EXTENDS", yylstack[yysp - 3]], ["Value", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 132:
    /*! Production::    Class : CLASS ClassConstructor? EXTENDS Value Block */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Class"]("CLASS ClassConstructor? EXTENDS Value Block", ...[undefined, yyvstack[yysp - 1], yyvstack[yysp][1], yylstack[yysp - 4].origin === "class*", yyvstack[yysp - 3].unwrap]), { rule: "CLASS ClassConstructor? EXTENDS Value Block", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["CLASS", yylstack[yysp - 4]], ["ClassConstructor?", yylstack[yysp - 3]], ["EXTENDS", yylstack[yysp - 2]], ["Value", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 133:
    /*! Production::    Class : CLASS Identifier ClassConstructor? EXTENDS Value */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Class"]("CLASS Identifier ClassConstructor? EXTENDS Value", ...[yyvstack[yysp - 3], yyvstack[yysp], false, yylstack[yysp - 4].origin === "class*", yyvstack[yysp - 2].unwrap]), { rule: "CLASS Identifier ClassConstructor? EXTENDS Value", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["CLASS", yylstack[yysp - 4]], ["Identifier", yylstack[yysp - 3]], ["ClassConstructor?", yylstack[yysp - 2]], ["EXTENDS", yylstack[yysp - 1]], ["Value", yylstack[yysp]])
    break;

case 134:
    /*! Production::    Class : CLASS ClassConstructor? EXTENDS Value */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Class"]("CLASS ClassConstructor? EXTENDS Value", ...[undefined, yyvstack[yysp],false, yylstack[yysp - 3].origin === "class*", yyvstack[yysp - 2].unwrap]), { rule: "CLASS ClassConstructor? EXTENDS Value", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["CLASS", yylstack[yysp - 3]], ["ClassConstructor?", yylstack[yysp - 2]], ["EXTENDS", yylstack[yysp - 1]], ["Value", yylstack[yysp]])
    break;

case 135:
    /*! Production::    Class : CLASS ClassConstructor? EXTENDS Value THEN Block */

    // default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 5, yysp);
    // END of default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Class"]("CLASS ClassConstructor? EXTENDS Value THEN Block", ...[undefined, yyvstack[yysp - 2], yyvstack[yysp][1], yylstack[yysp - 5].origin === "class*", yyvstack[yysp - 4].unwrap]), { rule: "CLASS ClassConstructor? EXTENDS Value THEN Block", loc: { first_line: yylstack[yysp - 5].first_line, first_column: yylstack[yysp - 5].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 5].src, type: yylstack[yysp - 5].type } }, {"first":1,"last":6,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["CLASS", yylstack[yysp - 5]], ["ClassConstructor?", yylstack[yysp - 4]], ["EXTENDS", yylstack[yysp - 3]], ["Value", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 136:
    /*! Production::    ClassConstructor? : %epsilon */

    // default action (generated by JISON mode classic/merge :: 0,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(null, null, null, null, true);
    // END of default action (generated by JISON mode classic/merge :: 0,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ClassConstructor?"]("", ...[undefined]), { rule: "", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["", yylstack[yysp]])
    break;

case 137:
    /*! Production::    ClassConstructor? : WITH Params */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ClassConstructor?"]("WITH Params", ...[yyvstack[yysp]]), { rule: "WITH Params", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["WITH", yylstack[yysp - 1]], ["Params", yylstack[yysp]])
    break;

case 138:
    /*! Production::    ClassConstructor? : Params */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ClassConstructor?"]("Params", ...[yyvstack[yysp]]), { rule: "Params", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Params", yylstack[yysp]])
    break;

case 139:
    /*! Production::    Block : "{{" "}}" */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Block"]("{{ }}", ...[yy.Block.wrap()]), { rule: "{{ }}", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["{{", yylstack[yysp - 1]], ["}}", yylstack[yysp]])
    break;

case 140:
    /*! Production::    Block : INDENT OUTDENT */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Block"]("INDENT OUTDENT", ...[yy.Block.wrap()]), { rule: "INDENT OUTDENT", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["INDENT", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 141:
    /*! Production::    Block : "{{" INDENT OUTDENT "}}" */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Block"]("{{ INDENT OUTDENT }}", ...[yy.Block.wrap()]), { rule: "{{ INDENT OUTDENT }}", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["{{", yylstack[yysp - 3]], ["INDENT", yylstack[yysp - 2]], ["OUTDENT", yylstack[yysp - 1]], ["}}", yylstack[yysp]])
    break;

case 142:
    /*! Production::    Block : INDENT Body OUTDENT */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Block"]("INDENT Body OUTDENT", ...[yyvstack[yysp - 1]]), { rule: "INDENT Body OUTDENT", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["INDENT", yylstack[yysp - 2]], ["Body", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 143:
    /*! Production::    Block : "{{" INDENT Body OUTDENT "}}" */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Block"]("{{ INDENT Body OUTDENT }}", ...[yyvstack[yysp - 2]]), { rule: "{{ INDENT Body OUTDENT }}", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["{{", yylstack[yysp - 4]], ["INDENT", yylstack[yysp - 3]], ["Body", yylstack[yysp - 2]], ["OUTDENT", yylstack[yysp - 1]], ["}}", yylstack[yysp]])
    break;

case 144:
    /*! Production::    Block : "{" Body "}" */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Block"]("{ Body }", ...[yyvstack[yysp - 1]]), { rule: "{ Body }", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["{", yylstack[yysp - 2]], ["Body", yylstack[yysp - 1]], ["}", yylstack[yysp]])
    break;

case 145:
    /*! Production::    ForExpression : JointExpression */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["ForExpression"]("JointExpression", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["JointExpression", yylstack[yysp - 1]])
    break;

case 146:
    /*! Production::    ForExpression : Declare */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["ForExpression"]("Declare", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Declare", yylstack[yysp - 1]])
    break;

case 147:
    /*! Production::    JointExpression : Expression */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["JointExpression"]("Expression", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Expression", yylstack[yysp - 1]])
    break;

case 148:
    /*! Production::    JointExpression : JointExpression "," Expression */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["JointExpression"]("JointExpression , Expression", ...[...yyvstack[yysp - 2].contents, yyvstack[yysp]]), { rule: "JointExpression , Expression", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["JointExpression", yylstack[yysp - 2]], [",", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 149:
    /*! Production::    For : FOR ForExpression ";" Expression ";" Expression Block */

    // default action (generated by JISON mode classic/merge :: 7,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 6, yysp);
    // END of default action (generated by JISON mode classic/merge :: 7,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["For"]("FOR ForExpression ; Expression ; Expression Block", ...[[yyvstack[yysp - 5], yyvstack[yysp - 3], yyvstack[yysp - 1]], yyvstack[yysp]]), { rule: "FOR ForExpression ; Expression ; Expression Block", loc: { first_line: yylstack[yysp - 6].first_line, first_column: yylstack[yysp - 6].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 6].src, type: yylstack[yysp - 6].type } }, {"first":1,"last":7,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["FOR", yylstack[yysp - 6]], ["ForExpression", yylstack[yysp - 5]], [";", yylstack[yysp - 4]], ["Expression", yylstack[yysp - 3]], [";", yylstack[yysp - 2]], ["Expression", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 150:
    /*! Production::    For : FOR ForExpression ";" Expression ";" Expression THEN Block */

    // default action (generated by JISON mode classic/merge :: 8,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 7, yysp);
    // END of default action (generated by JISON mode classic/merge :: 8,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["For"]("FOR ForExpression ; Expression ; Expression THEN Block", ...[[yyvstack[yysp - 6], yyvstack[yysp - 4], yyvstack[yysp - 2]], yyvstack[yysp]]), { rule: "FOR ForExpression ; Expression ; Expression THEN Block", loc: { first_line: yylstack[yysp - 7].first_line, first_column: yylstack[yysp - 7].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 7].src, type: yylstack[yysp - 7].type } }, {"first":1,"last":8,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["FOR", yylstack[yysp - 7]], ["ForExpression", yylstack[yysp - 6]], [";", yylstack[yysp - 5]], ["Expression", yylstack[yysp - 4]], [";", yylstack[yysp - 3]], ["Expression", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 151:
    /*! Production::    For : FOR ForExpression ";" Expression ";" Expression THEN Expression */

    // default action (generated by JISON mode classic/merge :: 8,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 7, yysp);
    // END of default action (generated by JISON mode classic/merge :: 8,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["For"]("FOR ForExpression ; Expression ; Expression THEN Expression", ...[[yyvstack[yysp - 6], yyvstack[yysp - 4], yyvstack[yysp - 2]], yy.Block.wrap(yyvstack[yysp])]), { rule: "FOR ForExpression ; Expression ; Expression THEN Expression", loc: { first_line: yylstack[yysp - 7].first_line, first_column: yylstack[yysp - 7].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 7].src, type: yylstack[yysp - 7].type } }, {"first":1,"last":8,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["FOR", yylstack[yysp - 7]], ["ForExpression", yylstack[yysp - 6]], [";", yylstack[yysp - 5]], ["Expression", yylstack[yysp - 4]], [";", yylstack[yysp - 3]], ["Expression", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 152:
    /*! Production::    For : FOR ForExpression WHEN Expression WHILST Expression Block */

    // default action (generated by JISON mode classic/merge :: 7,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 6, yysp);
    // END of default action (generated by JISON mode classic/merge :: 7,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["For"]("FOR ForExpression WHEN Expression WHILST Expression Block", ...[[yyvstack[yysp - 5], yyvstack[yysp - 3], yyvstack[yysp - 1]], yyvstack[yysp]]), { rule: "FOR ForExpression WHEN Expression WHILST Expression Block", loc: { first_line: yylstack[yysp - 6].first_line, first_column: yylstack[yysp - 6].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 6].src, type: yylstack[yysp - 6].type } }, {"first":1,"last":7,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["FOR", yylstack[yysp - 6]], ["ForExpression", yylstack[yysp - 5]], ["WHEN", yylstack[yysp - 4]], ["Expression", yylstack[yysp - 3]], ["WHILST", yylstack[yysp - 2]], ["Expression", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 153:
    /*! Production::    For : FOR ForExpression WHEN Expression WHILST Expression THEN Block */

    // default action (generated by JISON mode classic/merge :: 8,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 7, yysp);
    // END of default action (generated by JISON mode classic/merge :: 8,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["For"]("FOR ForExpression WHEN Expression WHILST Expression THEN Block", ...[[yyvstack[yysp - 6], yyvstack[yysp - 4], yyvstack[yysp - 2]], yyvstack[yysp]]), { rule: "FOR ForExpression WHEN Expression WHILST Expression THEN Block", loc: { first_line: yylstack[yysp - 7].first_line, first_column: yylstack[yysp - 7].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 7].src, type: yylstack[yysp - 7].type } }, {"first":1,"last":8,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["FOR", yylstack[yysp - 7]], ["ForExpression", yylstack[yysp - 6]], ["WHEN", yylstack[yysp - 5]], ["Expression", yylstack[yysp - 4]], ["WHILST", yylstack[yysp - 3]], ["Expression", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 154:
    /*! Production::    For : FOR ForExpression WHEN Expression WHILST Expression THEN Expression */

    // default action (generated by JISON mode classic/merge :: 8,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 7, yysp);
    // END of default action (generated by JISON mode classic/merge :: 8,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["For"]("FOR ForExpression WHEN Expression WHILST Expression THEN Expression", ...[[yyvstack[yysp - 6], yyvstack[yysp - 4], yyvstack[yysp - 2]], yy.Block.wrap(yyvstack[yysp])]), { rule: "FOR ForExpression WHEN Expression WHILST Expression THEN Expression", loc: { first_line: yylstack[yysp - 7].first_line, first_column: yylstack[yysp - 7].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 7].src, type: yylstack[yysp - 7].type } }, {"first":1,"last":8,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["FOR", yylstack[yysp - 7]], ["ForExpression", yylstack[yysp - 6]], ["WHEN", yylstack[yysp - 5]], ["Expression", yylstack[yysp - 4]], ["WHILST", yylstack[yysp - 3]], ["Expression", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 155:
    /*! Production::    For : FOR ForAssignable FOR_OF Expression Block */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["For"]("FOR ForAssignable FOR_OF Expression Block", ...[[yyvstack[yysp - 3][1], yyvstack[yysp - 2], yyvstack[yysp - 1]], yyvstack[yysp], yyvstack[yysp - 3][2]]), { rule: "FOR ForAssignable FOR_OF Expression Block", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["FOR", yylstack[yysp - 4]], ["ForAssignable", yylstack[yysp - 3]], ["FOR_OF", yylstack[yysp - 2]], ["Expression", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 156:
    /*! Production::    For : FOR ForAssignable FOR_IN Expression Block */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["For"]("FOR ForAssignable FOR_IN Expression Block", ...[[yyvstack[yysp - 3][1], yyvstack[yysp - 2], yyvstack[yysp - 1]], yyvstack[yysp], yyvstack[yysp - 3][2]]), { rule: "FOR ForAssignable FOR_IN Expression Block", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["FOR", yylstack[yysp - 4]], ["ForAssignable", yylstack[yysp - 3]], ["FOR_IN", yylstack[yysp - 2]], ["Expression", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 157:
    /*! Production::    For : FOR ForAssignable FOR_OF Expression THEN Block */

    // default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 5, yysp);
    // END of default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["For"]("FOR ForAssignable FOR_OF Expression THEN Block", ...[[yyvstack[yysp - 4][1], yyvstack[yysp - 3], yyvstack[yysp - 2]], yyvstack[yysp], yyvstack[yysp - 4][2]]), { rule: "FOR ForAssignable FOR_OF Expression THEN Block", loc: { first_line: yylstack[yysp - 5].first_line, first_column: yylstack[yysp - 5].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 5].src, type: yylstack[yysp - 5].type } }, {"first":1,"last":6,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["FOR", yylstack[yysp - 5]], ["ForAssignable", yylstack[yysp - 4]], ["FOR_OF", yylstack[yysp - 3]], ["Expression", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 158:
    /*! Production::    For : FOR ForAssignable FOR_IN Expression THEN Block */

    // default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 5, yysp);
    // END of default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["For"]("FOR ForAssignable FOR_IN Expression THEN Block", ...[[yyvstack[yysp - 4][1], yyvstack[yysp - 3], yyvstack[yysp - 2]], yyvstack[yysp], yyvstack[yysp - 4][2]]), { rule: "FOR ForAssignable FOR_IN Expression THEN Block", loc: { first_line: yylstack[yysp - 5].first_line, first_column: yylstack[yysp - 5].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 5].src, type: yylstack[yysp - 5].type } }, {"first":1,"last":6,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["FOR", yylstack[yysp - 5]], ["ForAssignable", yylstack[yysp - 4]], ["FOR_IN", yylstack[yysp - 3]], ["Expression", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 159:
    /*! Production::    For : FOR ForAssignable FOR_OF Expression THEN Expression */

    // default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 5, yysp);
    // END of default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["For"]("FOR ForAssignable FOR_OF Expression THEN Expression", ...[[yyvstack[yysp - 4][1], yyvstack[yysp - 3], yyvstack[yysp - 2]], yy.Block.wrap(yyvstack[yysp]), yyvstack[yysp - 4][2]]), { rule: "FOR ForAssignable FOR_OF Expression THEN Expression", loc: { first_line: yylstack[yysp - 5].first_line, first_column: yylstack[yysp - 5].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 5].src, type: yylstack[yysp - 5].type } }, {"first":1,"last":6,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["FOR", yylstack[yysp - 5]], ["ForAssignable", yylstack[yysp - 4]], ["FOR_OF", yylstack[yysp - 3]], ["Expression", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 160:
    /*! Production::    For : FOR ForAssignable FOR_IN Expression THEN Expression */

    // default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 5, yysp);
    // END of default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["For"]("FOR ForAssignable FOR_IN Expression THEN Expression", ...[[yyvstack[yysp - 4][1], yyvstack[yysp - 3], yyvstack[yysp - 2]], yy.Block.wrap(yyvstack[yysp]), yyvstack[yysp - 4][2]]), { rule: "FOR ForAssignable FOR_IN Expression THEN Expression", loc: { first_line: yylstack[yysp - 5].first_line, first_column: yylstack[yysp - 5].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 5].src, type: yylstack[yysp - 5].type } }, {"first":1,"last":6,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["FOR", yylstack[yysp - 5]], ["ForAssignable", yylstack[yysp - 4]], ["FOR_IN", yylstack[yysp - 3]], ["Expression", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 161:
    /*! Production::    For : FOR Identifier "," Assignable ForAny Expression THEN Expression */

    // default action (generated by JISON mode classic/merge :: 8,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 7, yysp);
    // END of default action (generated by JISON mode classic/merge :: 8,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["For"]("FOR Identifier , Assignable ForAny Expression THEN Expression", ...[[[yyvstack[yysp - 6], yyvstack[yysp - 4]], yyvstack[yysp - 3], yyvstack[yysp - 2]], yy.Block.wrap(yyvstack[yysp])]), { rule: "FOR Identifier , Assignable ForAny Expression THEN Expression", loc: { first_line: yylstack[yysp - 7].first_line, first_column: yylstack[yysp - 7].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 7].src, type: yylstack[yysp - 7].type } }, {"first":1,"last":8,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["FOR", yylstack[yysp - 7]], ["Identifier", yylstack[yysp - 6]], [",", yylstack[yysp - 5]], ["Assignable", yylstack[yysp - 4]], ["ForAny", yylstack[yysp - 3]], ["Expression", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 162:
    /*! Production::    For : FOR Identifier "," Assignable ForAny Expression THEN Block */

    // default action (generated by JISON mode classic/merge :: 8,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 7, yysp);
    // END of default action (generated by JISON mode classic/merge :: 8,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["For"]("FOR Identifier , Assignable ForAny Expression THEN Block", ...[[[yyvstack[yysp - 6], yyvstack[yysp - 4]], yyvstack[yysp - 3], yyvstack[yysp - 2]], yyvstack[yysp]]), { rule: "FOR Identifier , Assignable ForAny Expression THEN Block", loc: { first_line: yylstack[yysp - 7].first_line, first_column: yylstack[yysp - 7].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 7].src, type: yylstack[yysp - 7].type } }, {"first":1,"last":8,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["FOR", yylstack[yysp - 7]], ["Identifier", yylstack[yysp - 6]], [",", yylstack[yysp - 5]], ["Assignable", yylstack[yysp - 4]], ["ForAny", yylstack[yysp - 3]], ["Expression", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 163:
    /*! Production::    For : FOR Identifier "," Assignable ForAny Expression Block */

    // default action (generated by JISON mode classic/merge :: 7,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 6, yysp);
    // END of default action (generated by JISON mode classic/merge :: 7,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["For"]("FOR Identifier , Assignable ForAny Expression Block", ...[[[yyvstack[yysp - 5], yyvstack[yysp - 3]], yyvstack[yysp - 2], yyvstack[yysp - 1]], yyvstack[yysp]]), { rule: "FOR Identifier , Assignable ForAny Expression Block", loc: { first_line: yylstack[yysp - 6].first_line, first_column: yylstack[yysp - 6].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 6].src, type: yylstack[yysp - 6].type } }, {"first":1,"last":7,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["FOR", yylstack[yysp - 6]], ["Identifier", yylstack[yysp - 5]], [",", yylstack[yysp - 4]], ["Assignable", yylstack[yysp - 3]], ["ForAny", yylstack[yysp - 2]], ["Expression", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 164:
    /*! Production::    For : FOR DeclarationKeyword Identifier "," Assignable ForAny Expression THEN Expression */

    // default action (generated by JISON mode classic/merge :: 9,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 8, yysp);
    // END of default action (generated by JISON mode classic/merge :: 9,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["For"]("FOR DeclarationKeyword Identifier , Assignable ForAny Expression THEN Expression", ...[[[yyvstack[yysp - 6], yyvstack[yysp - 4]], yyvstack[yysp - 3], yyvstack[yysp - 2]], yy.Block.wrap(yyvstack[yysp]), yyvstack[yysp - 7]]), { rule: "FOR DeclarationKeyword Identifier , Assignable ForAny Expression THEN Expression", loc: { first_line: yylstack[yysp - 8].first_line, first_column: yylstack[yysp - 8].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 8].src, type: yylstack[yysp - 8].type } }, {"first":1,"last":9,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["FOR", yylstack[yysp - 8]], ["DeclarationKeyword", yylstack[yysp - 7]], ["Identifier", yylstack[yysp - 6]], [",", yylstack[yysp - 5]], ["Assignable", yylstack[yysp - 4]], ["ForAny", yylstack[yysp - 3]], ["Expression", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 165:
    /*! Production::    For : FOR DeclarationKeyword Identifier "," Assignable ForAny Expression THEN Block */

    // default action (generated by JISON mode classic/merge :: 9,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 8, yysp);
    // END of default action (generated by JISON mode classic/merge :: 9,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["For"]("FOR DeclarationKeyword Identifier , Assignable ForAny Expression THEN Block", ...[[[yyvstack[yysp - 6], yyvstack[yysp - 4]], yyvstack[yysp - 3], yyvstack[yysp - 2]], yyvstack[yysp - 1], yyvstack[yysp - 7]]), { rule: "FOR DeclarationKeyword Identifier , Assignable ForAny Expression THEN Block", loc: { first_line: yylstack[yysp - 8].first_line, first_column: yylstack[yysp - 8].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 8].src, type: yylstack[yysp - 8].type } }, {"first":1,"last":9,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["FOR", yylstack[yysp - 8]], ["DeclarationKeyword", yylstack[yysp - 7]], ["Identifier", yylstack[yysp - 6]], [",", yylstack[yysp - 5]], ["Assignable", yylstack[yysp - 4]], ["ForAny", yylstack[yysp - 3]], ["Expression", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 166:
    /*! Production::    For : FOR DeclarationKeyword Identifier "," Assignable ForAny Expression Block */

    // default action (generated by JISON mode classic/merge :: 8,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 7, yysp);
    // END of default action (generated by JISON mode classic/merge :: 8,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["For"]("FOR DeclarationKeyword Identifier , Assignable ForAny Expression Block", ...[[[yyvstack[yysp - 5], yyvstack[yysp - 3]], yyvstack[yysp - 2], yyvstack[yysp - 1]], yyvstack[yysp], yyvstack[yysp - 6]]), { rule: "FOR DeclarationKeyword Identifier , Assignable ForAny Expression Block", loc: { first_line: yylstack[yysp - 7].first_line, first_column: yylstack[yysp - 7].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 7].src, type: yylstack[yysp - 7].type } }, {"first":1,"last":8,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["FOR", yylstack[yysp - 7]], ["DeclarationKeyword", yylstack[yysp - 6]], ["Identifier", yylstack[yysp - 5]], [",", yylstack[yysp - 4]], ["Assignable", yylstack[yysp - 3]], ["ForAny", yylstack[yysp - 2]], ["Expression", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 167:
    /*! Production::    For : Expression POSTFOR DeclarationKeyword Identifier "," Assignable ForAny Expression */

    // default action (generated by JISON mode classic/merge :: 8,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 7, yysp);
    // END of default action (generated by JISON mode classic/merge :: 8,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["For"]("Expression POSTFOR DeclarationKeyword Identifier , Assignable ForAny Expression", ...[[[yyvstack[yysp - 4], yyvstack[yysp - 2]], yyvstack[yysp - 1], yyvstack[yysp]], yy.Block.wrap(yyvstack[yysp - 7]), yyvstack[yysp - 5]]), { rule: "Expression POSTFOR DeclarationKeyword Identifier , Assignable ForAny Expression", loc: { first_line: yylstack[yysp - 7].first_line, first_column: yylstack[yysp - 7].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 7].src, type: yylstack[yysp - 7].type } }, {"first":1,"last":8,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Expression", yylstack[yysp - 7]], ["POSTFOR", yylstack[yysp - 6]], ["DeclarationKeyword", yylstack[yysp - 5]], ["Identifier", yylstack[yysp - 4]], [",", yylstack[yysp - 3]], ["Assignable", yylstack[yysp - 2]], ["ForAny", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 168:
    /*! Production::    For : Expression POSTFOR ForAssignable FOR_OF Expression */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["For"]("Expression POSTFOR ForAssignable FOR_OF Expression", ...[[yyvstack[yysp - 2][1], yyvstack[yysp - 1], yyvstack[yysp]], yy.Block.wrap(yyvstack[yysp - 4]), yyvstack[yysp - 2][2]]), { rule: "Expression POSTFOR ForAssignable FOR_OF Expression", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Expression", yylstack[yysp - 4]], ["POSTFOR", yylstack[yysp - 3]], ["ForAssignable", yylstack[yysp - 2]], ["FOR_OF", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 169:
    /*! Production::    For : Expression POSTFOR ForAssignable FOR_IN Expression */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["For"]("Expression POSTFOR ForAssignable FOR_IN Expression", ...[[yyvstack[yysp - 2][1], yyvstack[yysp - 1], yyvstack[yysp]], yy.Block.wrap(yyvstack[yysp - 4]), yyvstack[yysp - 2][2]]), { rule: "Expression POSTFOR ForAssignable FOR_IN Expression", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Expression", yylstack[yysp - 4]], ["POSTFOR", yylstack[yysp - 3]], ["ForAssignable", yylstack[yysp - 2]], ["FOR_IN", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 170:
    /*! Production::    For : Expression POSTFOR Identifier "," Assignable ForAny Expression */

    // default action (generated by JISON mode classic/merge :: 7,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 6, yysp);
    // END of default action (generated by JISON mode classic/merge :: 7,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["For"]("Expression POSTFOR Identifier , Assignable ForAny Expression", ...[[[yyvstack[yysp - 4], yyvstack[yysp - 2]], yyvstack[yysp - 1], yyvstack[yysp]], yy.Block.wrap(yyvstack[yysp - 6])]), { rule: "Expression POSTFOR Identifier , Assignable ForAny Expression", loc: { first_line: yylstack[yysp - 6].first_line, first_column: yylstack[yysp - 6].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 6].src, type: yylstack[yysp - 6].type } }, {"first":1,"last":7,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Expression", yylstack[yysp - 6]], ["POSTFOR", yylstack[yysp - 5]], ["Identifier", yylstack[yysp - 4]], [",", yylstack[yysp - 3]], ["Assignable", yylstack[yysp - 2]], ["ForAny", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 171:
    /*! Production::    ForAssignable : DeclarationKeyword Assignable */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ForAssignable"]("DeclarationKeyword Assignable", ...[yyvstack[yysp], yyvstack[yysp - 1]]), { rule: "DeclarationKeyword Assignable", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["DeclarationKeyword", yylstack[yysp - 1]], ["Assignable", yylstack[yysp]])
    break;

case 172:
    /*! Production::    ForAssignable : Assignable */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ForAssignable"]("Assignable", ...[yyvstack[yysp]]), { rule: "Assignable", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Assignable", yylstack[yysp]])
    break;

case 173:
    /*! Production::    Switch : SWITCH Expression INDENT Cases OUTDENT */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Switch"]("SWITCH Expression INDENT Cases OUTDENT", ...[yyvstack[yysp - 3], yyvstack[yysp - 1]]), { rule: "SWITCH Expression INDENT Cases OUTDENT", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["SWITCH", yylstack[yysp - 4]], ["Expression", yylstack[yysp - 3]], ["INDENT", yylstack[yysp - 2]], ["Cases", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 174:
    /*! Production::    Switch : SWITCH INDENT Cases OUTDENT */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Switch"]("SWITCH INDENT Cases OUTDENT", ...[false, yyvstack[yysp - 1]]), { rule: "SWITCH INDENT Cases OUTDENT", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["SWITCH", yylstack[yysp - 3]], ["INDENT", yylstack[yysp - 2]], ["Cases", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 175:
    /*! Production::    Switch : SWITCH Expression "{{" INDENT Cases OUTDENT "}}" */

    // default action (generated by JISON mode classic/merge :: 7,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 6, yysp);
    // END of default action (generated by JISON mode classic/merge :: 7,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Switch"]("SWITCH Expression {{ INDENT Cases OUTDENT }}", ...[yyvstack[yysp - 5], yyvstack[yysp - 2]]), { rule: "SWITCH Expression {{ INDENT Cases OUTDENT }}", loc: { first_line: yylstack[yysp - 6].first_line, first_column: yylstack[yysp - 6].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 6].src, type: yylstack[yysp - 6].type } }, {"first":1,"last":7,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["SWITCH", yylstack[yysp - 6]], ["Expression", yylstack[yysp - 5]], ["{{", yylstack[yysp - 4]], ["INDENT", yylstack[yysp - 3]], ["Cases", yylstack[yysp - 2]], ["OUTDENT", yylstack[yysp - 1]], ["}}", yylstack[yysp]])
    break;

case 176:
    /*! Production::    Switch : SWITCH "{{" INDENT Cases OUTDENT "}}" */

    // default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 5, yysp);
    // END of default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Switch"]("SWITCH {{ INDENT Cases OUTDENT }}", ...[false, yyvstack[yysp - 2]]), { rule: "SWITCH {{ INDENT Cases OUTDENT }}", loc: { first_line: yylstack[yysp - 5].first_line, first_column: yylstack[yysp - 5].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 5].src, type: yylstack[yysp - 5].type } }, {"first":1,"last":6,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["SWITCH", yylstack[yysp - 5]], ["{{", yylstack[yysp - 4]], ["INDENT", yylstack[yysp - 3]], ["Cases", yylstack[yysp - 2]], ["OUTDENT", yylstack[yysp - 1]], ["}}", yylstack[yysp]])
    break;

case 177:
    /*! Production::    Cases : Case */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Cases"]("Case", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Case", yylstack[yysp - 1]])
    break;

case 178:
    /*! Production::    Cases : Cases NEWLINE Case */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Cases"]("Cases NEWLINE Case", ...[...yyvstack[yysp - 2].contents, yyvstack[yysp]]), { rule: "Cases NEWLINE Case", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Cases", yylstack[yysp - 2]], ["NEWLINE", yylstack[yysp - 1]], ["Case", yylstack[yysp]])
    break;

case 179:
    /*! Production::    Case : Clauses THEN Expression */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Case"]("Clauses THEN Expression", ...[yyvstack[yysp - 2], yy.Block.wrap(yyvstack[yysp])]), { rule: "Clauses THEN Expression", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Clauses", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 180:
    /*! Production::    Case : Clauses THEN Block */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Case"]("Clauses THEN Block", ...[yyvstack[yysp - 2], yyvstack[yysp].unwrap]), { rule: "Clauses THEN Block", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Clauses", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 181:
    /*! Production::    Case : Clauses Block */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Case"]("Clauses Block", ...[yyvstack[yysp - 1], yyvstack[yysp].unwrap]), { rule: "Clauses Block", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Clauses", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 182:
    /*! Production::    Case : Multicondition THEN Expression */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Case"]("Multicondition THEN Expression", ...[yyvstack[yysp - 2], yy.Block.wrap(yyvstack[yysp])]), { rule: "Multicondition THEN Expression", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Multicondition", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 183:
    /*! Production::    Case : Multicondition THEN Block */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Case"]("Multicondition THEN Block", ...[yyvstack[yysp - 2], yyvstack[yysp].unwrap]), { rule: "Multicondition THEN Block", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Multicondition", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 184:
    /*! Production::    Case : Multicondition Block */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Case"]("Multicondition Block", ...[yyvstack[yysp - 1], yyvstack[yysp].unwrap]), { rule: "Multicondition Block", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Multicondition", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 185:
    /*! Production::    Case : DEFAULT Expression */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Case"]("DEFAULT Expression", ...[false, yy.Block.wrap(yyvstack[yysp])]), { rule: "DEFAULT Expression", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["DEFAULT", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 186:
    /*! Production::    Case : DEFAULT Block */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Case"]("DEFAULT Block", ...[false, yyvstack[yysp].unwrap]), { rule: "DEFAULT Block", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["DEFAULT", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 187:
    /*! Production::    Case : Expression POSTCASE MulticheckClauses */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Case"]("Expression POSTCASE MulticheckClauses", ...[yyvstack[yysp], yy.Block.wrap(yyvstack[yysp - 2])]), { rule: "Expression POSTCASE MulticheckClauses", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Expression", yylstack[yysp - 2]], ["POSTCASE", yylstack[yysp - 1]], ["MulticheckClauses", yylstack[yysp]])
    break;

case 188:
    /*! Production::    Case : BREAK */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Case"]("BREAK", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["BREAK", yylstack[yysp - 1]])
    break;

case 189:
    /*! Production::    Clauses : When */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Clauses"]("When", ...[yyvstack[yysp].contents]), { rule: "When", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["When", yylstack[yysp]])
    break;

case 190:
    /*! Production::    Clauses : Clauses NEWLINE When */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Clauses"]("Clauses NEWLINE When", ...[...yyvstack[yysp - 2].contents, yyvstack[yysp].contents]), { rule: "Clauses NEWLINE When", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Clauses", yylstack[yysp - 2]], ["NEWLINE", yylstack[yysp - 1]], ["When", yylstack[yysp]])
    break;

case 191:
    /*! Production::    Clauses : Clauses COMPOUND_OR When */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Clauses"]("Clauses COMPOUND_OR When", ...[...yyvstack[yysp - 2].contents, yyvstack[yysp].contents]), { rule: "Clauses COMPOUND_OR When", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Clauses", yylstack[yysp - 2]], ["COMPOUND_OR", yylstack[yysp - 1]], ["When", yylstack[yysp]])
    break;

case 192:
    /*! Production::    When : CASE Clause */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["When"]("CASE Clause", ...[...yyvstack[yysp].contents]), { rule: "CASE Clause", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["CASE", yylstack[yysp - 1]], ["Clause", yylstack[yysp]])
    break;

case 193:
    /*! Production::    When : IF Clause */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["When"]("IF Clause", ...[...yyvstack[yysp].contents]), { rule: "IF Clause", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["IF", yylstack[yysp - 1]], ["Clause", yylstack[yysp]])
    break;

case 194:
    /*! Production::    When : WHEN Clause */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["When"]("WHEN Clause", ...[...yyvstack[yysp].contents]), { rule: "WHEN Clause", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["WHEN", yylstack[yysp - 1]], ["Clause", yylstack[yysp]])
    break;

case 195:
    /*! Production::    ForAny : FOR_FROM */
case 196:
    /*! Production::    ForAny : FOR_AT */
case 197:
    /*! Production::    ForAny : FOR_AS */
case 281:
    /*! Production::    PropObj : Function */
case 295:
    /*! Production::    PropObj : Assignment */
case 301:
    /*! Production::    ParamPropObj : ParamIdentifier */
case 422:
    /*! Production::    OptVoids : Voids */
case 525:
    /*! Production::    Import(FROM) : FROM */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = yyvstack[yysp]
    break;

case 198:
    /*! Production::    If : IfBlock */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["If"]("IfBlock", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["IfBlock", yylstack[yysp - 1]])
    break;

case 199:
    /*! Production::    If : IfBlock Else */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["If"]("IfBlock Else", ...[yyvstack[yysp - 1], yyvstack[yysp]]), { rule: "IfBlock Else", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["IfBlock", yylstack[yysp - 1]], ["Else", yylstack[yysp]])
    break;

case 200:
    /*! Production::    If : Expression "?" BlockExpression ":" BlockExpression */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["If"]("Expression ? BlockExpression : BlockExpression", ...[new yy.IfBlock('IfBlock', yyvstack[yysp - 4], yyvstack[yysp - 2].unwrap), new yy.Else('Else', yyvstack[yysp].unwrap)]), { rule: "Expression ? BlockExpression : BlockExpression", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false,"quoteSyntax":true}, { generated: undefined }).setTokens(["Expression", yylstack[yysp - 4]], ["?", yylstack[yysp - 3]], ["BlockExpression", yylstack[yysp - 2]], [":", yylstack[yysp - 1]], ["BlockExpression", yylstack[yysp]])
    break;

case 201:
    /*! Production::    If : Expression "?" BlockExpression */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["If"]("Expression ? BlockExpression", ...[new yy.IfBlock('IfBlock', yyvstack[yysp - 2], yyvstack[yysp].unwrap)]), { rule: "Expression ? BlockExpression", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false,"quoteSyntax":true}, { generated: undefined }).setTokens(["Expression", yylstack[yysp - 2]], ["?", yylstack[yysp - 1]], ["BlockExpression", yylstack[yysp]])
    break;

case 202:
    /*! Production::    If : Expression "?" INDENT BlockExpression ":" BlockExpression OUTDENT */

    // default action (generated by JISON mode classic/merge :: 7,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 6, yysp);
    // END of default action (generated by JISON mode classic/merge :: 7,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["If"]("Expression ? INDENT BlockExpression : BlockExpression OUTDENT", ...[new yy.IfBlock('IfBlock', yyvstack[yysp - 6], yyvstack[yysp - 3].unwrap), new yy.Else('Else', yyvstack[yysp - 1].unwrap)]), { rule: "Expression ? INDENT BlockExpression : BlockExpression OUTDENT", loc: { first_line: yylstack[yysp - 6].first_line, first_column: yylstack[yysp - 6].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 6].src, type: yylstack[yysp - 6].type } }, {"first":1,"last":7,"typeOf":1,"checkGenerated":false,"quoteSyntax":true}, { generated: undefined }).setTokens(["Expression", yylstack[yysp - 6]], ["?", yylstack[yysp - 5]], ["INDENT", yylstack[yysp - 4]], ["BlockExpression", yylstack[yysp - 3]], [":", yylstack[yysp - 2]], ["BlockExpression", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 203:
    /*! Production::    If : Expression POSTIF Expression */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["If"]("Expression POSTIF Expression", ...[yyvstack[yysp], yyvstack[yysp - 2]]), { rule: "Expression POSTIF Expression", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false,"postfix":true}, { generated: undefined }).setTokens(["Expression", yylstack[yysp - 2]], ["POSTIF", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 204:
    /*! Production::    If : Statement POSTIF Expression */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["If"]("Statement POSTIF Expression", ...[yyvstack[yysp], yyvstack[yysp - 2]]), { rule: "Statement POSTIF Expression", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false,"postfix":true,"statement":true}, { generated: undefined }).setTokens(["Statement", yylstack[yysp - 2]], ["POSTIF", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 205:
    /*! Production::    If : Expression POSTUNLESS Expression */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["If"]("Expression POSTUNLESS Expression", ...[yyvstack[yysp], yyvstack[yysp - 2]]), { rule: "Expression POSTUNLESS Expression", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false,"postfix":true,"unless":true}, { generated: undefined }).setTokens(["Expression", yylstack[yysp - 2]], ["POSTUNLESS", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 206:
    /*! Production::    If : Statement POSTUNLESS Expression */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["If"]("Statement POSTUNLESS Expression", ...[yyvstack[yysp], yyvstack[yysp - 2]]), { rule: "Statement POSTUNLESS Expression", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false,"postfix":true,"statement":true,"unless":true}, { generated: undefined }).setTokens(["Statement", yylstack[yysp - 2]], ["POSTUNLESS", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 207:
    /*! Production::    BlockExpression : Expression */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["BlockExpression"]("Expression", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Expression", yylstack[yysp - 1]])
    break;

case 208:
    /*! Production::    BlockExpression : INDENT Expression OUTDENT */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["BlockExpression"]("INDENT Expression OUTDENT", ...[yyvstack[yysp - 1]]), { rule: "INDENT Expression OUTDENT", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["INDENT", yylstack[yysp - 2]], ["Expression", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 209:
    /*! Production::    TryBlock : Try */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TryBlock"]("Try", ...[yyvstack[yysp], null, null]), { rule: "Try", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Try", yylstack[yysp]])
    break;

case 210:
    /*! Production::    TryBlock : Try Catch */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TryBlock"]("Try Catch", ...[yyvstack[yysp - 1], yyvstack[yysp], null]), { rule: "Try Catch", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Try", yylstack[yysp - 1]], ["Catch", yylstack[yysp]])
    break;

case 211:
    /*! Production::    TryBlock : Try Catch Finally */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TryBlock"]("Try Catch Finally", ...[yyvstack[yysp - 2], yyvstack[yysp - 1], yyvstack[yysp]]), { rule: "Try Catch Finally", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Try", yylstack[yysp - 2]], ["Catch", yylstack[yysp - 1]], ["Finally", yylstack[yysp]])
    break;

case 212:
    /*! Production::    Try : TRY Expression */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Try"]("TRY Expression", ...[yy.Block.wrap(yyvstack[yysp])]), { rule: "TRY Expression", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["TRY", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 213:
    /*! Production::    Try : TRY Block */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Try"]("TRY Block", ...[yyvstack[yysp]]), { rule: "TRY Block", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["TRY", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 214:
    /*! Production::    Finally : FINALLY Block */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Finally"]("FINALLY Block", ...[yyvstack[yysp]]), { rule: "FINALLY Block", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["FINALLY", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 215:
    /*! Production::    Finally : FINALLY Expression */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Finally"]("FINALLY Expression", ...[yy.Block.wrap(yyvstack[yysp])]), { rule: "FINALLY Expression", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["FINALLY", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 216:
    /*! Production::    Catch : CATCH Block */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Catch"]("CATCH Block", ...[null, yyvstack[yysp]]), { rule: "CATCH Block", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["CATCH", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 217:
    /*! Production::    Catch : CATCH Expression */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Catch"]("CATCH Expression", ...[null, yy.Block.wrap(yyvstack[yysp])]), { rule: "CATCH Expression", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["CATCH", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 218:
    /*! Production::    Catch : CATCH Identifier Block */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Catch"]("CATCH Identifier Block", ...[yyvstack[yysp - 1], yyvstack[yysp]]), { rule: "CATCH Identifier Block", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["CATCH", yylstack[yysp - 2]], ["Identifier", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 219:
    /*! Production::    Catch : CATCH Identifier THEN Block */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Catch"]("CATCH Identifier THEN Block", ...[yyvstack[yysp - 2], yyvstack[yysp]]), { rule: "CATCH Identifier THEN Block", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["CATCH", yylstack[yysp - 3]], ["Identifier", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 220:
    /*! Production::    Catch : CATCH Identifier THEN Expression */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Catch"]("CATCH Identifier THEN Expression", ...[yyvstack[yysp - 2], yy.Block.wrap(yyvstack[yysp])]), { rule: "CATCH Identifier THEN Expression", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["CATCH", yylstack[yysp - 3]], ["Identifier", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 221:
    /*! Production::    While : WhileUntil Expression THEN Block */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["While"]("WhileUntil Expression THEN Block", ...[yyvstack[yysp - 2], yyvstack[yysp].unwrap, yyvstack[yysp - 3]]), { rule: "WhileUntil Expression THEN Block", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["WhileUntil", yylstack[yysp - 3]], ["Expression", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 222:
    /*! Production::    While : WhileUntil Expression THEN Expression */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["While"]("WhileUntil Expression THEN Expression", ...[yyvstack[yysp - 2], yy.Block.wrap(yyvstack[yysp]), yyvstack[yysp - 3]]), { rule: "WhileUntil Expression THEN Expression", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["WhileUntil", yylstack[yysp - 3]], ["Expression", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 223:
    /*! Production::    While : WhileUntil "(" Expression ")" Expression */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["While"]("WhileUntil ( Expression ) Expression", ...[yyvstack[yysp - 2], yy.Block.wrap(yyvstack[yysp]), yyvstack[yysp - 4]]), { rule: "WhileUntil ( Expression ) Expression", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["WhileUntil", yylstack[yysp - 4]], ["(", yylstack[yysp - 3]], ["Expression", yylstack[yysp - 2]], [")", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 224:
    /*! Production::    While : WhileUntil Expression Block */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["While"]("WhileUntil Expression Block", ...[yyvstack[yysp - 1], yyvstack[yysp].unwrap, yyvstack[yysp - 2]]), { rule: "WhileUntil Expression Block", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["WhileUntil", yylstack[yysp - 2]], ["Expression", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 225:
    /*! Production::    While : Loop WhileUntil Expression */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["While"]("Loop WhileUntil Expression", ...[yyvstack[yysp], yyvstack[yysp - 2].unwrap, yyvstack[yysp - 1]]), { rule: "Loop WhileUntil Expression", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Loop", yylstack[yysp - 2]], ["WhileUntil", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 226:
    /*! Production::    While : Loop NEWLINE WhileUntil Expression */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["While"]("Loop NEWLINE WhileUntil Expression", ...[yyvstack[yysp], yyvstack[yysp - 3].unwrap, yyvstack[yysp - 1]]), { rule: "Loop NEWLINE WhileUntil Expression", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Loop", yylstack[yysp - 3]], ["NEWLINE", yylstack[yysp - 2]], ["WhileUntil", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 227:
    /*! Production::    While : Expression WhileUntil Expression */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["While"]("Expression WhileUntil Expression", ...[yyvstack[yysp], yy.Block.wrap(yyvstack[yysp - 2]), yyvstack[yysp - 1]]), { rule: "Expression WhileUntil Expression", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Expression", yylstack[yysp - 2]], ["WhileUntil", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 228:
    /*! Production::    WhileUntil : WHILE */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["WhileUntil"]("WHILE", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["WHILE", yylstack[yysp - 1]])
    break;

case 229:
    /*! Production::    WhileUntil : UNTIL */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["WhileUntil"]("UNTIL", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["UNTIL", yylstack[yysp - 1]])
    break;

case 230:
    /*! Production::    WhileUntil : POSTWHILE */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["WhileUntil"]("POSTWHILE", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["POSTWHILE", yylstack[yysp - 1]])
    break;

case 231:
    /*! Production::    WhileUntil : POSTUNTIL */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["WhileUntil"]("POSTUNTIL", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["POSTUNTIL", yylstack[yysp - 1]])
    break;

case 232:
    /*! Production::    Loop : LOOP Block */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Loop"]("LOOP Block", ...[yyvstack[yysp].unwrap]), { rule: "LOOP Block", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["LOOP", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 233:
    /*! Production::    Loop : LOOP Expression */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Loop"]("LOOP Expression", ...[yy.Block.wrap(yyvstack[yysp]).unwrap]), { rule: "LOOP Expression", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["LOOP", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 234:
    /*! Production::    Else : ElseOtherwise Block */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Else"]("ElseOtherwise Block", ...[yyvstack[yysp]]), { rule: "ElseOtherwise Block", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["ElseOtherwise", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 235:
    /*! Production::    Else : ElseOtherwise Expression */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Else"]("ElseOtherwise Expression", ...[yyvstack[yysp]]), { rule: "ElseOtherwise Expression", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["ElseOtherwise", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 236:
    /*! Production::    Else : ElseOtherwise Statement */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Else"]("ElseOtherwise Statement", ...[yyvstack[yysp]]), { rule: "ElseOtherwise Statement", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["ElseOtherwise", yylstack[yysp - 1]], ["Statement", yylstack[yysp]])
    break;

case 237:
    /*! Production::    Else : ElseOtherwise THEN Block */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Else"]("ElseOtherwise THEN Block", ...[yyvstack[yysp]]), { rule: "ElseOtherwise THEN Block", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["ElseOtherwise", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 238:
    /*! Production::    IfBlock : IfUnless Expression Block */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["IfBlock"]("IfUnless Expression Block", ...[yyvstack[yysp - 1], yyvstack[yysp], yyvstack[yysp - 2]]), { rule: "IfUnless Expression Block", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["IfUnless", yylstack[yysp - 2]], ["Expression", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 239:
    /*! Production::    IfBlock : IfUnless Expression THEN Block */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["IfBlock"]("IfUnless Expression THEN Block", ...[yyvstack[yysp - 2], yyvstack[yysp], yyvstack[yysp - 3]]), { rule: "IfUnless Expression THEN Block", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["IfUnless", yylstack[yysp - 3]], ["Expression", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 240:
    /*! Production::    IfBlock : IfUnless Expression THEN Expression */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["IfBlock"]("IfUnless Expression THEN Expression", ...[yyvstack[yysp - 2], yyvstack[yysp], yyvstack[yysp - 3]]), { rule: "IfUnless Expression THEN Expression", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["IfUnless", yylstack[yysp - 3]], ["Expression", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 241:
    /*! Production::    IfBlock : IfUnless "(" Expression ")" Expression */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["IfBlock"]("IfUnless ( Expression ) Expression", ...[yyvstack[yysp - 2], yyvstack[yysp], yyvstack[yysp - 4]]), { rule: "IfUnless ( Expression ) Expression", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["IfUnless", yylstack[yysp - 4]], ["(", yylstack[yysp - 3]], ["Expression", yylstack[yysp - 2]], [")", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 242:
    /*! Production::    IfBlock : IfUnless Expression THEN Statement */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["IfBlock"]("IfUnless Expression THEN Statement", ...[yyvstack[yysp - 2], yyvstack[yysp], yyvstack[yysp - 3]]), { rule: "IfUnless Expression THEN Statement", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["IfUnless", yylstack[yysp - 3]], ["Expression", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Statement", yylstack[yysp]])
    break;

case 243:
    /*! Production::    IfBlock : IfUnless Expression "{" Expression "}" */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["IfBlock"]("IfUnless Expression { Expression }", ...[yyvstack[yysp - 3], yyvstack[yysp - 1], yyvstack[yysp - 4]]), { rule: "IfUnless Expression { Expression }", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["IfUnless", yylstack[yysp - 4]], ["Expression", yylstack[yysp - 3]], ["{", yylstack[yysp - 2]], ["Expression", yylstack[yysp - 1]], ["}", yylstack[yysp]])
    break;

case 244:
    /*! Production::    IfBlock : IfUnless Expression THEN "{" Expression "}" */

    // default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 5, yysp);
    // END of default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["IfBlock"]("IfUnless Expression THEN { Expression }", ...[yyvstack[yysp - 4], yyvstack[yysp - 1], yyvstack[yysp - 5]]), { rule: "IfUnless Expression THEN { Expression }", loc: { first_line: yylstack[yysp - 5].first_line, first_column: yylstack[yysp - 5].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 5].src, type: yylstack[yysp - 5].type } }, {"first":1,"last":6,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["IfUnless", yylstack[yysp - 5]], ["Expression", yylstack[yysp - 4]], ["THEN", yylstack[yysp - 3]], ["{", yylstack[yysp - 2]], ["Expression", yylstack[yysp - 1]], ["}", yylstack[yysp]])
    break;

case 245:
    /*! Production::    IfBlock : IfUnless Expression THEN "{" Statement "}" */

    // default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 5, yysp);
    // END of default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["IfBlock"]("IfUnless Expression THEN { Statement }", ...[yyvstack[yysp - 4], yyvstack[yysp - 1], yyvstack[yysp - 5]]), { rule: "IfUnless Expression THEN { Statement }", loc: { first_line: yylstack[yysp - 5].first_line, first_column: yylstack[yysp - 5].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 5].src, type: yylstack[yysp - 5].type } }, {"first":1,"last":6,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["IfUnless", yylstack[yysp - 5]], ["Expression", yylstack[yysp - 4]], ["THEN", yylstack[yysp - 3]], ["{", yylstack[yysp - 2]], ["Statement", yylstack[yysp - 1]], ["}", yylstack[yysp]])
    break;

case 246:
    /*! Production::    IfUnless : IF */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["IfUnless"]("IF", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["IF", yylstack[yysp - 1]])
    break;

case 247:
    /*! Production::    IfUnless : UNLESS */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["IfUnless"]("UNLESS", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["UNLESS", yylstack[yysp - 1]])
    break;

case 248:
    /*! Production::    ElseOtherwise : ELSE */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["ElseOtherwise"]("ELSE", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["ELSE", yylstack[yysp - 1]])
    break;

case 249:
    /*! Production::    ElseOtherwise : OTHERWISE */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["ElseOtherwise"]("OTHERWISE", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["OTHERWISE", yylstack[yysp - 1]])
    break;

case 250:
    /*! Production::    ElseOtherwise : OR */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["ElseOtherwise"]("OR", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["OR", yylstack[yysp - 1]])
    break;

case 251:
    /*! Production::    Value : Assignable */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Value"]("Assignable", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Assignable", yylstack[yysp - 1]])
    break;

case 252:
    /*! Production::    Value : Parenthetical */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Value"]("Parenthetical", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Parenthetical", yylstack[yysp - 1]])
    break;

case 253:
    /*! Production::    Value : Literal */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Value"]("Literal", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Literal", yylstack[yysp - 1]])
    break;

case 254:
    /*! Production::    Value : Invocation */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Value"]("Invocation", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Invocation", yylstack[yysp - 1]])
    break;

case 255:
    /*! Production::    Value : Function */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Value"]("Function", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Function", yylstack[yysp - 1]])
    break;

case 256:
    /*! Production::    Value : New */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Value"]("New", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["New", yylstack[yysp - 1]])
    break;

case 257:
    /*! Production::    Value : This */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Value"]("This", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["This", yylstack[yysp - 1]])
    break;

case 258:
    /*! Production::    Value : Super */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Value"]("Super", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Super", yylstack[yysp - 1]])
    break;

case 259:
    /*! Production::    Value : SUCH */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Value"]("SUCH", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["SUCH", yylstack[yysp - 1]])
    break;

case 260:
    /*! Production::    New : NEW Expression */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["New"]("NEW Expression", ...[yyvstack[yysp]]), { rule: "NEW Expression", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["NEW", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 261:
    /*! Production::    Super : SUPER "." PROPERTY */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Super"]("SUPER . PROPERTY", ...[Object.assign([yyvstack[yysp]], { loc: yylstack[yysp] })]), { rule: "SUPER . PROPERTY", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["SUPER", yylstack[yysp - 2]], [".", yylstack[yysp - 1]], ["PROPERTY", yylstack[yysp]])
    break;

case 262:
    /*! Production::    Super : SUPER INDEX_START PROPERTY INDEX_END */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Super"]("SUPER INDEX_START PROPERTY INDEX_END", ...[yyvstack[yysp - 1]]), { rule: "SUPER INDEX_START PROPERTY INDEX_END", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["SUPER", yylstack[yysp - 3]], ["INDEX_START", yylstack[yysp - 2]], ["PROPERTY", yylstack[yysp - 1]], ["INDEX_END", yylstack[yysp]])
    break;

case 263:
    /*! Production::    This : THIS */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["This"]("THIS", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["THIS", yylstack[yysp - 1]])
    break;

case 264:
    /*! Production::    Parenthetical : "(" Expression ")" */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Parenthetical"]("( Expression )", ...[yyvstack[yysp - 1]]), { rule: "( Expression )", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["(", yylstack[yysp - 2]], ["Expression", yylstack[yysp - 1]], [")", yylstack[yysp]])
    break;

case 265:
    /*! Production::    Parenthetical : "(" Body ")" */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Parenthetical"]("( Body )", ...[yyvstack[yysp - 1]]), { rule: "( Body )", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["(", yylstack[yysp - 2]], ["Body", yylstack[yysp - 1]], [")", yylstack[yysp]])
    break;

case 266:
    /*! Production::    Parenthetical : "(" INDENT Body OUTDENT ")" */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Parenthetical"]("( INDENT Body OUTDENT )", ...[yyvstack[yysp - 2]]), { rule: "( INDENT Body OUTDENT )", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["(", yylstack[yysp - 4]], ["INDENT", yylstack[yysp - 3]], ["Body", yylstack[yysp - 2]], ["OUTDENT", yylstack[yysp - 1]], [")", yylstack[yysp]])
    break;

case 267:
    /*! Production::    ParamObject : "{" ParamPropList "}" */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ParamObject"]("{ ParamPropList }", ...[yyvstack[yysp - 1]]), { rule: "{ ParamPropList }", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp].type } }, {"first":1,"last":3,"typeOf":3,"checkGenerated":false}, { generated: undefined }).setTokens(["{", yylstack[yysp - 2]], ["ParamPropList", yylstack[yysp - 1]], ["}", yylstack[yysp]])
    break;

case 268:
    /*! Production::    ParamObject : "{" "}" */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ParamObject"]("{ }", ...[[]]), { rule: "{ }", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src } }, {"first":1,"last":2,"typeOf":0,"checkGenerated":false}, { generated: undefined }).setTokens(["{", yylstack[yysp - 1]], ["}", yylstack[yysp]])
    break;

case 269:
    /*! Production::    Object : "{" "}" */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Object"]("{ }", ...[[]]), { rule: "{ }", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["{", yylstack[yysp - 1]], ["}", yylstack[yysp]])
    break;

case 270:
    /*! Production::    Object : "{" PropList OptComma "}" */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Object"]("{ PropList OptComma }", ...[yyvstack[yysp - 2]]), { rule: "{ PropList OptComma }", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false,"indentOf":1}, { generated: undefined, indented: yylstack[yysp - 3].indented }).setTokens(["{", yylstack[yysp - 3]], ["PropList", yylstack[yysp - 2]], ["OptComma", yylstack[yysp - 1]], ["}", yylstack[yysp]])
    break;

case 271:
    /*! Production::    Object : "{" INDENT PropList OUTDENT "}" */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Object"]("{ INDENT PropList OUTDENT }", ...[yyvstack[yysp - 2]]), { rule: "{ INDENT PropList OUTDENT }", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false,"indented":true}, { generated: undefined }).setTokens(["{", yylstack[yysp - 4]], ["INDENT", yylstack[yysp - 3]], ["PropList", yylstack[yysp - 2]], ["OUTDENT", yylstack[yysp - 1]], ["}", yylstack[yysp]])
    break;

case 272:
    /*! Production::    PropList : PropObj */
case 277:
    /*! Production::    ParamPropList : ParamPropObj */
case 415:
    /*! Production::    ParamArrayArg : ParamAssignable */
case 419:
    /*! Production::    ArrayArg : Expression */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = [yyvstack[yysp]]
    break;

case 273:
    /*! Production::    PropList : PropList "," PropObj */
case 278:
    /*! Production::    ParamPropList : ParamPropList "," ParamPropObj */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = yyvstack[yysp - 2].push(yyvstack[yysp]) && yyvstack[yysp - 2]
    break;

case 274:
    /*! Production::    PropList : PropList OptComma NEWLINE PropObj */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = yyvstack[yysp - 3].push(yylstack[yysp - 1].generated, yyvstack[yysp]) && yyvstack[yysp - 3]
    break;

case 275:
    /*! Production::    PropList : PropList OptComma INDENT PropList OUTDENT */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = yyvstack[yysp - 4].concat(false, ...[yyvstack[yysp - 1]])
    break;

case 276:
    /*! Production::    ParamPropList : %epsilon */

    // default action (generated by JISON mode classic/merge :: 0,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(null, null, null, null, true);
    // END of default action (generated by JISON mode classic/merge :: 0,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = []
    break;

case 279:
    /*! Production::    ParamPropList : ParamPropList OptComma NEWLINE ParamPropObj */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = yyvstack[yysp - 3].push(yyvstack[yysp]) && yyvstack[yysp - 3]
    break;

case 280:
    /*! Production::    ParamPropList : ParamPropList OptComma INDENT ParamPropObj OUTDENT */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = yyvstack[yysp - 4].push(yyvstack[yysp - 1]) && yyvstack[yysp - 4]
    break;

case 282:
    /*! Production::    PropObj : PROPERTY ":" Expression */
case 285:
    /*! Production::    PropObj : AlphaNum ":" Expression */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = [yyvstack[yysp - 2], yyvstack[yysp], [yylstack[yysp - 2], yylstack[yysp]]]
    break;

case 283:
    /*! Production::    PropObj : PROPERTY ":" Block */
case 286:
    /*! Production::    PropObj : AlphaNum ":" Block */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = [yyvstack[yysp - 2], yy.Array.from(yyvstack[yysp]), [yylstack[yysp - 2], yylstack[yysp], true]]
    break;

case 284:
    /*! Production::    PropObj : PROPERTY ":" INDENT Expression OUTDENT */
case 287:
    /*! Production::    PropObj : AlphaNum ":" INDENT Expression OUTDENT */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = [yyvstack[yysp - 4], yyvstack[yysp - 1], [yylstack[yysp - 4], yylstack[yysp], true]]
    break;

case 288:
    /*! Production::    PropObj : "[" Expression "]" ":" Expression */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = [yyvstack[yysp - 3], yyvstack[yysp], [yylstack[yysp - 4], yylstack[yysp]]]
    break;

case 289:
    /*! Production::    PropObj : "[" Expression "]" ":" INDENT Expression OUTDENT */

    // default action (generated by JISON mode classic/merge :: 7,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 6, yysp);
    // END of default action (generated by JISON mode classic/merge :: 7,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = [yyvstack[yysp - 5], yyvstack[yysp - 1], [yylstack[yysp - 6], yylstack[yysp - 1], true]]
    break;

case 290:
    /*! Production::    PropObj : "[" Expression "]" ":" Block */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = [yyvstack[yysp - 3], yy.Array.from(yyvstack[yysp]), [yylstack[yysp - 4], yylstack[yysp], true]]
    break;

case 291:
    /*! Production::    PropObj : PROPERTY ":" */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = [yyvstack[yysp - 1], false, [yylstack[yysp - 1], yylstack[yysp]]]
    break;

case 292:
    /*! Production::    PropObj : "..." PROPERTY ":" */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = [yyvstack[yysp - 1], false, [yylstack[yysp - 2], yylstack[yysp]], true]
    break;

case 293:
    /*! Production::    PropObj : PROPERTY ":" "..." */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = [yyvstack[yysp - 2], false, [yylstack[yysp - 2], yylstack[yysp]], true]
    break;

case 294:
    /*! Production::    PropObj : Identifier */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = [yyvstack[yysp][1], false, [yylstack[yysp], yylstack[yysp]]]
    break;

case 296:
    /*! Production::    PropObj : "..." Value */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = yyvstack[yysp]
    break;

case 297:
    /*! Production::    PropObj : Value "..." */
case 535:
    /*! Production::    OptDefault : Identifier "," */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = yyvstack[yysp - 1]
    break;

case 298:
    /*! Production::    ParamPropObj : PROPERTY ":" ParamAssignable */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = [yyvstack[yysp - 2], yyvstack[yysp]]
    break;

case 299:
    /*! Production::    ParamPropObj : PROPERTY ":" */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = [yyvstack[yysp - 1]]
    break;

case 300:
    /*! Production::    ParamPropObj : PROPERTY ":" DEFAULTS Expression */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = [yyvstack[yysp - 3],,yyvstack[yysp]]
    break;

case 302:
    /*! Production::    ParamPropObj : ParamIdentifier DEFAULTS Expression */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = [yyvstack[yysp - 2],,yyvstack[yysp]]
    break;

case 303:
    /*! Production::    ParamPropObj : "..." PROPERTY ":" */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = [yyvstack[yysp - 1],,,true]
    break;

case 304:
    /*! Production::    ParamPropObj : PROPERTY ":" "..." */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = [yyvstack[yysp - 2],,,true]
    break;

case 305:
    /*! Production::    Literal : AlphaNum */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Literal"]("AlphaNum", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["AlphaNum", yylstack[yysp - 1]])
    break;

case 306:
    /*! Production::    Literal : Regex */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Literal"]("Regex", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Regex", yylstack[yysp - 1]])
    break;

case 307:
    /*! Production::    Literal : UNDEFINED */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Literal"]("UNDEFINED", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["UNDEFINED", yylstack[yysp - 1]])
    break;

case 308:
    /*! Production::    Literal : INFINITY */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Literal"]("INFINITY", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["INFINITY", yylstack[yysp - 1]])
    break;

case 309:
    /*! Production::    Literal : BOOL */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Literal"]("BOOL", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["BOOL", yylstack[yysp - 1]])
    break;

case 310:
    /*! Production::    Literal : NULL */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Literal"]("NULL", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["NULL", yylstack[yysp - 1]])
    break;

case 311:
    /*! Production::    Literal : NAN */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Literal"]("NAN", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["NAN", yylstack[yysp - 1]])
    break;

case 312:
    /*! Production::    AlphaNum : String */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["AlphaNum"]("String", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["String", yylstack[yysp - 1]])
    break;

case 313:
    /*! Production::    AlphaNum : NUMBER */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["AlphaNum"]("NUMBER", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["NUMBER", yylstack[yysp - 1]])
    break;

case 314:
    /*! Production::    String : STRING */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["String"]("STRING", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["STRING", yylstack[yysp - 1]])
    break;

case 315:
    /*! Production::    String : StringWithInterpolations */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["String"]("StringWithInterpolations", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["StringWithInterpolations", yylstack[yysp - 1]])
    break;

case 316:
    /*! Production::    StringWithInterpolations : STRING_START Interpolations STRING_END */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["StringWithInterpolations"]("STRING_START Interpolations STRING_END", ...[yyvstack[yysp - 1], yyvstack[yysp - 2]]), { rule: "STRING_START Interpolations STRING_END", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["STRING_START", yylstack[yysp - 2]], ["Interpolations", yylstack[yysp - 1]], ["STRING_END", yylstack[yysp]])
    break;

case 317:
    /*! Production::    Interpolations : Interpolation */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Interpolations"]("Interpolation", ...[yyvstack[yysp]]), { rule: "Interpolation", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Interpolation", yylstack[yysp]])
    break;

case 318:
    /*! Production::    Interpolations : Interpolations Interpolation */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Interpolations"]("Interpolations Interpolation", ...[...yyvstack[yysp - 1].contents, yyvstack[yysp]]), { rule: "Interpolations Interpolation", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Interpolations", yylstack[yysp - 1]], ["Interpolation", yylstack[yysp]])
    break;

case 319:
    /*! Production::    Interpolation : INTERPOLATION_START Expression INTERPOLATION_END */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Interpolation"]("INTERPOLATION_START Expression INTERPOLATION_END", ...[yyvstack[yysp - 1]]), { rule: "INTERPOLATION_START Expression INTERPOLATION_END", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["INTERPOLATION_START", yylstack[yysp - 2]], ["Expression", yylstack[yysp - 1]], ["INTERPOLATION_END", yylstack[yysp]])
    break;

case 320:
    /*! Production::    Interpolation : String */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Interpolation"]("String", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["String", yylstack[yysp - 1]])
    break;

case 321:
    /*! Production::    Regex : REGEX */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Regex"]("REGEX", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["REGEX", yylstack[yysp - 1]])
    break;

case 322:
    /*! Production::    Regex : RegexWithInterpolations */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Regex"]("RegexWithInterpolations", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["RegexWithInterpolations", yylstack[yysp - 1]])
    break;

case 323:
    /*! Production::    RegexWithInterpolations : REGEX_START RegexInterpolations REGEX_END */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["RegexWithInterpolations"]("REGEX_START RegexInterpolations REGEX_END", ...[yyvstack[yysp - 1], yyvstack[yysp]]), { rule: "REGEX_START RegexInterpolations REGEX_END", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["REGEX_START", yylstack[yysp - 2]], ["RegexInterpolations", yylstack[yysp - 1]], ["REGEX_END", yylstack[yysp]])
    break;

case 324:
    /*! Production::    RegexInterpolations : RegexInterpolation */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["RegexInterpolations"]("RegexInterpolation", ...[yyvstack[yysp]]), { rule: "RegexInterpolation", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["RegexInterpolation", yylstack[yysp]])
    break;

case 325:
    /*! Production::    RegexInterpolations : RegexInterpolations RegexInterpolation */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["RegexInterpolations"]("RegexInterpolations RegexInterpolation", ...[...yyvstack[yysp - 1].contents, yyvstack[yysp]]), { rule: "RegexInterpolations RegexInterpolation", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["RegexInterpolations", yylstack[yysp - 1]], ["RegexInterpolation", yylstack[yysp]])
    break;

case 326:
    /*! Production::    RegexInterpolation : INTERPOLATION_START Expression INTERPOLATION_END */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["RegexInterpolation"]("INTERPOLATION_START Expression INTERPOLATION_END", ...[yyvstack[yysp - 1]]), { rule: "INTERPOLATION_START Expression INTERPOLATION_END", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["INTERPOLATION_START", yylstack[yysp - 2]], ["Expression", yylstack[yysp - 1]], ["INTERPOLATION_END", yylstack[yysp]])
    break;

case 327:
    /*! Production::    RegexInterpolation : Regex */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["RegexInterpolation"]("Regex", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Regex", yylstack[yysp - 1]])
    break;

case 328:
    /*! Production::    Function : FuncHeader */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Function"]("FuncHeader", ...[yyvstack[yysp].contents, yy.Block.wrap(), { arguments: yyvstack[yysp][3] }]), { rule: "FuncHeader", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["FuncHeader", yylstack[yysp]])
    break;

case 329:
    /*! Production::    Function : FuncHeader FuncBody */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Function"]("FuncHeader FuncBody", ...[yyvstack[yysp - 1].contents, yyvstack[yysp].unwrap, { arguments: yyvstack[yysp - 1][3], returns: [yylstack[yysp - 1].type, yylstack[yysp].type].filter(Boolean) }]), { rule: "FuncHeader FuncBody", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["FuncHeader", yylstack[yysp - 1]], ["FuncBody", yylstack[yysp]])
    break;

case 330:
    /*! Production::    Function : FuncSpecifiers FuncHeader FuncBody */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Function"]("FuncSpecifiers FuncHeader FuncBody", ...[yyvstack[yysp - 1].contents, yyvstack[yysp].unwrap, { ...yyvstack[yysp - 2].unwrap, arguments: yyvstack[yysp - 1][3], returns: [yylstack[yysp - 1].type, yylstack[yysp].type].filter(Boolean) }]), { rule: "FuncSpecifiers FuncHeader FuncBody", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["FuncSpecifiers", yylstack[yysp - 2]], ["FuncHeader", yylstack[yysp - 1]], ["FuncBody", yylstack[yysp]])
    break;

case 331:
    /*! Production::    Function : FUNCTION FuncHeader FuncBody */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Function"]("FUNCTION FuncHeader FuncBody", ...[yyvstack[yysp - 1].contents, yyvstack[yysp].unwrap, { yields: yylstack[yysp - 2].origin === 'function*', arguments: yyvstack[yysp - 1][3], returns: [yylstack[yysp - 1].type, yylstack[yysp].type].filter(Boolean) }]), { rule: "FUNCTION FuncHeader FuncBody", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["FUNCTION", yylstack[yysp - 2]], ["FuncHeader", yylstack[yysp - 1]], ["FuncBody", yylstack[yysp]])
    break;

case 332:
    /*! Production::    Function : ASYNC FUNCTION FuncHeader FuncBody */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Function"]("ASYNC FUNCTION FuncHeader FuncBody", ...[yyvstack[yysp - 1].contents, yyvstack[yysp].unwrap, { async: true, yields: yylstack[yysp - 2].origin === 'function*', arguments: yyvstack[yysp - 1][3], returns: [yylstack[yysp - 1].type, yylstack[yysp].type].filter(Boolean) }]), { rule: "ASYNC FUNCTION FuncHeader FuncBody", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["ASYNC", yylstack[yysp - 3]], ["FUNCTION", yylstack[yysp - 2]], ["FuncHeader", yylstack[yysp - 1]], ["FuncBody", yylstack[yysp]])
    break;

case 333:
    /*! Production::    Function : FUNCTION WITH FuncBody */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Function"]("FUNCTION WITH FuncBody", ...[[], yyvstack[yysp].unwrap, { yields: yylstack[yysp - 2].origin === 'function*', returns: [yylstack[yysp].type].filter(Boolean) }]), { rule: "FUNCTION WITH FuncBody", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["FUNCTION", yylstack[yysp - 2]], ["WITH", yylstack[yysp - 1]], ["FuncBody", yylstack[yysp]])
    break;

case 334:
    /*! Production::    Function : FUNCTION WITH "<(" TypeArguments ")>" FuncBody */

    // default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 5, yysp);
    // END of default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Function"]("FUNCTION WITH <( TypeArguments )> FuncBody", ...[[], yyvstack[yysp].unwrap, { yields: yylstack[yysp - 5].origin === 'function*', arguments: yyvstack[yysp - 2], returns: [yylstack[yysp].type].filter(Boolean) }]), { rule: "FUNCTION WITH <( TypeArguments )> FuncBody", loc: { first_line: yylstack[yysp - 5].first_line, first_column: yylstack[yysp - 5].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 5].src, type: yylstack[yysp - 5].type } }, {"first":1,"last":6,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["FUNCTION", yylstack[yysp - 5]], ["WITH", yylstack[yysp - 4]], ["<(", yylstack[yysp - 3]], ["TypeArguments", yylstack[yysp - 2]], [")>", yylstack[yysp - 1]], ["FuncBody", yylstack[yysp]])
    break;

case 335:
    /*! Production::    Function : ASYNC FUNCTION WITH FuncBody */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Function"]("ASYNC FUNCTION WITH FuncBody", ...[[], yyvstack[yysp].unwrap, { async: true, yields: yylstack[yysp - 2].origin === 'function*', returns: [yylstack[yysp].type].filter(Boolean) }]), { rule: "ASYNC FUNCTION WITH FuncBody", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["ASYNC", yylstack[yysp - 3]], ["FUNCTION", yylstack[yysp - 2]], ["WITH", yylstack[yysp - 1]], ["FuncBody", yylstack[yysp]])
    break;

case 336:
    /*! Production::    Function : ASYNC FUNCTION WITH "<(" TypeArguments ")>" FuncBody */

    // default action (generated by JISON mode classic/merge :: 7,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 6, yysp);
    // END of default action (generated by JISON mode classic/merge :: 7,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Function"]("ASYNC FUNCTION WITH <( TypeArguments )> FuncBody", ...[[], yyvstack[yysp].unwrap, { async: true, yields: yylstack[yysp - 5].origin === 'function*', arguments: yyvstack[yysp - 2], returns: [yylstack[yysp].type].filter(Boolean) }]), { rule: "ASYNC FUNCTION WITH <( TypeArguments )> FuncBody", loc: { first_line: yylstack[yysp - 6].first_line, first_column: yylstack[yysp - 6].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 6].src, type: yylstack[yysp - 6].type } }, {"first":1,"last":7,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["ASYNC", yylstack[yysp - 6]], ["FUNCTION", yylstack[yysp - 5]], ["WITH", yylstack[yysp - 4]], ["<(", yylstack[yysp - 3]], ["TypeArguments", yylstack[yysp - 2]], [")>", yylstack[yysp - 1]], ["FuncBody", yylstack[yysp]])
    break;

case 337:
    /*! Production::    Function : WITH Block */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Function"]("WITH Block", ...[[], yyvstack[yysp].unwrap, {}]), { rule: "WITH Block", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["WITH", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 338:
    /*! Production::    Function : WITH "<(" TypeArguments ")>" Block */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Function"]("WITH <( TypeArguments )> Block", ...[[], yyvstack[yysp].unwrap, { arguments: yyvstack[yysp - 2] }]), { rule: "WITH <( TypeArguments )> Block", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["WITH", yylstack[yysp - 4]], ["<(", yylstack[yysp - 3]], ["TypeArguments", yylstack[yysp - 2]], [")>", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 339:
    /*! Production::    Function : WITH "<(" TypeArguments ")>" THEN Block */

    // default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 5, yysp);
    // END of default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Function"]("WITH <( TypeArguments )> THEN Block", ...[[], yyvstack[yysp].unwrap, { arguments: yyvstack[yysp - 3], returns: [yylstack[yysp - 1].type].filter(Boolean) }]), { rule: "WITH <( TypeArguments )> THEN Block", loc: { first_line: yylstack[yysp - 5].first_line, first_column: yylstack[yysp - 5].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 5].src, type: yylstack[yysp - 5].type } }, {"first":1,"last":6,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["WITH", yylstack[yysp - 5]], ["<(", yylstack[yysp - 4]], ["TypeArguments", yylstack[yysp - 3]], [")>", yylstack[yysp - 2]], ["THEN", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 340:
    /*! Production::    Function : FUNC_DIRECTIVE Block */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Function"]("FUNC_DIRECTIVE Block", ...[[], yyvstack[yysp].unwrap]), { rule: "FUNC_DIRECTIVE Block", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["FUNC_DIRECTIVE", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 341:
    /*! Production::    Function : Identifier TypeArguments? Params FUNC_DIRECTIVE Expression */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Function"]("Identifier TypeArguments? Params FUNC_DIRECTIVE Expression", ...[[yyvstack[yysp - 4], yyvstack[yysp - 2]], yy.Block.wrap(yyvstack[yysp]).setLoc(yylstack[yysp]), { arguments: yyvstack[yysp - 3].unwrap }]), { rule: "Identifier TypeArguments? Params FUNC_DIRECTIVE Expression", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Identifier", yylstack[yysp - 4]], ["TypeArguments?", yylstack[yysp - 3]], ["Params", yylstack[yysp - 2]], ["FUNC_DIRECTIVE", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 342:
    /*! Production::    Function : Identifier TypeArguments? Params FUNC_DIRECTIVE Block */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Function"]("Identifier TypeArguments? Params FUNC_DIRECTIVE Block", ...[[yyvstack[yysp - 4], yyvstack[yysp - 2]], yyvstack[yysp].unwrap, { arguments: yyvstack[yysp - 3].unwrap }]), { rule: "Identifier TypeArguments? Params FUNC_DIRECTIVE Block", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Identifier", yylstack[yysp - 4]], ["TypeArguments?", yylstack[yysp - 3]], ["Params", yylstack[yysp - 2]], ["FUNC_DIRECTIVE", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 343:
    /*! Production::    FuncBody : THEN Block */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["FuncBody"]("THEN Block", ...[yyvstack[yysp].unwrap.setLoc(yylstack[yysp - 1], yylstack[yysp])]), { rule: "THEN Block", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["THEN", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 344:
    /*! Production::    FuncBody : Block */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["FuncBody"]("Block", ...[yyvstack[yysp].unwrap.setLoc(yylstack[yysp])]), { rule: "Block", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src } }, {"first":1,"last":1,"typeOf":0,"checkGenerated":false}, { generated: undefined }).setTokens(["Block", yylstack[yysp]])
    break;

case 345:
    /*! Production::    FuncBody : THEN Expression */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["FuncBody"]("THEN Expression", ...[yy.Block.wrap(yyvstack[yysp]).setLoc(yylstack[yysp])]), { rule: "THEN Expression", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["THEN", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 346:
    /*! Production::    FuncSpecifiers : STATIC GET */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["FuncSpecifiers"]("STATIC GET", ...[{ static: true, get: true }]), { rule: "STATIC GET", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["STATIC", yylstack[yysp - 1]], ["GET", yylstack[yysp]])
    break;

case 347:
    /*! Production::    FuncSpecifiers : STATIC SET */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["FuncSpecifiers"]("STATIC SET", ...[{ static: true, set: true }]), { rule: "STATIC SET", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["STATIC", yylstack[yysp - 1]], ["SET", yylstack[yysp]])
    break;

case 348:
    /*! Production::    FuncSpecifiers : STATIC ASYNC */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["FuncSpecifiers"]("STATIC ASYNC", ...[{ static: true, async: true }]), { rule: "STATIC ASYNC", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["STATIC", yylstack[yysp - 1]], ["ASYNC", yylstack[yysp]])
    break;

case 349:
    /*! Production::    FuncSpecifiers : GET */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["FuncSpecifiers"]("GET", ...[{ get: true }]), { rule: "GET", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["GET", yylstack[yysp]])
    break;

case 350:
    /*! Production::    FuncSpecifiers : SET */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["FuncSpecifiers"]("SET", ...[{ set: true }]), { rule: "SET", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["SET", yylstack[yysp]])
    break;

case 351:
    /*! Production::    FuncSpecifiers : STATIC */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["FuncSpecifiers"]("STATIC", ...[{ static: true }]), { rule: "STATIC", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["STATIC", yylstack[yysp]])
    break;

case 352:
    /*! Production::    FuncSpecifiers : ASYNC */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["FuncSpecifiers"]("ASYNC", ...[{ async: true }]), { rule: "ASYNC", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["ASYNC", yylstack[yysp]])
    break;

case 353:
    /*! Production::    FuncHeader : Identifier TypeArguments? Params */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["FuncHeader"]("Identifier TypeArguments? Params", ...[yyvstack[yysp - 2], yyvstack[yysp], yyvstack[yysp - 1].unwrap]), { rule: "Identifier TypeArguments? Params", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp].type } }, {"first":1,"last":3,"typeOf":3,"checkGenerated":false}, { generated: undefined }).setTokens(["Identifier", yylstack[yysp - 2]], ["TypeArguments?", yylstack[yysp - 1]], ["Params", yylstack[yysp]])
    break;

case 354:
    /*! Production::    FuncHeader : Identifier WITH TypeArguments? Params */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["FuncHeader"]("Identifier WITH TypeArguments? Params", ...[yyvstack[yysp - 3], yyvstack[yysp], yyvstack[yysp - 1].unwrap]), { rule: "Identifier WITH TypeArguments? Params", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp].type } }, {"first":1,"last":4,"typeOf":4,"checkGenerated":false}, { generated: undefined }).setTokens(["Identifier", yylstack[yysp - 3]], ["WITH", yylstack[yysp - 2]], ["TypeArguments?", yylstack[yysp - 1]], ["Params", yylstack[yysp]])
    break;

case 355:
    /*! Production::    FuncHeader : Identifier TypeArguments? WITH Params */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["FuncHeader"]("Identifier TypeArguments? WITH Params", ...[yyvstack[yysp - 3], yyvstack[yysp], yyvstack[yysp - 2].unwrap]), { rule: "Identifier TypeArguments? WITH Params", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp].type } }, {"first":1,"last":4,"typeOf":4,"checkGenerated":false}, { generated: undefined }).setTokens(["Identifier", yylstack[yysp - 3]], ["TypeArguments?", yylstack[yysp - 2]], ["WITH", yylstack[yysp - 1]], ["Params", yylstack[yysp]])
    break;

case 356:
    /*! Production::    FuncHeader : WITH TypeArguments? Params */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["FuncHeader"]("WITH TypeArguments? Params", ...[null, yyvstack[yysp], yyvstack[yysp - 1].unwrap]), { rule: "WITH TypeArguments? Params", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp].type } }, {"first":1,"last":3,"typeOf":3,"checkGenerated":false}, { generated: undefined }).setTokens(["WITH", yylstack[yysp - 2]], ["TypeArguments?", yylstack[yysp - 1]], ["Params", yylstack[yysp]])
    break;

case 357:
    /*! Production::    FuncHeader : TypeArguments? WITH Params */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["FuncHeader"]("TypeArguments? WITH Params", ...[null, yyvstack[yysp], yyvstack[yysp - 2].unwrap]), { rule: "TypeArguments? WITH Params", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp].type } }, {"first":2,"last":3,"typeOf":3,"checkGenerated":false}, { generated: undefined }).setTokens(["TypeArguments?", yylstack[yysp - 2]], ["WITH", yylstack[yysp - 1]], ["Params", yylstack[yysp]])
    break;

case 358:
    /*! Production::    FuncHeader : Identifier TypeArguments? */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["FuncHeader"]("Identifier TypeArguments?", ...[yyvstack[yysp - 1], null, yyvstack[yysp].unwrap]), { rule: "Identifier TypeArguments?", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp - 1].last_line, last_column: yylstack[yysp - 1].last_column, src: yylstack[yysp - 1].src } }, {"first":1,"last":1,"typeOf":0,"checkGenerated":false}, { generated: undefined }).setTokens(["Identifier", yylstack[yysp - 1]], ["TypeArguments?", yylstack[yysp]])
    break;

case 359:
    /*! Production::    FuncHeader : Identifier TypeArguments? WITH */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["FuncHeader"]("Identifier TypeArguments? WITH", ...[yyvstack[yysp - 2], null, yyvstack[yysp - 1].unwrap]), { rule: "Identifier TypeArguments? WITH", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src } }, {"first":1,"last":3,"typeOf":0,"checkGenerated":false}, { generated: undefined }).setTokens(["Identifier", yylstack[yysp - 2]], ["TypeArguments?", yylstack[yysp - 1]], ["WITH", yylstack[yysp]])
    break;

case 360:
    /*! Production::    FuncHeader : Identifier WITH TypeArguments? */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["FuncHeader"]("Identifier WITH TypeArguments?", ...[yyvstack[yysp - 2], null, yyvstack[yysp].unwrap]), { rule: "Identifier WITH TypeArguments?", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp - 1].last_line, last_column: yylstack[yysp - 1].last_column, src: yylstack[yysp - 2].src } }, {"first":1,"last":2,"typeOf":0,"checkGenerated":false}, { generated: undefined }).setTokens(["Identifier", yylstack[yysp - 2]], ["WITH", yylstack[yysp - 1]], ["TypeArguments?", yylstack[yysp]])
    break;

case 361:
    /*! Production::    FuncHeader : TypeArguments? Params */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["FuncHeader"]("TypeArguments? Params", ...[null, yyvstack[yysp], yyvstack[yysp - 1].unwrap]), { rule: "TypeArguments? Params", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":2,"last":2,"typeOf":2,"checkGenerated":false}, { generated: undefined }).setTokens(["TypeArguments?", yylstack[yysp - 1]], ["Params", yylstack[yysp]])
    break;

case 362:
    /*! Production::    TypeArguments? : %epsilon */

    // default action (generated by JISON mode classic/merge :: 0,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(null, null, null, null, true);
    // END of default action (generated by JISON mode classic/merge :: 0,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeArguments?"]("", ...[undefined]), { rule: "", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["", yylstack[yysp]])
    break;

case 363:
    /*! Production::    TypeArguments? : "<(" TypeArguments ")>" */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeArguments?"]("<( TypeArguments )>", ...[yyvstack[yysp - 1]]), { rule: "<( TypeArguments )>", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["<(", yylstack[yysp - 2]], ["TypeArguments", yylstack[yysp - 1]], [")>", yylstack[yysp]])
    break;

case 364:
    /*! Production::    TypeArguments? : "<(" INDENT TypeArguments OUTDENT ")>" */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeArguments?"]("<( INDENT TypeArguments OUTDENT )>", ...[yyvstack[yysp - 2]]), { rule: "<( INDENT TypeArguments OUTDENT )>", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["<(", yylstack[yysp - 4]], ["INDENT", yylstack[yysp - 3]], ["TypeArguments", yylstack[yysp - 2]], ["OUTDENT", yylstack[yysp - 1]], [")>", yylstack[yysp]])
    break;

case 365:
    /*! Production::    Params : PARAM_START PARAM_END */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Params"]("PARAM_START PARAM_END", ...[[]]), { rule: "PARAM_START PARAM_END", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp].type } }, {"first":1,"last":2,"typeOf":2,"checkGenerated":false}, { generated: undefined }).setTokens(["PARAM_START", yylstack[yysp - 1]], ["PARAM_END", yylstack[yysp]])
    break;

case 366:
    /*! Production::    Params : PARAM_START ParamList PARAM_END */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Params"]("PARAM_START ParamList PARAM_END", ...[yyvstack[yysp - 1].setLoc(yylstack[yysp - 2], yylstack[yysp])]), { rule: "PARAM_START ParamList PARAM_END", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp].type } }, {"first":1,"last":3,"typeOf":3,"checkGenerated":false}, { generated: undefined }).setTokens(["PARAM_START", yylstack[yysp - 2]], ["ParamList", yylstack[yysp - 1]], ["PARAM_END", yylstack[yysp]])
    break;

case 367:
    /*! Production::    ParamList : Param */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ParamList"]("Param", ...[yyvstack[yysp]]), { rule: "Param", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Param", yylstack[yysp]])
    break;

case 368:
    /*! Production::    ParamList : ParamList "," Param */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ParamList"]("ParamList , Param", ...[...yyvstack[yysp - 2].addParam(yyvstack[yysp]).setLoc(yylstack[yysp - 2], yylstack[yysp])]), { rule: "ParamList , Param", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["ParamList", yylstack[yysp - 2]], [",", yylstack[yysp - 1]], ["Param", yylstack[yysp]])
    break;

case 369:
    /*! Production::    ParamList : ParamList OptComma NEWLINE Param */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ParamList"]("ParamList OptComma NEWLINE Param", ...[...yyvstack[yysp - 3].addParam(yyvstack[yysp])]), { rule: "ParamList OptComma NEWLINE Param", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["ParamList", yylstack[yysp - 3]], ["OptComma", yylstack[yysp - 2]], ["NEWLINE", yylstack[yysp - 1]], ["Param", yylstack[yysp]])
    break;

case 370:
    /*! Production::    ParamList : ParamList OptComma INDENT ParamList OptComma OUTDENT */

    // default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 5, yysp);
    // END of default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ParamList"]("ParamList OptComma INDENT ParamList OptComma OUTDENT", ...[...yyvstack[yysp - 5].addParams(yyvstack[yysp - 2].contents)]), { rule: "ParamList OptComma INDENT ParamList OptComma OUTDENT", loc: { first_line: yylstack[yysp - 5].first_line, first_column: yylstack[yysp - 5].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 5].src, type: yylstack[yysp - 5].type } }, {"first":1,"last":6,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["ParamList", yylstack[yysp - 5]], ["OptComma", yylstack[yysp - 4]], ["INDENT", yylstack[yysp - 3]], ["ParamList", yylstack[yysp - 2]], ["OptComma", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 371:
    /*! Production::    Param : ParamAssignable */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Param"]("ParamAssignable", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["ParamAssignable", yylstack[yysp - 1]])
    break;

case 372:
    /*! Production::    Assign : Assignment */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Assign"]("Assignment", ...[yyvstack[yysp]]), { rule: "Assignment", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Assignment", yylstack[yysp]])
    break;

case 373:
    /*! Production::    Assignment : Assignable AssignKeyword Expression */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Assignment"]("Assignable AssignKeyword Expression", ...[yyvstack[yysp - 2], yyvstack[yysp], yyvstack[yysp - 1]]), { rule: "Assignable AssignKeyword Expression", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Assignable", yylstack[yysp - 2]], ["AssignKeyword", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 374:
    /*! Production::    Assignment : Assignable AssignKeyword INDENT Expression OUTDENT */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Assignment"]("Assignable AssignKeyword INDENT Expression OUTDENT", ...[yyvstack[yysp - 4], yyvstack[yysp - 1], yyvstack[yysp - 3]]), { rule: "Assignable AssignKeyword INDENT Expression OUTDENT", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Assignable", yylstack[yysp - 4]], ["AssignKeyword", yylstack[yysp - 3]], ["INDENT", yylstack[yysp - 2]], ["Expression", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 375:
    /*! Production::    Assignment : Assignable AssignKeyword NEWLINE Expression */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Assignment"]("Assignable AssignKeyword NEWLINE Expression", ...[yyvstack[yysp - 3], yyvstack[yysp], yyvstack[yysp - 2]]), { rule: "Assignable AssignKeyword NEWLINE Expression", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Assignable", yylstack[yysp - 3]], ["AssignKeyword", yylstack[yysp - 2]], ["NEWLINE", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 376:
    /*! Production::    Assignment : Assignable AssignKeyword Block */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Assignment"]("Assignable AssignKeyword Block", ...[yyvstack[yysp - 2], yy.Array.from(yyvstack[yysp]), yyvstack[yysp - 1]]), { rule: "Assignable AssignKeyword Block", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Assignable", yylstack[yysp - 2]], ["AssignKeyword", yylstack[yysp - 1]], ["Block", yylstack[yysp]])
    break;

case 377:
    /*! Production::    AssignKeyword : AS */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["AssignKeyword"]("AS", ...[yylstack[yysp].origin]), { rule: "AS", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["AS", yylstack[yysp]])
    break;

case 378:
    /*! Production::    AssignKeyword : AT */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["AssignKeyword"]("AT", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["AT", yylstack[yysp - 1]])
    break;

case 379:
    /*! Production::    AssignKeyword : FROM */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["AssignKeyword"]("FROM", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["FROM", yylstack[yysp - 1]])
    break;

case 380:
    /*! Production::    Assignable : Identifier */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Assignable"]("Identifier", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Identifier", yylstack[yysp - 1]])
    break;

case 381:
    /*! Production::    Assignable : ARGUMENT */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Assignable"]("ARGUMENT", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["ARGUMENT", yylstack[yysp - 1]])
    break;

case 382:
    /*! Production::    Assignable : Object */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Assignable"]("Object", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Object", yylstack[yysp - 1]])
    break;

case 383:
    /*! Production::    Assignable : Array */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Assignable"]("Array", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Array", yylstack[yysp - 1]])
    break;

case 384:
    /*! Production::    Assignable : Value Access */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Assignable"]("Value Access", ...[yyvstack[yysp - 1], yyvstack[yysp]]), { rule: "Value Access", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp].type } }, {"first":1,"last":2,"typeOf":2,"checkGenerated":false}, { generated: undefined }).setTokens(["Value", yylstack[yysp - 1]], ["Access", yylstack[yysp]])
    break;

case 385:
    /*! Production::    Assignable : Expression IN Expression */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Assignable"]("Expression IN Expression", ...[yyvstack[yysp], yyvstack[yysp - 2]]), { rule: "Expression IN Expression", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Expression", yylstack[yysp - 2]], ["IN", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 386:
    /*! Production::    ParamAssignable : ParamIdentifier */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["ParamAssignable"]("ParamIdentifier", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["ParamIdentifier", yylstack[yysp - 1]])
    break;

case 387:
    /*! Production::    ParamAssignable : ParamObject */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["ParamAssignable"]("ParamObject", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["ParamObject", yylstack[yysp - 1]])
    break;

case 388:
    /*! Production::    ParamAssignable : ParamObject DEFAULTS Expression */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy.ParamAssignable('ParamObject', yyvstack[yysp - 2].defaults(yyvstack[yysp])).setLocation(yylstack[yysp - 2], yylstack[yysp])
    break;

case 389:
    /*! Production::    ParamAssignable : ParamArray */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["ParamAssignable"]("ParamArray", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["ParamArray", yylstack[yysp - 1]])
    break;

case 390:
    /*! Production::    ParamAssignable : ParamArray DEFAULTS Expression */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy.ParamAssignable('ParamArray', yyvstack[yysp - 2].defaults(yyvstack[yysp])).setLocation(yylstack[yysp - 2], yylstack[yysp])
    break;

case 391:
    /*! Production::    Identifier : IDENTIFIER */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Identifier"]("IDENTIFIER", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["IDENTIFIER", yylstack[yysp - 1]])
    break;

case 392:
    /*! Production::    ParamIdentifier : IDENTIFIER */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ParamIdentifier"]("IDENTIFIER", ...[yyvstack[yysp]]), { rule: "IDENTIFIER", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["IDENTIFIER", yylstack[yysp]])
    break;

case 393:
    /*! Production::    ParamIdentifier : "..." IDENTIFIER */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ParamIdentifier"]("... IDENTIFIER", ...[yyvstack[yysp]]), { rule: "... IDENTIFIER", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false,"expansion":true}, { generated: undefined }).setTokens(["...", yylstack[yysp - 1]], ["IDENTIFIER", yylstack[yysp]])
    break;

case 394:
    /*! Production::    ParamIdentifier : IDENTIFIER "..." */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ParamIdentifier"]("IDENTIFIER ...", ...[yyvstack[yysp - 1]]), { rule: "IDENTIFIER ...", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false,"expansion":true}, { generated: undefined }).setTokens(["IDENTIFIER", yylstack[yysp - 1]], ["...", yylstack[yysp]])
    break;

case 395:
    /*! Production::    ParamIdentifier : IDENTIFIER DEFAULTS Expression */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ParamIdentifier"]("IDENTIFIER DEFAULTS Expression", ...[yyvstack[yysp - 2],,yyvstack[yysp]]), { rule: "IDENTIFIER DEFAULTS Expression", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["IDENTIFIER", yylstack[yysp - 2]], ["DEFAULTS", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 396:
    /*! Production::    ParamIdentifier : THIS "." PROPERTY */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ParamIdentifier"]("THIS . PROPERTY", ...[yyvstack[yysp], true]), { rule: "THIS . PROPERTY", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["THIS", yylstack[yysp - 2]], [".", yylstack[yysp - 1]], ["PROPERTY", yylstack[yysp]])
    break;

case 397:
    /*! Production::    ParamIdentifier : THIS "." PROPERTY DEFAULTS Expression */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ParamIdentifier"]("THIS . PROPERTY DEFAULTS Expression", ...[yyvstack[yysp - 2],true,yyvstack[yysp]]), { rule: "THIS . PROPERTY DEFAULTS Expression", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["THIS", yylstack[yysp - 4]], [".", yylstack[yysp - 3]], ["PROPERTY", yylstack[yysp - 2]], ["DEFAULTS", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 398:
    /*! Production::    ParamIdentifier : THIS "." PROPERTY "..." */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ParamIdentifier"]("THIS . PROPERTY ...", ...[yyvstack[yysp - 1], true]), { rule: "THIS . PROPERTY ...", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false,"expansion":true}, { generated: undefined }).setTokens(["THIS", yylstack[yysp - 3]], [".", yylstack[yysp - 2]], ["PROPERTY", yylstack[yysp - 1]], ["...", yylstack[yysp]])
    break;

case 399:
    /*! Production::    ParamIdentifier : "..." THIS "." PROPERTY */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ParamIdentifier"]("... THIS . PROPERTY", ...[yyvstack[yysp], true]), { rule: "... THIS . PROPERTY", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false,"expansion":true}, { generated: undefined }).setTokens(["...", yylstack[yysp - 3]], ["THIS", yylstack[yysp - 2]], [".", yylstack[yysp - 1]], ["PROPERTY", yylstack[yysp]])
    break;

case 400:
    /*! Production::    ParamIdentifier : THIS */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ParamIdentifier"]("THIS", ...[yyvstack[yysp],,,true]), { rule: "THIS", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["THIS", yylstack[yysp]])
    break;

case 401:
    /*! Production::    Access : "." PROPERTY */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Access"](". PROPERTY", ...[Object.assign([yyvstack[yysp]], { loc: yylstack[yysp] }), yylstack[yysp - 1].origin === '?.']), { rule: ". PROPERTY", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp].type } }, {"first":1,"last":2,"typeOf":2,"checkGenerated":false}, { generated: undefined }).setTokens([".", yylstack[yysp - 1]], ["PROPERTY", yylstack[yysp]])
    break;

case 402:
    /*! Production::    Access : INDEX_START Expression INDEX_END */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Access"]("INDEX_START Expression INDEX_END", ...[yyvstack[yysp - 1]]), { rule: "INDEX_START Expression INDEX_END", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp].type } }, {"first":1,"last":3,"typeOf":3,"checkGenerated":false}, { generated: undefined }).setTokens(["INDEX_START", yylstack[yysp - 2]], ["Expression", yylstack[yysp - 1]], ["INDEX_END", yylstack[yysp]])
    break;

case 403:
    /*! Production::    ParamArray : "[" "]" */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ParamArray"]("[ ]", ...[/* */]), { rule: "[ ]", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src } }, {"first":1,"last":2,"typeOf":0,"checkGenerated":false}, { generated: undefined }).setTokens(["[", yylstack[yysp - 1]], ["]", yylstack[yysp]])
    break;

case 404:
    /*! Production::    ParamArray : "[" ParamArrayList OptVoids "]" */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ParamArray"]("[ ParamArrayList OptVoids ]", ...[yyvstack[yysp - 2]]), { rule: "[ ParamArrayList OptVoids ]", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp].type } }, {"first":1,"last":4,"typeOf":4,"checkGenerated":false}, { generated: undefined }).setTokens(["[", yylstack[yysp - 3]], ["ParamArrayList", yylstack[yysp - 2]], ["OptVoids", yylstack[yysp - 1]], ["]", yylstack[yysp]])
    break;

case 405:
    /*! Production::    Array : "[" "]" */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Array"]("[ ]", ...[/* */]), { rule: "[ ]", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":1}, { generated: yylstack[yysp - 1].generated }).setTokens(["[", yylstack[yysp - 1]], ["]", yylstack[yysp]])
    break;

case 406:
    /*! Production::    Array : "[" ArrayList OptVoids "]" */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Array"]("[ ArrayList OptVoids ]", ...[...yyvstack[yysp - 2]]), { rule: "[ ArrayList OptVoids ]", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":1}, { generated: yylstack[yysp - 3].generated }).setTokens(["[", yylstack[yysp - 3]], ["ArrayList", yylstack[yysp - 2]], ["OptVoids", yylstack[yysp - 1]], ["]", yylstack[yysp]])
    break;

case 407:
    /*! Production::    Array : "[" INDENT ArrayList OptVoids OUTDENT "]" */

    // default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 5, yysp);
    // END of default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Array"]("[ INDENT ArrayList OptVoids OUTDENT ]", ...[...yyvstack[yysp - 3]]), { rule: "[ INDENT ArrayList OptVoids OUTDENT ]", loc: { first_line: yylstack[yysp - 5].first_line, first_column: yylstack[yysp - 5].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 5].src, type: yylstack[yysp - 5].type } }, {"first":1,"last":6,"typeOf":1,"checkGenerated":1,"indented":true}, { generated: yylstack[yysp - 5].generated }).setTokens(["[", yylstack[yysp - 5]], ["INDENT", yylstack[yysp - 4]], ["ArrayList", yylstack[yysp - 3]], ["OptVoids", yylstack[yysp - 2]], ["OUTDENT", yylstack[yysp - 1]], ["]", yylstack[yysp]])
    break;

case 408:
    /*! Production::    ParamArrayList : ParamArrayArg */
case 411:
    /*! Production::    ArrayList : ArrayArg */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = [...yyvstack[yysp]]
    break;

case 409:
    /*! Production::    ParamArrayList : ParamArrayList "," ParamArrayArg */
case 412:
    /*! Production::    ArrayList : ArrayList "," ArrayArg */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = yyvstack[yysp - 2].concat(yyvstack[yysp])
    break;

case 410:
    /*! Production::    ParamArrayList : ParamArrayList OptComma NEWLINE ParamArrayArg */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = yyvstack[yysp - 3].concat(yyvstack[yysp])
    break;

case 413:
    /*! Production::    ArrayList : ArrayList OptComma INDENT ArrayList OptVoids OUTDENT */

    // default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 5, yysp);
    // END of default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = yyvstack[yysp - 5].concat(false, yyvstack[yysp - 2])
    break;

case 414:
    /*! Production::    ArrayList : ArrayList OptComma NEWLINE ArrayArg */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = yyvstack[yysp - 3].concat(yylstack[yysp - 1].generated, yyvstack[yysp])
    break;

case 416:
    /*! Production::    ParamArrayArg : Voids ParamAssignable */
case 420:
    /*! Production::    ArrayArg : Voids Expression */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = [...yyvstack[yysp - 1], yyvstack[yysp]]
    break;

case 417:
    /*! Production::    ArrayArg : "..." Expression */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = [Object.assign(yyvstack[yysp], { expansion: true })]
    break;

case 418:
    /*! Production::    ArrayArg : Expression "..." */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = [Object.assign(yyvstack[yysp - 1], { expansion: true })]
    break;

case 421:
    /*! Production::    OptVoids : %epsilon */
case 534:
    /*! Production::    OptDefault : %epsilon */

    // default action (generated by JISON mode classic/merge :: 0,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(null, null, null, null, true);
    // END of default action (generated by JISON mode classic/merge :: 0,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = undefined
    break;

case 423:
    /*! Production::    Voids : "," */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = [null]
    break;

case 424:
    /*! Production::    Voids : "," Voids */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = [null, ...yyvstack[yysp - 1]]
    break;

case 425:
    /*! Production::    Voids : "," NEWLINE Voids */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = [null, ...yyvstack[yysp - 1]]
    break;

case 426:
    /*! Production::    Statement : Return */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Statement"]("Return", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Return", yylstack[yysp - 1]])
    break;

case 427:
    /*! Production::    Statement : BREAK Identifier */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Statement"]("BREAK Identifier", ...[yyvstack[yysp]]), { rule: "BREAK Identifier", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["BREAK", yylstack[yysp - 1]], ["Identifier", yylstack[yysp]])
    break;

case 428:
    /*! Production::    Statement : BREAK */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Statement"]("BREAK", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["BREAK", yylstack[yysp - 1]])
    break;

case 429:
    /*! Production::    Statement : CONTINUE Identifier */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Statement"]("CONTINUE Identifier", ...[yyvstack[yysp]]), { rule: "CONTINUE Identifier", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["CONTINUE", yylstack[yysp - 1]], ["Identifier", yylstack[yysp]])
    break;

case 430:
    /*! Production::    Statement : CONTINUE */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Statement"]("CONTINUE", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["CONTINUE", yylstack[yysp - 1]])
    break;

case 431:
    /*! Production::    Statement : Import */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Statement"]("Import", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Import", yylstack[yysp - 1]])
    break;

case 432:
    /*! Production::    Statement : Export */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Statement"]("Export", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Export", yylstack[yysp - 1]])
    break;

case 433:
    /*! Production::    Statement : Declare */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Statement"]("Declare", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Declare", yylstack[yysp - 1]])
    break;

case 434:
    /*! Production::    Statement : THROW Expression */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Statement"]("THROW Expression", ...[yyvstack[yysp]]), { rule: "THROW Expression", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["THROW", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 435:
    /*! Production::    Statement : THROW INDENT Expression OUTDENT */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Statement"]("THROW INDENT Expression OUTDENT", ...[yyvstack[yysp - 1]]), { rule: "THROW INDENT Expression OUTDENT", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["THROW", yylstack[yysp - 3]], ["INDENT", yylstack[yysp - 2]], ["Expression", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 436:
    /*! Production::    Statement : Type */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Statement"]("Type", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Type", yylstack[yysp - 1]])
    break;

case 437:
    /*! Production::    Statement : Interface */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Statement"]("Interface", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Interface", yylstack[yysp - 1]])
    break;

case 438:
    /*! Production::    Interface : INTERFACE Identifier TypeArguments? InterfaceBody */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Interface"]("INTERFACE Identifier TypeArguments? InterfaceBody", ...[yyvstack[yysp - 2], yyvstack[yysp - 1], yyvstack[yysp]]), { rule: "INTERFACE Identifier TypeArguments? InterfaceBody", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["INTERFACE", yylstack[yysp - 3]], ["Identifier", yylstack[yysp - 2]], ["TypeArguments?", yylstack[yysp - 1]], ["InterfaceBody", yylstack[yysp]])
    break;

case 439:
    /*! Production::    Interface : INTERFACE Identifier TypeArguments? INDENT InterfaceBody OUTDENT */

    // default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 5, yysp);
    // END of default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Interface"]("INTERFACE Identifier TypeArguments? INDENT InterfaceBody OUTDENT", ...[yyvstack[yysp - 4], yyvstack[yysp - 3], yyvstack[yysp - 1]]), { rule: "INTERFACE Identifier TypeArguments? INDENT InterfaceBody OUTDENT", loc: { first_line: yylstack[yysp - 5].first_line, first_column: yylstack[yysp - 5].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 5].src, type: yylstack[yysp - 5].type } }, {"first":1,"last":6,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["INTERFACE", yylstack[yysp - 5]], ["Identifier", yylstack[yysp - 4]], ["TypeArguments?", yylstack[yysp - 3]], ["INDENT", yylstack[yysp - 2]], ["InterfaceBody", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 440:
    /*! Production::    InterfaceBody : "{" "}" */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["InterfaceBody"]("{ }", ...[[]]), { rule: "{ }", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["{", yylstack[yysp - 1]], ["}", yylstack[yysp]])
    break;

case 441:
    /*! Production::    InterfaceBody : "{" InterfaceProperties "}" */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["InterfaceBody"]("{ InterfaceProperties }", ...[yyvstack[yysp - 1].contents]), { rule: "{ InterfaceProperties }", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["{", yylstack[yysp - 2]], ["InterfaceProperties", yylstack[yysp - 1]], ["}", yylstack[yysp]])
    break;

case 442:
    /*! Production::    InterfaceBody : "{" INDENT InterfaceProperties OUTDENT "}" */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["InterfaceBody"]("{ INDENT InterfaceProperties OUTDENT }", ...[yyvstack[yysp - 2].contents]), { rule: "{ INDENT InterfaceProperties OUTDENT }", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["{", yylstack[yysp - 4]], ["INDENT", yylstack[yysp - 3]], ["InterfaceProperties", yylstack[yysp - 2]], ["OUTDENT", yylstack[yysp - 1]], ["}", yylstack[yysp]])
    break;

case 443:
    /*! Production::    InterfaceProperties : InterfaceProperty */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["InterfaceProperties"]("InterfaceProperty", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["InterfaceProperty", yylstack[yysp - 1]])
    break;

case 444:
    /*! Production::    InterfaceProperties : InterfaceProperties "," InterfaceProperty */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["InterfaceProperties"]("InterfaceProperties , InterfaceProperty", ...[...yyvstack[yysp - 2].unwrap, yyvstack[yysp]]), { rule: "InterfaceProperties , InterfaceProperty", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["InterfaceProperties", yylstack[yysp - 2]], [",", yylstack[yysp - 1]], ["InterfaceProperty", yylstack[yysp]])
    break;

case 445:
    /*! Production::    InterfaceProperties : InterfaceProperties OptComma NEWLINE InterfaceProperty */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["InterfaceProperties"]("InterfaceProperties OptComma NEWLINE InterfaceProperty", ...[...yyvstack[yysp - 3].unwrap, yyvstack[yysp]]), { rule: "InterfaceProperties OptComma NEWLINE InterfaceProperty", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["InterfaceProperties", yylstack[yysp - 3]], ["OptComma", yylstack[yysp - 2]], ["NEWLINE", yylstack[yysp - 1]], ["InterfaceProperty", yylstack[yysp]])
    break;

case 446:
    /*! Production::    InterfaceProperties : InterfaceProperties OptComma INDENT InterfaceProperty OUTDENT */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["InterfaceProperties"]("InterfaceProperties OptComma INDENT InterfaceProperty OUTDENT", ...[...yyvstack[yysp - 4].unwrap, yyvstack[yysp - 1]]), { rule: "InterfaceProperties OptComma INDENT InterfaceProperty OUTDENT", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["InterfaceProperties", yylstack[yysp - 4]], ["OptComma", yylstack[yysp - 3]], ["INDENT", yylstack[yysp - 2]], ["InterfaceProperty", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 447:
    /*! Production::    InterfaceProperty : InterfaceKeyword? TypeArguments? Identifier? Params ":" TypeSentence */

    // default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 5, yysp);
    // END of default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["InterfaceProperty"]("InterfaceKeyword? TypeArguments? Identifier? Params : TypeSentence", ...[yyvstack[yysp - 3].unwrap, yyvstack[yysp], yyvstack[yysp - 2], { ...yyvstack[yysp - 5].unwrap, arguments: yyvstack[yysp - 4].unwrap, optional: yylstack[yysp - 4].origin === "?:" }]), { rule: "InterfaceKeyword? TypeArguments? Identifier? Params : TypeSentence", loc: { first_line: yylstack[yysp - 5].first_line, first_column: yylstack[yysp - 5].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 5].src, type: yylstack[yysp - 5].type } }, {"first":1,"last":6,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["InterfaceKeyword?", yylstack[yysp - 5]], ["TypeArguments?", yylstack[yysp - 4]], ["Identifier?", yylstack[yysp - 3]], ["Params", yylstack[yysp - 2]], [":", yylstack[yysp - 1]], ["TypeSentence", yylstack[yysp]])
    break;

case 448:
    /*! Production::    InterfaceProperty : PROPERTY ":" TypeSentence */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["InterfaceProperty"]("PROPERTY : TypeSentence", ...[new yy.Identifier(null, yyvstack[yysp - 2]).setLoc(yylstack[yysp - 2]), yyvstack[yysp], null, { optional: yylstack[yysp - 1].origin === "?:" }]), { rule: "PROPERTY : TypeSentence", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["PROPERTY", yylstack[yysp - 2]], [":", yylstack[yysp - 1]], ["TypeSentence", yylstack[yysp]])
    break;

case 449:
    /*! Production::    InterfaceProperty : READONLY PROPERTY ":" TypeSentence */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["InterfaceProperty"]("READONLY PROPERTY : TypeSentence", ...[new yy.Identifier(null, yyvstack[yysp - 2]).setLoc(yylstack[yysp - 2]), yyvstack[yysp], null, { optional: yylstack[yysp - 1].origin === "?:", readonly: true }]), { rule: "READONLY PROPERTY : TypeSentence", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["READONLY", yylstack[yysp - 3]], ["PROPERTY", yylstack[yysp - 2]], [":", yylstack[yysp - 1]], ["TypeSentence", yylstack[yysp]])
    break;

case 450:
    /*! Production::    InterfaceKeyword? : %epsilon */

    // default action (generated by JISON mode classic/merge :: 0,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(null, null, null, null, true);
    // END of default action (generated by JISON mode classic/merge :: 0,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["InterfaceKeyword?"]("", ...[undefined]), { rule: "", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["", yylstack[yysp]])
    break;

case 451:
    /*! Production::    InterfaceKeyword? : NEW */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["InterfaceKeyword?"]("NEW", ...[{ new: true }]), { rule: "NEW", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["NEW", yylstack[yysp]])
    break;

case 452:
    /*! Production::    InterfaceKeyword? : READONLY */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["InterfaceKeyword?"]("READONLY", ...[{ readonly: true }]), { rule: "READONLY", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["READONLY", yylstack[yysp]])
    break;

case 453:
    /*! Production::    Identifier? : %epsilon */

    // default action (generated by JISON mode classic/merge :: 0,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(null, null, null, null, true);
    // END of default action (generated by JISON mode classic/merge :: 0,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Identifier?"]("", ...[undefined]), { rule: "", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["", yylstack[yysp]])
    break;

case 454:
    /*! Production::    Identifier? : Identifier */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Identifier?"]("Identifier", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Identifier", yylstack[yysp - 1]])
    break;

case 455:
    /*! Production::    Type : TYPE TypeDeclaration */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Type"]("TYPE TypeDeclaration", ...[yyvstack[yysp]]), { rule: "TYPE TypeDeclaration", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["TYPE", yylstack[yysp - 1]], ["TypeDeclaration", yylstack[yysp]])
    break;

case 456:
    /*! Production::    Type : TYPE INDENT TypeDeclaration OUTDENT */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Type"]("TYPE INDENT TypeDeclaration OUTDENT", ...[yyvstack[yysp - 1]]), { rule: "TYPE INDENT TypeDeclaration OUTDENT", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["TYPE", yylstack[yysp - 3]], ["INDENT", yylstack[yysp - 2]], ["TypeDeclaration", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 457:
    /*! Production::    Type : TYPE NEWLINE TypeDeclaration */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Type"]("TYPE NEWLINE TypeDeclaration", ...[yyvstack[yysp]]), { rule: "TYPE NEWLINE TypeDeclaration", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["TYPE", yylstack[yysp - 2]], ["NEWLINE", yylstack[yysp - 1]], ["TypeDeclaration", yylstack[yysp]])
    break;

case 458:
    /*! Production::    TypeDeclaration : Identifier TypeArguments? AS TypeSentence */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeDeclaration"]("Identifier TypeArguments? AS TypeSentence", ...[yyvstack[yysp - 3], yyvstack[yysp], yyvstack[yysp - 2].unwrap]), { rule: "Identifier TypeArguments? AS TypeSentence", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Identifier", yylstack[yysp - 3]], ["TypeArguments?", yylstack[yysp - 2]], ["AS", yylstack[yysp - 1]], ["TypeSentence", yylstack[yysp]])
    break;

case 459:
    /*! Production::    TypeDeclaration : Identifier TypeArguments? AS INDENT TypeSentence OUTDENT */

    // default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 5, yysp);
    // END of default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeDeclaration"]("Identifier TypeArguments? AS INDENT TypeSentence OUTDENT", ...[yyvstack[yysp - 5], yyvstack[yysp - 1], yyvstack[yysp - 4].unwrap]), { rule: "Identifier TypeArguments? AS INDENT TypeSentence OUTDENT", loc: { first_line: yylstack[yysp - 5].first_line, first_column: yylstack[yysp - 5].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 5].src, type: yylstack[yysp - 5].type } }, {"first":1,"last":6,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Identifier", yylstack[yysp - 5]], ["TypeArguments?", yylstack[yysp - 4]], ["AS", yylstack[yysp - 3]], ["INDENT", yylstack[yysp - 2]], ["TypeSentence", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 460:
    /*! Production::    TypeDeclaration : Identifier TypeArguments? AS NEWLINE TypeSentence */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeDeclaration"]("Identifier TypeArguments? AS NEWLINE TypeSentence", ...[yyvstack[yysp - 4], yyvstack[yysp], yyvstack[yysp - 3].unwrap]), { rule: "Identifier TypeArguments? AS NEWLINE TypeSentence", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Identifier", yylstack[yysp - 4]], ["TypeArguments?", yylstack[yysp - 3]], ["AS", yylstack[yysp - 2]], ["NEWLINE", yylstack[yysp - 1]], ["TypeSentence", yylstack[yysp]])
    break;

case 461:
    /*! Production::    TypeSentence : TypeSentence "&" TypeValue */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeSentence"]("TypeSentence & TypeValue", ...[...yyvstack[yysp - 2].contents, yyvstack[yysp - 1], yyvstack[yysp]]), { rule: "TypeSentence & TypeValue", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["TypeSentence", yylstack[yysp - 2]], ["&", yylstack[yysp - 1]], ["TypeValue", yylstack[yysp]])
    break;

case 462:
    /*! Production::    TypeSentence : TypeSentence "|" TypeValue */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeSentence"]("TypeSentence | TypeValue", ...[...yyvstack[yysp - 2].contents, yyvstack[yysp - 1], yyvstack[yysp]]), { rule: "TypeSentence | TypeValue", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["TypeSentence", yylstack[yysp - 2]], ["|", yylstack[yysp - 1]], ["TypeValue", yylstack[yysp]])
    break;

case 463:
    /*! Production::    TypeSentence : TypeSentence "&" INDENT TypeValue OUTDENT */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeSentence"]("TypeSentence & INDENT TypeValue OUTDENT", ...[...yyvstack[yysp - 4].contents, yyvstack[yysp - 3], yyvstack[yysp - 1]]), { rule: "TypeSentence & INDENT TypeValue OUTDENT", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["TypeSentence", yylstack[yysp - 4]], ["&", yylstack[yysp - 3]], ["INDENT", yylstack[yysp - 2]], ["TypeValue", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 464:
    /*! Production::    TypeSentence : TypeSentence "|" INDENT TypeValue OUTDENT */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeSentence"]("TypeSentence | INDENT TypeValue OUTDENT", ...[...yyvstack[yysp - 4].contents, yyvstack[yysp - 3], yyvstack[yysp - 1]]), { rule: "TypeSentence | INDENT TypeValue OUTDENT", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["TypeSentence", yylstack[yysp - 4]], ["|", yylstack[yysp - 3]], ["INDENT", yylstack[yysp - 2]], ["TypeValue", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 465:
    /*! Production::    TypeSentence : TypeSentence "&" NEWLINE TypeValue */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeSentence"]("TypeSentence & NEWLINE TypeValue", ...[...yyvstack[yysp - 3].contents, yyvstack[yysp - 2], yyvstack[yysp]]), { rule: "TypeSentence & NEWLINE TypeValue", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["TypeSentence", yylstack[yysp - 3]], ["&", yylstack[yysp - 2]], ["NEWLINE", yylstack[yysp - 1]], ["TypeValue", yylstack[yysp]])
    break;

case 466:
    /*! Production::    TypeSentence : TypeSentence "|" NEWLINE TypeValue */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeSentence"]("TypeSentence | NEWLINE TypeValue", ...[...yyvstack[yysp - 3].contents, yyvstack[yysp - 2], yyvstack[yysp]]), { rule: "TypeSentence | NEWLINE TypeValue", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["TypeSentence", yylstack[yysp - 3]], ["|", yylstack[yysp - 2]], ["NEWLINE", yylstack[yysp - 1]], ["TypeValue", yylstack[yysp]])
    break;

case 467:
    /*! Production::    TypeSentence : TypeValue */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeSentence"]("TypeValue", ...[yyvstack[yysp]]), { rule: "TypeValue", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["TypeValue", yylstack[yysp]])
    break;

case 468:
    /*! Production::    TypeValue : TypeArray */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["TypeValue"]("TypeArray", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["TypeArray", yylstack[yysp - 1]])
    break;

case 469:
    /*! Production::    TypeValue : TypeObject */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["TypeValue"]("TypeObject", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["TypeObject", yylstack[yysp - 1]])
    break;

case 470:
    /*! Production::    TypeValue : Literal */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["TypeValue"]("Literal", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Literal", yylstack[yysp - 1]])
    break;

case 471:
    /*! Production::    TypeValue : Identifier */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["TypeValue"]("Identifier", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Identifier", yylstack[yysp - 1]])
    break;

case 472:
    /*! Production::    TypeValue : TAG */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["TypeValue"]("TAG", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["TAG", yylstack[yysp - 1]])
    break;

case 473:
    /*! Production::    TypeValue : TypeWithArguments */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["TypeValue"]("TypeWithArguments", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["TypeWithArguments", yylstack[yysp - 1]])
    break;

case 474:
    /*! Production::    TypeWithArguments : "(" TypeSentence ")" INDEX_START INDEX_END */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeWithArguments"]("( TypeSentence ) INDEX_START INDEX_END", ...[{ isArray: true, type: yyvstack[yysp - 3] }]), { rule: "( TypeSentence ) INDEX_START INDEX_END", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["(", yylstack[yysp - 4]], ["TypeSentence", yylstack[yysp - 3]], [")", yylstack[yysp - 2]], ["INDEX_START", yylstack[yysp - 1]], ["INDEX_END", yylstack[yysp]])
    break;

case 475:
    /*! Production::    TypeWithArguments : TypeValue INDEX_START INDEX_END */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeWithArguments"]("TypeValue INDEX_START INDEX_END", ...[{ isArray: true, type: yyvstack[yysp - 2] }]), { rule: "TypeValue INDEX_START INDEX_END", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["TypeValue", yylstack[yysp - 2]], ["INDEX_START", yylstack[yysp - 1]], ["INDEX_END", yylstack[yysp]])
    break;

case 476:
    /*! Production::    TypeWithArguments : Identifier "<(" TypeArguments ")>" */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeWithArguments"]("Identifier <( TypeArguments )>", ...[{ type: yyvstack[yysp - 3], arguments: yyvstack[yysp - 1] }]), { rule: "Identifier <( TypeArguments )>", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Identifier", yylstack[yysp - 3]], ["<(", yylstack[yysp - 2]], ["TypeArguments", yylstack[yysp - 1]], [")>", yylstack[yysp]])
    break;

case 477:
    /*! Production::    TypeWithArguments : Identifier "<(" INDENT TypeArguments OUTDENT ")>" */

    // default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 5, yysp);
    // END of default action (generated by JISON mode classic/merge :: 6,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeWithArguments"]("Identifier <( INDENT TypeArguments OUTDENT )>", ...[{ type: yyvstack[yysp - 5], arguments: yyvstack[yysp - 2] }]), { rule: "Identifier <( INDENT TypeArguments OUTDENT )>", loc: { first_line: yylstack[yysp - 5].first_line, first_column: yylstack[yysp - 5].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 5].src, type: yylstack[yysp - 5].type } }, {"first":1,"last":6,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Identifier", yylstack[yysp - 5]], ["<(", yylstack[yysp - 4]], ["INDENT", yylstack[yysp - 3]], ["TypeArguments", yylstack[yysp - 2]], ["OUTDENT", yylstack[yysp - 1]], [")>", yylstack[yysp]])
    break;

case 478:
    /*! Production::    TypeArguments : TypeArgument */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["TypeArguments"]("TypeArgument", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["TypeArgument", yylstack[yysp - 1]])
    break;

case 479:
    /*! Production::    TypeArguments : TypeArguments "," TypeArgument */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeArguments"]("TypeArguments , TypeArgument", ...[...yyvstack[yysp - 2].contents, yyvstack[yysp]]), { rule: "TypeArguments , TypeArgument", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["TypeArguments", yylstack[yysp - 2]], [",", yylstack[yysp - 1]], ["TypeArgument", yylstack[yysp]])
    break;

case 480:
    /*! Production::    TypeArguments : TypeArguments OptComma NEWLINE TypeArgument */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeArguments"]("TypeArguments OptComma NEWLINE TypeArgument", ...[...yyvstack[yysp - 3].contents, yyvstack[yysp]]), { rule: "TypeArguments OptComma NEWLINE TypeArgument", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["TypeArguments", yylstack[yysp - 3]], ["OptComma", yylstack[yysp - 2]], ["NEWLINE", yylstack[yysp - 1]], ["TypeArgument", yylstack[yysp]])
    break;

case 481:
    /*! Production::    TypeArguments : TypeArguments OptComma INDENT TypeArgument OUTDENT */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeArguments"]("TypeArguments OptComma INDENT TypeArgument OUTDENT", ...[...yyvstack[yysp - 4].contents, yyvstack[yysp - 1]]), { rule: "TypeArguments OptComma INDENT TypeArgument OUTDENT", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["TypeArguments", yylstack[yysp - 4]], ["OptComma", yylstack[yysp - 3]], ["INDENT", yylstack[yysp - 2]], ["TypeArgument", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 482:
    /*! Production::    TypeArgument : Identifier */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeArgument"]("Identifier", ...[yyvstack[yysp]]), { rule: "Identifier", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Identifier", yylstack[yysp]])
    break;

case 483:
    /*! Production::    TypeArgument : Identifier EXTENDS Identifier */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeArgument"]("Identifier EXTENDS Identifier", ...[yyvstack[yysp - 2], yyvstack[yysp]]), { rule: "Identifier EXTENDS Identifier", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Identifier", yylstack[yysp - 2]], ["EXTENDS", yylstack[yysp - 1]], ["Identifier", yylstack[yysp]])
    break;

case 484:
    /*! Production::    TypeArgument : TypeWithArguments */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["TypeArgument"]("TypeWithArguments", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["TypeWithArguments", yylstack[yysp - 1]])
    break;

case 485:
    /*! Production::    TypeObject : "{" TypeObjProps "}" */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeObject"]("{ TypeObjProps }", ...[...yyvstack[yysp - 1].contents]), { rule: "{ TypeObjProps }", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["{", yylstack[yysp - 2]], ["TypeObjProps", yylstack[yysp - 1]], ["}", yylstack[yysp]])
    break;

case 486:
    /*! Production::    TypeObject : "{" INDENT TypeObjProps OUTDENT "}" */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeObject"]("{ INDENT TypeObjProps OUTDENT }", ...[...yyvstack[yysp - 2].contents]), { rule: "{ INDENT TypeObjProps OUTDENT }", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["{", yylstack[yysp - 4]], ["INDENT", yylstack[yysp - 3]], ["TypeObjProps", yylstack[yysp - 2]], ["OUTDENT", yylstack[yysp - 1]], ["}", yylstack[yysp]])
    break;

case 487:
    /*! Production::    TypeObjProps : TypeObjProps OptComma NEWLINE TypeObjProp */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeObjProps"]("TypeObjProps OptComma NEWLINE TypeObjProp", ...[...yyvstack[yysp - 3].contents, yyvstack[yysp]]), { rule: "TypeObjProps OptComma NEWLINE TypeObjProp", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["TypeObjProps", yylstack[yysp - 3]], ["OptComma", yylstack[yysp - 2]], ["NEWLINE", yylstack[yysp - 1]], ["TypeObjProp", yylstack[yysp]])
    break;

case 488:
    /*! Production::    TypeObjProps : TypeObjProps "," TypeObjProp */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeObjProps"]("TypeObjProps , TypeObjProp", ...[...yyvstack[yysp - 2].contents, yyvstack[yysp]]), { rule: "TypeObjProps , TypeObjProp", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["TypeObjProps", yylstack[yysp - 2]], [",", yylstack[yysp - 1]], ["TypeObjProp", yylstack[yysp]])
    break;

case 489:
    /*! Production::    TypeObjProps : TypeObjProps OptComma INDENT TypeObjProp OUTDENT */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeObjProps"]("TypeObjProps OptComma INDENT TypeObjProp OUTDENT", ...[...yyvstack[yysp - 4].contents, yyvstack[yysp - 1]]), { rule: "TypeObjProps OptComma INDENT TypeObjProp OUTDENT", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["TypeObjProps", yylstack[yysp - 4]], ["OptComma", yylstack[yysp - 3]], ["INDENT", yylstack[yysp - 2]], ["TypeObjProp", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 490:
    /*! Production::    TypeObjProps : TypeObjProp */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["TypeObjProps"]("TypeObjProp", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["TypeObjProp", yylstack[yysp - 1]])
    break;

case 491:
    /*! Production::    TypeObjProp : PROPERTY ":" TypeSentence */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeObjProp"]("PROPERTY : TypeSentence", ...[yyvstack[yysp - 2], yyvstack[yysp], yylstack[yysp - 1].origin === '?:']), { rule: "PROPERTY : TypeSentence", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["PROPERTY", yylstack[yysp - 2]], [":", yylstack[yysp - 1]], ["TypeSentence", yylstack[yysp]])
    break;

case 492:
    /*! Production::    TypeObjProp : PROPERTY ":" NEWLINE TypeSentence */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeObjProp"]("PROPERTY : NEWLINE TypeSentence", ...[yyvstack[yysp - 3], yyvstack[yysp], yylstack[yysp - 2].origin === '?:']), { rule: "PROPERTY : NEWLINE TypeSentence", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["PROPERTY", yylstack[yysp - 3]], [":", yylstack[yysp - 2]], ["NEWLINE", yylstack[yysp - 1]], ["TypeSentence", yylstack[yysp]])
    break;

case 493:
    /*! Production::    TypeObjProp : PROPERTY ":" INDENT TypeSentence OUTDENT */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeObjProp"]("PROPERTY : INDENT TypeSentence OUTDENT", ...[yyvstack[yysp - 4], yyvstack[yysp - 1], yylstack[yysp - 3].origin === '?:']), { rule: "PROPERTY : INDENT TypeSentence OUTDENT", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["PROPERTY", yylstack[yysp - 4]], [":", yylstack[yysp - 3]], ["INDENT", yylstack[yysp - 2]], ["TypeSentence", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 494:
    /*! Production::    TypeObjProp : PROPERTY ":" */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeObjProp"]("PROPERTY :", ...[yyvstack[yysp - 1], , yylstack[yysp].origin === '?:']), { rule: "PROPERTY :", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["PROPERTY", yylstack[yysp - 1]], [":", yylstack[yysp]])
    break;

case 495:
    /*! Production::    TypeObjProp : Identifier */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeObjProp"]("Identifier", ...[yyvstack[yysp]]), { rule: "Identifier", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Identifier", yylstack[yysp]])
    break;

case 496:
    /*! Production::    TypeArray : "[" TypeArrayItems "]" */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeArray"]("[ TypeArrayItems ]", ...[...yyvstack[yysp - 1].contents]), { rule: "[ TypeArrayItems ]", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["[", yylstack[yysp - 2]], ["TypeArrayItems", yylstack[yysp - 1]], ["]", yylstack[yysp]])
    break;

case 497:
    /*! Production::    TypeArray : "[" INDENT TypeArrayItems OUTDENT "]" */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeArray"]("[ INDENT TypeArrayItems OUTDENT ]", ...[...yyvstack[yysp - 2].contents]), { rule: "[ INDENT TypeArrayItems OUTDENT ]", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["[", yylstack[yysp - 4]], ["INDENT", yylstack[yysp - 3]], ["TypeArrayItems", yylstack[yysp - 2]], ["OUTDENT", yylstack[yysp - 1]], ["]", yylstack[yysp]])
    break;

case 498:
    /*! Production::    TypeArrayItems : TypeSentence */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["TypeArrayItems"]("TypeSentence", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["TypeSentence", yylstack[yysp - 1]])
    break;

case 499:
    /*! Production::    TypeArrayItems : TypeArrayItems OptComma NEWLINE TypeSentence */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeArrayItems"]("TypeArrayItems OptComma NEWLINE TypeSentence", ...[...yyvstack[yysp - 3].contents, yyvstack[yysp]]), { rule: "TypeArrayItems OptComma NEWLINE TypeSentence", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["TypeArrayItems", yylstack[yysp - 3]], ["OptComma", yylstack[yysp - 2]], ["NEWLINE", yylstack[yysp - 1]], ["TypeSentence", yylstack[yysp]])
    break;

case 500:
    /*! Production::    TypeArrayItems : TypeArrayItems OptComma INDENT TypeSentence OUTDENT */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeArrayItems"]("TypeArrayItems OptComma INDENT TypeSentence OUTDENT", ...[...yyvstack[yysp - 4].contents, yyvstack[yysp - 1]]), { rule: "TypeArrayItems OptComma INDENT TypeSentence OUTDENT", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["TypeArrayItems", yylstack[yysp - 4]], ["OptComma", yylstack[yysp - 3]], ["INDENT", yylstack[yysp - 2]], ["TypeSentence", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 501:
    /*! Production::    TypeArrayItems : TypeArrayItems "," TypeSentence */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["TypeArrayItems"]("TypeArrayItems , TypeSentence", ...[...yyvstack[yysp - 2].contents, yyvstack[yysp]]), { rule: "TypeArrayItems , TypeSentence", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["TypeArrayItems", yylstack[yysp - 2]], [",", yylstack[yysp - 1]], ["TypeSentence", yylstack[yysp]])
    break;

case 502:
    /*! Production::    Declare : DeclarationKeyword Declarations */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Declare"]("DeclarationKeyword Declarations", ...[{ keyword: yyvstack[yysp - 1], statements: yyvstack[yysp] }, [yylstack[yysp - 1], yylstack[yysp]]]), { rule: "DeclarationKeyword Declarations", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["DeclarationKeyword", yylstack[yysp - 1]], ["Declarations", yylstack[yysp]])
    break;

case 503:
    /*! Production::    Declare : DeclarationKeyword INDENT Declarations OUTDENT */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Declare"]("DeclarationKeyword INDENT Declarations OUTDENT", ...[{ keyword: yyvstack[yysp - 3], statements: yyvstack[yysp - 1], indented: true }, [yylstack[yysp - 3], yylstack[yysp - 1]]]), { rule: "DeclarationKeyword INDENT Declarations OUTDENT", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["DeclarationKeyword", yylstack[yysp - 3]], ["INDENT", yylstack[yysp - 2]], ["Declarations", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 504:
    /*! Production::    DeclarationKeyword : VAR */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["DeclarationKeyword"]("VAR", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["VAR", yylstack[yysp - 1]])
    break;

case 505:
    /*! Production::    DeclarationKeyword : LET */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["DeclarationKeyword"]("LET", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["LET", yylstack[yysp - 1]])
    break;

case 506:
    /*! Production::    DeclarationKeyword : CONST */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["DeclarationKeyword"]("CONST", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["CONST", yylstack[yysp - 1]])
    break;

case 507:
    /*! Production::    Declarations : Declaration */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Declarations"]("Declaration", ...[yyvstack[yysp].unwrap]), { rule: "Declaration", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Declaration", yylstack[yysp]])
    break;

case 508:
    /*! Production::    Declarations : Declarations "," Declaration */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Declarations"]("Declarations , Declaration", ...[...yyvstack[yysp - 2].contents, yyvstack[yysp].unwrap]), { rule: "Declarations , Declaration", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Declarations", yylstack[yysp - 2]], [",", yylstack[yysp - 1]], ["Declaration", yylstack[yysp]])
    break;

case 509:
    /*! Production::    Declarations : Declarations OptComma NEWLINE Declaration */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Declarations"]("Declarations OptComma NEWLINE Declaration", ...[...yyvstack[yysp - 3].contents, yylstack[yysp - 1].generated, yyvstack[yysp].unwrap]), { rule: "Declarations OptComma NEWLINE Declaration", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Declarations", yylstack[yysp - 3]], ["OptComma", yylstack[yysp - 2]], ["NEWLINE", yylstack[yysp - 1]], ["Declaration", yylstack[yysp]])
    break;

case 510:
    /*! Production::    Declarations : Declarations OptComma INDENT Declarations OUTDENT */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Declarations"]("Declarations OptComma INDENT Declarations OUTDENT", ...[...yyvstack[yysp - 4].contents, false, ...yyvstack[yysp - 1].contents]), { rule: "Declarations OptComma INDENT Declarations OUTDENT", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Declarations", yylstack[yysp - 4]], ["OptComma", yylstack[yysp - 3]], ["INDENT", yylstack[yysp - 2]], ["Declarations", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 511:
    /*! Production::    Declaration : Assignment */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Declaration"]("Assignment", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Assignment", yylstack[yysp - 1]])
    break;

case 512:
    /*! Production::    Declaration : Identifier */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Declaration"]("Identifier", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Identifier", yylstack[yysp - 1]])
    break;

case 513:
    /*! Production::    Return : RETURN */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Return"]("RETURN", ...[/* */]), { rule: "RETURN", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["RETURN", yylstack[yysp]])
    break;

case 514:
    /*! Production::    Return : RETURN Expression */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Return"]("RETURN Expression", ...[yyvstack[yysp]]), { rule: "RETURN Expression", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["RETURN", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 515:
    /*! Production::    Return : RETURN INDENT Expression OUTDENT */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Return"]("RETURN INDENT Expression OUTDENT", ...[yyvstack[yysp - 1]]), { rule: "RETURN INDENT Expression OUTDENT", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["RETURN", yylstack[yysp - 3]], ["INDENT", yylstack[yysp - 2]], ["Expression", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 516:
    /*! Production::    Return : RETURN INDENT Body OUTDENT */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Return"]("RETURN INDENT Body OUTDENT", ...[yyvstack[yysp - 1]]), { rule: "RETURN INDENT Body OUTDENT", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["RETURN", yylstack[yysp - 3]], ["INDENT", yylstack[yysp - 2]], ["Body", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 517:
    /*! Production::    Import : IMPORT OptDefault ImportList Import(FROM) STRING */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Import"]("IMPORT OptDefault ImportList Import(FROM) STRING", ...[yyvstack[yysp - 2].contents, yyvstack[yysp], false, yyvstack[yysp - 3]]), { rule: "IMPORT OptDefault ImportList Import(FROM) STRING", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["IMPORT", yylstack[yysp - 4]], ["OptDefault", yylstack[yysp - 3]], ["ImportList", yylstack[yysp - 2]], ["Import(FROM)", yylstack[yysp - 1]], ["STRING", yylstack[yysp]])
    break;

case 518:
    /*! Production::    Import : IMPORT INDENT OptDefault ImportList Import(FROM) STRING OUTDENT */

    // default action (generated by JISON mode classic/merge :: 7,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 6, yysp);
    // END of default action (generated by JISON mode classic/merge :: 7,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Import"]("IMPORT INDENT OptDefault ImportList Import(FROM) STRING OUTDENT", ...[yyvstack[yysp - 3].contents, yyvstack[yysp - 1], false, yyvstack[yysp - 4]]), { rule: "IMPORT INDENT OptDefault ImportList Import(FROM) STRING OUTDENT", loc: { first_line: yylstack[yysp - 6].first_line, first_column: yylstack[yysp - 6].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 6].src, type: yylstack[yysp - 6].type } }, {"first":1,"last":7,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["IMPORT", yylstack[yysp - 6]], ["INDENT", yylstack[yysp - 5]], ["OptDefault", yylstack[yysp - 4]], ["ImportList", yylstack[yysp - 3]], ["Import(FROM)", yylstack[yysp - 2]], ["STRING", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 519:
    /*! Production::    Import : IMPORT OptDefault INDENT ImportList Import(FROM) STRING OUTDENT */

    // default action (generated by JISON mode classic/merge :: 7,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 6, yysp);
    // END of default action (generated by JISON mode classic/merge :: 7,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Import"]("IMPORT OptDefault INDENT ImportList Import(FROM) STRING OUTDENT", ...[yyvstack[yysp - 3].contents, yyvstack[yysp - 1], false, yyvstack[yysp - 5]]), { rule: "IMPORT OptDefault INDENT ImportList Import(FROM) STRING OUTDENT", loc: { first_line: yylstack[yysp - 6].first_line, first_column: yylstack[yysp - 6].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 6].src, type: yylstack[yysp - 6].type } }, {"first":1,"last":7,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["IMPORT", yylstack[yysp - 6]], ["OptDefault", yylstack[yysp - 5]], ["INDENT", yylstack[yysp - 4]], ["ImportList", yylstack[yysp - 3]], ["Import(FROM)", yylstack[yysp - 2]], ["STRING", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 520:
    /*! Production::    Import : IMPORT OptDefault INDENT ImportList OUTDENT Import(FROM) STRING */

    // default action (generated by JISON mode classic/merge :: 7,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 6, yysp);
    // END of default action (generated by JISON mode classic/merge :: 7,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Import"]("IMPORT OptDefault INDENT ImportList OUTDENT Import(FROM) STRING", ...[yyvstack[yysp - 3].contents, yyvstack[yysp], false, yyvstack[yysp - 5]]), { rule: "IMPORT OptDefault INDENT ImportList OUTDENT Import(FROM) STRING", loc: { first_line: yylstack[yysp - 6].first_line, first_column: yylstack[yysp - 6].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 6].src, type: yylstack[yysp - 6].type } }, {"first":1,"last":7,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["IMPORT", yylstack[yysp - 6]], ["OptDefault", yylstack[yysp - 5]], ["INDENT", yylstack[yysp - 4]], ["ImportList", yylstack[yysp - 3]], ["OUTDENT", yylstack[yysp - 2]], ["Import(FROM)", yylstack[yysp - 1]], ["STRING", yylstack[yysp]])
    break;

case 521:
    /*! Production::    Import : IMPORT INDENT OptDefault INDENT ImportList OUTDENT Import(FROM) STRING OUTDENT */

    // default action (generated by JISON mode classic/merge :: 9,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 8, yysp);
    // END of default action (generated by JISON mode classic/merge :: 9,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Import"]("IMPORT INDENT OptDefault INDENT ImportList OUTDENT Import(FROM) STRING OUTDENT", ...[yyvstack[yysp - 4].contents, yyvstack[yysp - 1], false, yyvstack[yysp - 6]]), { rule: "IMPORT INDENT OptDefault INDENT ImportList OUTDENT Import(FROM) STRING OUTDENT", loc: { first_line: yylstack[yysp - 8].first_line, first_column: yylstack[yysp - 8].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 8].src, type: yylstack[yysp - 8].type } }, {"first":1,"last":9,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["IMPORT", yylstack[yysp - 8]], ["INDENT", yylstack[yysp - 7]], ["OptDefault", yylstack[yysp - 6]], ["INDENT", yylstack[yysp - 5]], ["ImportList", yylstack[yysp - 4]], ["OUTDENT", yylstack[yysp - 3]], ["Import(FROM)", yylstack[yysp - 2]], ["STRING", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 522:
    /*! Production::    Import : IMPORT OptDefault "*" AS Identifier Import(FROM) STRING */

    // default action (generated by JISON mode classic/merge :: 7,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 6, yysp);
    // END of default action (generated by JISON mode classic/merge :: 7,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Import"]("IMPORT OptDefault * AS Identifier Import(FROM) STRING", ...[yyvstack[yysp - 2], yyvstack[yysp], true, yyvstack[yysp - 5]]), { rule: "IMPORT OptDefault * AS Identifier Import(FROM) STRING", loc: { first_line: yylstack[yysp - 6].first_line, first_column: yylstack[yysp - 6].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 6].src, type: yylstack[yysp - 6].type } }, {"first":1,"last":7,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["IMPORT", yylstack[yysp - 6]], ["OptDefault", yylstack[yysp - 5]], ["*", yylstack[yysp - 4]], ["AS", yylstack[yysp - 3]], ["Identifier", yylstack[yysp - 2]], ["Import(FROM)", yylstack[yysp - 1]], ["STRING", yylstack[yysp]])
    break;

case 523:
    /*! Production::    Import : IMPORT INDENT OptDefault "*" AS Identifier Import(FROM) STRING OUTDENT */

    // default action (generated by JISON mode classic/merge :: 9,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 8, yysp);
    // END of default action (generated by JISON mode classic/merge :: 9,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Import"]("IMPORT INDENT OptDefault * AS Identifier Import(FROM) STRING OUTDENT", ...[yyvstack[yysp - 3], yyvstack[yysp - 1], true, yyvstack[yysp - 6]]), { rule: "IMPORT INDENT OptDefault * AS Identifier Import(FROM) STRING OUTDENT", loc: { first_line: yylstack[yysp - 8].first_line, first_column: yylstack[yysp - 8].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 8].src, type: yylstack[yysp - 8].type } }, {"first":1,"last":9,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["IMPORT", yylstack[yysp - 8]], ["INDENT", yylstack[yysp - 7]], ["OptDefault", yylstack[yysp - 6]], ["*", yylstack[yysp - 5]], ["AS", yylstack[yysp - 4]], ["Identifier", yylstack[yysp - 3]], ["Import(FROM)", yylstack[yysp - 2]], ["STRING", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 524:
    /*! Production::    Import : IMPORT OptDefault INDENT "*" AS Identifier Import(FROM) STRING OUTDENT */

    // default action (generated by JISON mode classic/merge :: 9,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 8, yysp);
    // END of default action (generated by JISON mode classic/merge :: 9,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Import"]("IMPORT OptDefault INDENT * AS Identifier Import(FROM) STRING OUTDENT", ...[yyvstack[yysp - 3], yyvstack[yysp - 1], true, yyvstack[yysp - 7]]), { rule: "IMPORT OptDefault INDENT * AS Identifier Import(FROM) STRING OUTDENT", loc: { first_line: yylstack[yysp - 8].first_line, first_column: yylstack[yysp - 8].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 8].src, type: yylstack[yysp - 8].type } }, {"first":1,"last":9,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["IMPORT", yylstack[yysp - 8]], ["OptDefault", yylstack[yysp - 7]], ["INDENT", yylstack[yysp - 6]], ["*", yylstack[yysp - 5]], ["AS", yylstack[yysp - 4]], ["Identifier", yylstack[yysp - 3]], ["Import(FROM)", yylstack[yysp - 2]], ["STRING", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 526:
    /*! Production::    Export : EXPORT ExportList */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Export"]("EXPORT ExportList", ...[{ list: yyvstack[yysp] }]), { rule: "EXPORT ExportList", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["EXPORT", yylstack[yysp - 1]], ["ExportList", yylstack[yysp]])
    break;

case 527:
    /*! Production::    Export : EXPORT INDENT ExportList OUTDENT */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Export"]("EXPORT INDENT ExportList OUTDENT", ...[{ list: yyvstack[yysp - 1] }]), { rule: "EXPORT INDENT ExportList OUTDENT", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["EXPORT", yylstack[yysp - 3]], ["INDENT", yylstack[yysp - 2]], ["ExportList", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 528:
    /*! Production::    Export : EXPORT DEFAULT Expression */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Export"]("EXPORT DEFAULT Expression", ...[{ defaults: yyvstack[yysp] }]), { rule: "EXPORT DEFAULT Expression", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["EXPORT", yylstack[yysp - 2]], ["DEFAULT", yylstack[yysp - 1]], ["Expression", yylstack[yysp]])
    break;

case 529:
    /*! Production::    Export : EXPORT INDENT DEFAULT Expression OUDENT */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Export"]("EXPORT INDENT DEFAULT Expression OUDENT", ...[{ defaults: yyvstack[yysp - 1] }]), { rule: "EXPORT INDENT DEFAULT Expression OUDENT", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["EXPORT", yylstack[yysp - 4]], ["INDENT", yylstack[yysp - 3]], ["DEFAULT", yylstack[yysp - 2]], ["Expression", yylstack[yysp - 1]], ["OUDENT", yylstack[yysp]])
    break;

case 530:
    /*! Production::    Export : EXPORT Declare */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Export"]("EXPORT Declare", ...[{ declarations: yyvstack[yysp] }]), { rule: "EXPORT Declare", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["EXPORT", yylstack[yysp - 1]], ["Declare", yylstack[yysp]])
    break;

case 531:
    /*! Production::    Export : EXPORT INDENT Declare OUTDENT */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Export"]("EXPORT INDENT Declare OUTDENT", ...[{ declarations: yyvstack[yysp - 1] }]), { rule: "EXPORT INDENT Declare OUTDENT", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["EXPORT", yylstack[yysp - 3]], ["INDENT", yylstack[yysp - 2]], ["Declare", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 532:
    /*! Production::    Export : EXPORT Exportable */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Export"]("EXPORT Exportable", ...[{ exportable: yyvstack[yysp].unwrap }]), { rule: "EXPORT Exportable", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["EXPORT", yylstack[yysp - 1]], ["Exportable", yylstack[yysp]])
    break;

case 533:
    /*! Production::    Export : EXPORT INDENT Exportable OUTDENT */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["Export"]("EXPORT INDENT Exportable OUTDENT", ...[{ exportable: yyvstack[yysp - 1].unwrap }]), { rule: "EXPORT INDENT Exportable OUTDENT", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["EXPORT", yylstack[yysp - 3]], ["INDENT", yylstack[yysp - 2]], ["Exportable", yylstack[yysp - 1]], ["OUTDENT", yylstack[yysp]])
    break;

case 536:
    /*! Production::    OptDefault : Identifier OptComma NEWLINE */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = yyvstack[yysp - 2]
    break;

case 537:
    /*! Production::    ImportList : Identifier */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["ImportList"]("Identifier", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Identifier", yylstack[yysp - 1]])
    break;

case 538:
    /*! Production::    ImportList : "{" ImportNames "}" */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ImportList"]("{ ImportNames }", ...[yyvstack[yysp - 1]]), { rule: "{ ImportNames }", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["{", yylstack[yysp - 2]], ["ImportNames", yylstack[yysp - 1]], ["}", yylstack[yysp]])
    break;

case 539:
    /*! Production::    ImportList : "{{" INDENT ImportNames OUTDENT "}}" */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ImportList"]("{{ INDENT ImportNames OUTDENT }}", ...[yyvstack[yysp - 2]]), { rule: "{{ INDENT ImportNames OUTDENT }}", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["{{", yylstack[yysp - 4]], ["INDENT", yylstack[yysp - 3]], ["ImportNames", yylstack[yysp - 2]], ["OUTDENT", yylstack[yysp - 1]], ["}}", yylstack[yysp]])
    break;

case 540:
    /*! Production::    ExportList : "{" ExportNames "}" */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ExportList"]("{ ExportNames }", ...[yyvstack[yysp - 1]]), { rule: "{ ExportNames }", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["{", yylstack[yysp - 2]], ["ExportNames", yylstack[yysp - 1]], ["}", yylstack[yysp]])
    break;

case 541:
    /*! Production::    ExportList : "{{" INDENT ExportNames OUTDENT "}}" */

    // default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 4, yysp);
    // END of default action (generated by JISON mode classic/merge :: 5,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ExportList"]("{{ INDENT ExportNames OUTDENT }}", ...[yyvstack[yysp - 2]]), { rule: "{{ INDENT ExportNames OUTDENT }}", loc: { first_line: yylstack[yysp - 4].first_line, first_column: yylstack[yysp - 4].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 4].src, type: yylstack[yysp - 4].type } }, {"first":1,"last":5,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["{{", yylstack[yysp - 4]], ["INDENT", yylstack[yysp - 3]], ["ExportNames", yylstack[yysp - 2]], ["OUTDENT", yylstack[yysp - 1]], ["}}", yylstack[yysp]])
    break;

case 542:
    /*! Production::    ExportNames : ExportName */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ExportNames"]("ExportName", ...[yyvstack[yysp].contents]), { rule: "ExportName", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["ExportName", yylstack[yysp]])
    break;

case 543:
    /*! Production::    ExportNames : ExportNames "," ExportName */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ExportNames"]("ExportNames , ExportName", ...[...yyvstack[yysp - 2].contents, yyvstack[yysp].contents]), { rule: "ExportNames , ExportName", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["ExportNames", yylstack[yysp - 2]], [",", yylstack[yysp - 1]], ["ExportName", yylstack[yysp]])
    break;

case 544:
    /*! Production::    ExportNames : ExportNames OptComma NEWLINE ExportName */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ExportNames"]("ExportNames OptComma NEWLINE ExportName", ...[...yyvstack[yysp - 3].contents, yyvstack[yysp].contents]), { rule: "ExportNames OptComma NEWLINE ExportName", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["ExportNames", yylstack[yysp - 3]], ["OptComma", yylstack[yysp - 2]], ["NEWLINE", yylstack[yysp - 1]], ["ExportName", yylstack[yysp]])
    break;

case 545:
    /*! Production::    ExportName : PROPERTY ":" */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ExportName"]("PROPERTY :", ...[new yy.Identifier(0, yyvstack[yysp - 1]).setLoc(yylstack[yysp - 1])]), { rule: "PROPERTY :", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["PROPERTY", yylstack[yysp - 1]], [":", yylstack[yysp]])
    break;

case 546:
    /*! Production::    ExportName : PROPERTY ":" Identifier */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ExportName"]("PROPERTY : Identifier", ...[new yy.Identifier(0, yyvstack[yysp - 2]).setLoc(yylstack[yysp - 2]), yyvstack[yysp]]), { rule: "PROPERTY : Identifier", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["PROPERTY", yylstack[yysp - 2]], [":", yylstack[yysp - 1]], ["Identifier", yylstack[yysp]])
    break;

case 547:
    /*! Production::    ExportName : PROPERTY ":" AS Identifier */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ExportName"]("PROPERTY : AS Identifier", ...[new yy.Identifier(0, yyvstack[yysp - 3]).setLoc(yylstack[yysp - 3]), yyvstack[yysp]]), { rule: "PROPERTY : AS Identifier", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["PROPERTY", yylstack[yysp - 3]], [":", yylstack[yysp - 2]], ["AS", yylstack[yysp - 1]], ["Identifier", yylstack[yysp]])
    break;

case 548:
    /*! Production::    ExportName : Identifier */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["ExportName"]("Identifier", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Identifier", yylstack[yysp - 1]])
    break;

case 549:
    /*! Production::    ExportName : Identifier AS DEFAULT */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ExportName"]("Identifier AS DEFAULT", ...[yyvstack[yysp - 2],,true]), { rule: "Identifier AS DEFAULT", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Identifier", yylstack[yysp - 2]], ["AS", yylstack[yysp - 1]], ["DEFAULT", yylstack[yysp]])
    break;

case 550:
    /*! Production::    ExportName : Identifier AS Identifier */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ExportName"]("Identifier AS Identifier", ...[yyvstack[yysp - 2],yyvstack[yysp]]), { rule: "Identifier AS Identifier", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Identifier", yylstack[yysp - 2]], ["AS", yylstack[yysp - 1]], ["Identifier", yylstack[yysp]])
    break;

case 551:
    /*! Production::    Exportable : Class */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Exportable"]("Class", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Class", yylstack[yysp - 1]])
    break;

case 552:
    /*! Production::    Exportable : Function */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["Exportable"]("Function", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Function", yylstack[yysp - 1]])
    break;

case 553:
    /*! Production::    ImportNames : ImportName */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ImportNames"]("ImportName", ...[yyvstack[yysp].contents]), { rule: "ImportName", loc: { first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type } }, {"first":1,"last":1,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["ImportName", yylstack[yysp]])
    break;

case 554:
    /*! Production::    ImportNames : ImportNames "," ImportName */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ImportNames"]("ImportNames , ImportName", ...[...yyvstack[yysp - 2].contents, yyvstack[yysp].contents]), { rule: "ImportNames , ImportName", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["ImportNames", yylstack[yysp - 2]], [",", yylstack[yysp - 1]], ["ImportName", yylstack[yysp]])
    break;

case 555:
    /*! Production::    ImportNames : ImportNames OptComma NEWLINE ImportName */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ImportNames"]("ImportNames OptComma NEWLINE ImportName", ...[...yyvstack[yysp - 3].contents, yyvstack[yysp].contents]), { rule: "ImportNames OptComma NEWLINE ImportName", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["ImportNames", yylstack[yysp - 3]], ["OptComma", yylstack[yysp - 2]], ["NEWLINE", yylstack[yysp - 1]], ["ImportName", yylstack[yysp]])
    break;

case 556:
    /*! Production::    ImportName : PROPERTY ":" */

    // default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 1, yysp);
    // END of default action (generated by JISON mode classic/merge :: 2,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ImportName"]("PROPERTY :", ...[new yy.Identifier(0, yyvstack[yysp - 1]).setLoc(yylstack[yysp - 1]), , [yylstack[yysp - 1], yylstack[yysp]]]), { rule: "PROPERTY :", loc: { first_line: yylstack[yysp - 1].first_line, first_column: yylstack[yysp - 1].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 1].src, type: yylstack[yysp - 1].type } }, {"first":1,"last":2,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["PROPERTY", yylstack[yysp - 1]], [":", yylstack[yysp]])
    break;

case 557:
    /*! Production::    ImportName : PROPERTY ":" Identifier */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ImportName"]("PROPERTY : Identifier", ...[new yy.Identifier(0, yyvstack[yysp - 2]).setLoc(yylstack[yysp - 2]), yyvstack[yysp]]), { rule: "PROPERTY : Identifier", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["PROPERTY", yylstack[yysp - 2]], [":", yylstack[yysp - 1]], ["Identifier", yylstack[yysp]])
    break;

case 558:
    /*! Production::    ImportName : PROPERTY ":" AS Identifier */

    // default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 3, yysp);
    // END of default action (generated by JISON mode classic/merge :: 4,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ImportName"]("PROPERTY : AS Identifier", ...[new yy.Identifier(0, yyvstack[yysp - 3]).setLoc(yylstack[yysp - 3]), yyvstack[yysp]]), { rule: "PROPERTY : AS Identifier", loc: { first_line: yylstack[yysp - 3].first_line, first_column: yylstack[yysp - 3].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 3].src, type: yylstack[yysp - 3].type } }, {"first":1,"last":4,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["PROPERTY", yylstack[yysp - 3]], [":", yylstack[yysp - 2]], ["AS", yylstack[yysp - 1]], ["Identifier", yylstack[yysp]])
    break;

case 559:
    /*! Production::    ImportName : Identifier AS Identifier */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ImportName"]("Identifier AS Identifier", ...[yyvstack[yysp - 2], yyvstack[yysp]]), { rule: "Identifier AS Identifier", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["Identifier", yylstack[yysp - 2]], ["AS", yylstack[yysp - 1]], ["Identifier", yylstack[yysp]])
    break;

case 560:
    /*! Production::    ImportName : DEFAULT AS Identifier */

    // default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yyparser.yyMergeLocationInfo(yysp - 2, yysp);
    // END of default action (generated by JISON mode classic/merge :: 3,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = Object.assign(new yy["ImportName"]("DEFAULT AS Identifier", ...[(new yy.Identifier(null, 'default')).setLoc(yylstack[yysp - 2]), yyvstack[yysp]]), { rule: "DEFAULT AS Identifier", loc: { first_line: yylstack[yysp - 2].first_line, first_column: yylstack[yysp - 2].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp - 2].src, type: yylstack[yysp - 2].type } }, {"first":1,"last":3,"typeOf":1,"checkGenerated":false}, { generated: undefined }).setTokens(["DEFAULT", yylstack[yysp - 2]], ["AS", yylstack[yysp - 1]], ["Identifier", yylstack[yysp]])
    break;

case 561:
    /*! Production::    ImportName : Identifier */

    // default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-):
    this._$ = yylstack[yysp];
    // END of default action (generated by JISON mode classic/merge :: 1,VT,VA,VU,-,LT,LA,-,-)
    
    
    this.$ = new yy["ImportName"]("Identifier", ...[yyvstack[yysp]]).setLocation({ first_line: yylstack[yysp].first_line, first_column: yylstack[yysp].first_column, last_line: yylstack[yysp].last_line, last_column: yylstack[yysp].last_column, src: yylstack[yysp].src, type: yylstack[yysp].type }).setTokens(["Identifier", yylstack[yysp - 1]])
    break;

}
},
table: bt({
  len: u([
  117,
  1,
  2,
  0,
  57,
  7,
  93,
  s,
  [0, 11],
  91,
  91,
  s,
  [0, 3],
  114,
  0,
  0,
  90,
  s,
  [0, 8],
  s,
  [113, 5],
  114,
  114,
  0,
  113,
  6,
  116,
  115,
  90,
  0,
  91,
  11,
  94,
  116,
  5,
  12,
  9,
  191,
  7,
  28,
  116,
  5,
  2,
  s,
  [0, 3],
  116,
  s,
  [0, 7],
  5,
  91,
  s,
  [7, 3],
  113,
  s,
  [0, 9],
  127,
  s,
  [0, 4],
  116,
  116,
  c,
  [17, 5],
  119,
  120,
  s,
  [0, 4],
  3,
  7,
  s,
  [0, 6],
  7,
  29,
  7,
  119,
  0,
  c,
  [24, 3],
  s,
  [113, 4],
  0,
  116,
  113,
  114,
  115,
  c,
  [8, 4],
  s,
  [0, 12],
  66,
  0,
  66,
  s,
  [0, 15],
  127,
  c,
  [34, 4],
  6,
  0,
  1,
  113,
  118,
  0,
  0,
  96,
  113,
  2,
  117,
  s,
  [0, 3],
  96,
  93,
  90,
  52,
  s,
  [96, 4],
  113,
  96,
  113,
  57,
  116,
  113,
  5,
  2,
  2,
  68,
  116,
  3,
  4,
  60,
  55,
  54,
  120,
  1,
  90,
  116,
  0,
  c,
  [33, 4],
  94,
  6,
  2,
  0,
  12,
  116,
  92,
  92,
  96,
  0,
  2,
  116,
  121,
  12,
  0,
  115,
  5,
  1,
  s,
  [0, 3],
  8,
  8,
  9,
  2,
  9,
  11,
  14,
  0,
  7,
  113,
  5,
  96,
  115,
  7,
  7,
  3,
  0,
  27,
  c,
  [89, 3],
  c,
  [26, 4],
  5,
  4,
  93,
  90,
  115,
  c,
  [53, 3],
  0,
  s,
  [3, 3],
  4,
  54,
  2,
  115,
  0,
  2,
  1,
  1,
  c,
  [219, 3],
  6,
  8,
  3,
  6,
  9,
  0,
  29,
  2,
  96,
  89,
  89,
  96,
  c,
  [165, 4],
  53,
  96,
  0,
  57,
  116,
  0,
  5,
  117,
  0,
  57,
  1,
  55,
  120,
  114,
  68,
  50,
  58,
  0,
  7,
  118,
  0,
  113,
  58,
  113,
  72,
  c,
  [266, 4],
  0,
  7,
  c,
  [215, 3],
  5,
  28,
  0,
  8,
  6,
  27,
  c,
  [108, 4],
  0,
  29,
  6,
  c,
  [17, 4],
  0,
  s,
  [96, 6],
  0,
  96,
  116,
  2,
  66,
  89,
  115,
  c,
  [11, 5],
  0,
  89,
  c,
  [5, 4],
  0,
  53,
  0,
  5,
  116,
  0,
  58,
  113,
  53,
  96,
  c,
  [294, 3],
  53,
  53,
  116,
  0,
  54,
  96,
  s,
  [113, 6],
  69,
  57,
  113,
  120,
  c,
  [406, 3],
  7,
  51,
  116,
  53,
  6,
  0,
  s,
  [126, 3],
  120,
  c,
  [137, 3],
  96,
  95,
  0,
  96,
  89,
  4,
  91,
  0,
  4,
  c,
  [176, 4],
  96,
  89,
  0,
  90,
  c,
  [422, 3],
  116,
  0,
  2,
  2,
  5,
  117,
  1,
  13,
  2,
  116,
  c,
  [287, 3],
  113,
  0,
  1,
  1,
  5,
  0,
  0,
  1,
  6,
  3,
  c,
  [297, 3],
  0,
  9,
  6,
  9,
  54,
  2,
  2,
  6,
  1,
  0,
  6,
  1,
  7,
  6,
  1,
  1,
  113,
  1,
  1,
  96,
  4,
  0,
  1,
  5,
  5,
  116,
  2,
  c,
  [237, 3],
  1,
  3,
  0,
  0,
  c,
  [176, 3],
  1,
  0,
  96,
  c,
  [178, 3],
  0,
  29,
  5,
  0,
  126,
  12,
  96,
  0,
  116,
  115,
  54,
  3,
  119,
  5,
  121,
  116,
  57,
  1,
  60,
  0,
  1,
  121,
  c,
  [126, 3],
  57,
  0,
  57,
  c,
  [38, 4],
  c,
  [166, 3],
  29,
  2,
  5,
  2,
  29,
  3,
  89,
  90,
  c,
  [65, 3],
  28,
  7,
  5,
  5,
  c,
  [57, 3],
  c,
  [22, 3],
  67,
  s,
  [113, 3],
  115,
  1,
  54,
  113,
  0,
  c,
  [54, 3],
  c,
  [42, 3],
  54,
  c,
  [209, 4],
  96,
  157,
  96,
  53,
  53,
  57,
  57,
  59,
  113,
  55,
  2,
  120,
  0,
  119,
  116,
  0,
  4,
  4,
  c,
  [213, 3],
  0,
  127,
  s,
  [7, 3],
  2,
  c,
  [108, 3],
  c,
  [553, 3],
  c,
  [190, 3],
  94,
  c,
  [8, 4],
  c,
  [222, 3],
  c,
  [420, 3],
  116,
  96,
  116,
  0,
  10,
  11,
  0,
  96,
  59,
  59,
  60,
  1,
  9,
  0,
  8,
  2,
  15,
  c,
  [167, 3],
  14,
  c,
  [93, 4],
  29,
  c,
  [157, 4],
  3,
  1,
  2,
  c,
  [179, 4],
  1,
  6,
  c,
  [179, 4],
  c,
  [134, 3],
  c,
  [424, 4],
  7,
  3,
  4,
  0,
  114,
  c,
  [423, 3],
  29,
  0,
  2,
  11,
  c,
  [437, 4],
  6,
  89,
  113,
  c,
  [279, 3],
  121,
  54,
  157,
  0,
  116,
  117,
  c,
  [85, 3],
  57,
  c,
  [92, 3],
  c,
  [4, 3],
  c,
  [67, 4],
  115,
  118,
  117,
  c,
  [7, 4],
  27,
  c,
  [394, 3],
  5,
  28,
  1,
  28,
  28,
  c,
  [242, 3],
  c,
  [233, 3],
  2,
  6,
  5,
  32,
  0,
  113,
  96,
  96,
  59,
  0,
  115,
  c,
  [82, 3],
  115,
  116,
  0,
  3,
  c,
  [591, 3],
  c,
  [645, 3],
  c,
  [647, 3],
  s,
  [0, 3],
  59,
  c,
  [240, 3],
  54,
  0,
  0,
  126,
  c,
  [5, 3],
  3,
  c,
  [285, 4],
  94,
  0,
  4,
  c,
  [214, 3],
  c,
  [519, 3],
  c,
  [445, 3],
  c,
  [15, 3],
  5,
  c,
  [461, 4],
  6,
  6,
  0,
  113,
  c,
  [283, 3],
  0,
  0,
  10,
  12,
  c,
  [265, 3],
  s,
  [2, 3],
  c,
  [354, 4],
  2,
  2,
  4,
  1,
  c,
  [211, 4],
  4,
  c,
  [343, 6],
  5,
  89,
  c,
  [119, 5],
  9,
  0,
  4,
  1,
  4,
  c,
  [533, 4],
  4,
  96,
  54,
  4,
  c,
  [64, 5],
  54,
  54,
  116,
  7,
  c,
  [32, 3],
  c,
  [186, 4],
  1,
  89,
  26,
  26,
  c,
  [3, 3],
  27,
  27,
  7,
  1,
  4,
  c,
  [231, 3],
  7,
  27,
  27,
  59,
  113,
  c,
  [52, 3],
  1,
  57,
  57,
  c,
  [108, 4],
  57,
  c,
  [12, 3],
  c,
  [78, 3],
  c,
  [338, 3],
  3,
  c,
  [398, 3],
  57,
  0,
  7,
  c,
  [95, 3],
  c,
  [30, 3],
  c,
  [95, 5],
  c,
  [117, 3],
  c,
  [846, 5],
  89,
  c,
  [132, 3],
  2,
  5,
  4,
  c,
  [619, 6],
  s,
  [0, 3],
  c,
  [664, 3],
  c,
  [11, 3],
  1,
  0,
  2,
  89,
  2,
  89,
  c,
  [729, 3],
  c,
  [10, 3],
  7,
  3,
  113,
  96,
  c,
  [226, 3],
  c,
  [223, 4],
  c,
  [280, 4],
  s,
  [0, 6],
  c,
  [47, 6],
  c,
  [733, 3],
  c,
  [780, 3],
  c,
  [613, 4],
  27,
  c,
  [242, 3],
  s,
  [0, 5],
  c,
  [235, 3],
  c,
  [122, 3],
  c,
  [423, 4],
  s,
  [1, 3],
  c,
  [166, 4],
  7,
  c,
  [19, 4],
  c,
  [324, 4],
  7
]),
  symbol: u([
  1,
  s,
  [3, 5, 1],
  16,
  21,
  24,
  28,
  29,
  30,
  s,
  [33, 5, 1],
  40,
  46,
  s,
  [51, 4, 1],
  73,
  78,
  80,
  83,
  89,
  92,
  95,
  101,
  s,
  [104, 6, 1],
  112,
  113,
  117,
  s,
  [119, 8, 1],
  130,
  131,
  133,
  134,
  136,
  137,
  138,
  142,
  s,
  [144, 4, 1],
  149,
  s,
  [151, 6, 1],
  s,
  [158, 7, 1],
  166,
  s,
  [170, 4, 5],
  187,
  193,
  195,
  196,
  199,
  200,
  201,
  203,
  204,
  s,
  [206, 5, 1],
  212,
  s,
  [217, 4, 1],
  223,
  224,
  227,
  229,
  230,
  231,
  235,
  236,
  238,
  240,
  244,
  251,
  252,
  258,
  270,
  271,
  274,
  275,
  277,
  1,
  1,
  26,
  1,
  4,
  5,
  s,
  [8, 7, 1],
  17,
  19,
  22,
  26,
  39,
  s,
  [41, 5, 1],
  47,
  48,
  51,
  52,
  s,
  [55, 18, 1],
  88,
  99,
  100,
  c,
  [134, 4],
  143,
  165,
  167,
  s,
  [171, 4, 1],
  200,
  1,
  17,
  c,
  [47, 3],
  99,
  100,
  c,
  [64, 10],
  s,
  [15, 6, 1],
  22,
  23,
  25,
  26,
  31,
  32,
  38,
  c,
  [73, 8],
  s,
  [49, 4, 1],
  c,
  [75, 18],
  s,
  [74, 4, 1],
  81,
  s,
  [84, 5, 1],
  91,
  93,
  s,
  [96, 5, 1],
  s,
  [102, 6, 1],
  110,
  111,
  115,
  116,
  118,
  125,
  126,
  129,
  139,
  140,
  141,
  143,
  157,
  176,
  219,
  220,
  242,
  c,
  [93, 88],
  144,
  157,
  240,
  c,
  [91, 91],
  c,
  [458, 16],
  38,
  c,
  [459, 50],
  c,
  [456, 48],
  c,
  [389, 88],
  237,
  c,
  [662, 66],
  c,
  [203, 47],
  c,
  [113, 468],
  c,
  [769, 98],
  c,
  [114, 130],
  c,
  [113, 97],
  26,
  c,
  [84, 4],
  200,
  c,
  [119, 74],
  s,
  [183, 5, 1],
  c,
  [349, 63],
  81,
  c,
  [1233, 177],
  198,
  c,
  [90, 89],
  202,
  205,
  16,
  30,
  32,
  38,
  79,
  80,
  81,
  144,
  181,
  232,
  c,
  [1630, 21],
  27,
  30,
  c,
  [104, 37],
  80,
  c,
  [105, 27],
  134,
  c,
  [106, 5],
  231,
  c,
  [401, 76],
  182,
  c,
  [402, 39],
  16,
  30,
  38,
  81,
  182,
  16,
  24,
  31,
  77,
  117,
  144,
  211,
  233,
  234,
  239,
  241,
  243,
  c,
  [125, 4],
  80,
  133,
  134,
  144,
  163,
  c,
  [2234, 6],
  s,
  [8, 19, 1],
  s,
  [28, 51, 1],
  c,
  [193, 3],
  s,
  [84, 6, 1],
  91,
  92,
  93,
  s,
  [95, 19, 1],
  s,
  [115, 12, 1],
  129,
  c,
  [213, 7],
  s,
  [139, 9, 1],
  c,
  [217, 7],
  157,
  c,
  [619, 47],
  8,
  16,
  38,
  81,
  144,
  240,
  278,
  16,
  28,
  30,
  33,
  38,
  c,
  [128, 3],
  90,
  c,
  [85, 5],
  144,
  c,
  [76, 3],
  180,
  c,
  [43, 4],
  240,
  270,
  271,
  280,
  283,
  c,
  [1118, 111],
  s,
  [272, 4, 1],
  277,
  26,
  38,
  144,
  240,
  259,
  144,
  c,
  [2124, 68],
  c,
  [2582, 49],
  23,
  74,
  75,
  115,
  176,
  c,
  [808, 89],
  182,
  228,
  30,
  80,
  134,
  144,
  c,
  [346, 3],
  c,
  [7, 7],
  c,
  [601, 4],
  134,
  182,
  c,
  [724, 17],
  c,
  [1473, 102],
  11,
  12,
  c,
  [115, 13],
  c,
  [2809, 4],
  53,
  54,
  c,
  [210, 7],
  c,
  [124, 49],
  168,
  169,
  170,
  173,
  c,
  [1714, 67],
  c,
  [964, 90],
  c,
  [116, 132],
  c,
  [1945, 103],
  17,
  c,
  [230, 18],
  c,
  [1118, 3],
  c,
  [116, 13],
  114,
  c,
  [117, 52],
  213,
  215,
  c,
  [119, 28],
  15,
  c,
  [233, 3],
  25,
  c,
  [120, 32],
  c,
  [236, 67],
  246,
  248,
  250,
  c,
  [120, 8],
  30,
  80,
  232,
  c,
  [1416, 3],
  134,
  c,
  [1203, 3],
  128,
  130,
  131,
  s,
  [223, 4, 1],
  c,
  [131, 3],
  38,
  c,
  [98, 10],
  144,
  150,
  c,
  [59, 6],
  240,
  s,
  [261, 5, 1],
  268,
  125,
  126,
  128,
  s,
  [219, 4, 1],
  c,
  [3693, 7],
  17,
  21,
  s,
  [22, 4, 2],
  c,
  [175, 7],
  39,
  c,
  [410, 50],
  c,
  [1113, 48],
  c,
  [3149, 591],
  c,
  [1205, 209],
  c,
  [113, 69],
  c,
  [3029, 65],
  c,
  [228, 52],
  194,
  c,
  [910, 441],
  c,
  [66, 71],
  c,
  [2377, 138],
  c,
  [485, 210],
  75,
  125,
  126,
  c,
  [5389, 3],
  114,
  c,
  [1402, 137],
  c,
  [3496, 4],
  c,
  [116, 48],
  177,
  178,
  c,
  [4091, 129],
  c,
  [5816, 7],
  c,
  [327, 113],
  99,
  100,
  c,
  [115, 8],
  c,
  [2412, 9],
  c,
  [1732, 100],
  c,
  [328, 96],
  c,
  [6137, 181],
  157,
  176,
  c,
  [89, 9],
  19,
  c,
  [6379, 43],
  c,
  [331, 184],
  c,
  [96, 199],
  c,
  [947, 113],
  c,
  [209, 209],
  c,
  [208, 9],
  16,
  19,
  32,
  38,
  c,
  [761, 27],
  81,
  c,
  [762, 14],
  182,
  c,
  [170, 17],
  c,
  [4736, 100],
  c,
  [286, 113],
  c,
  [5978, 5],
  18,
  84,
  86,
  87,
  c,
  [503, 11],
  18,
  19,
  23,
  27,
  c,
  [5584, 3],
  c,
  [300, 27],
  74,
  75,
  c,
  [5547, 3],
  c,
  [494, 3],
  c,
  [306, 6],
  115,
  125,
  126,
  c,
  [5534, 5],
  c,
  [5533, 27],
  c,
  [5165, 90],
  15,
  18,
  84,
  18,
  84,
  99,
  100,
  c,
  [191, 10],
  c,
  [190, 3],
  c,
  [186, 29],
  c,
  [184, 13],
  c,
  [183, 4],
  237,
  c,
  [60, 12],
  c,
  [59, 27],
  84,
  c,
  [1307, 15],
  c,
  [1359, 10],
  c,
  [599, 43],
  c,
  [768, 27],
  84,
  89,
  90,
  92,
  94,
  c,
  [294, 48],
  s,
  [188, 4, 1],
  c,
  [489, 37],
  38,
  c,
  [985, 89],
  197,
  c,
  [3751, 127],
  c,
  [5992, 7],
  c,
  [2136, 119],
  c,
  [6362, 38],
  c,
  [6428, 3],
  c,
  [326, 31],
  181,
  232,
  16,
  c,
  [6467, 3],
  81,
  182,
  30,
  232,
  c,
  [6250, 12],
  c,
  [347, 116],
  c,
  [230, 58],
  c,
  [229, 33],
  232,
  c,
  [92, 58],
  c,
  [6683, 34],
  c,
  [1722, 96],
  38,
  82,
  c,
  [398, 16],
  c,
  [5176, 51],
  c,
  [1554, 55],
  c,
  [5588, 64],
  c,
  [119, 26],
  c,
  [5590, 25],
  c,
  [647, 28],
  c,
  [248, 99],
  15,
  26,
  31,
  38,
  179,
  28,
  15,
  17,
  c,
  [452, 3],
  38,
  39,
  118,
  c,
  [8, 15],
  77,
  118,
  117,
  144,
  15,
  17,
  c,
  [480, 4],
  c,
  [20, 5],
  26,
  38,
  77,
  114,
  117,
  144,
  214,
  216,
  241,
  15,
  16,
  24,
  25,
  c,
  [181, 4],
  s,
  [239, 5, 2],
  250,
  c,
  [6502, 7],
  c,
  [1876, 113],
  c,
  [105, 4],
  163,
  c,
  [2376, 162],
  c,
  [403, 49],
  c,
  [7215, 6],
  279,
  c,
  [7222, 7],
  15,
  26,
  179,
  c,
  [7225, 4],
  c,
  [7224, 39],
  c,
  [373, 97],
  114,
  144,
  240,
  281,
  282,
  38,
  30,
  c,
  [7575, 4],
  c,
  [160, 3],
  182,
  c,
  [1221, 86],
  c,
  [1130, 96],
  179,
  c,
  [311, 110],
  c,
  [2369, 5],
  c,
  [8112, 94],
  c,
  [7626, 5],
  259,
  134,
  139,
  231,
  16,
  38,
  134,
  231,
  c,
  [2354, 10],
  22,
  26,
  c,
  [3715, 42],
  22,
  26,
  c,
  [748, 115],
  75,
  176,
  114,
  c,
  [4726, 17],
  c,
  [8300, 101],
  32,
  c,
  [701, 3],
  228,
  c,
  [8527, 4],
  80,
  81,
  134,
  231,
  30,
  134,
  231,
  c,
  [17, 10],
  c,
  [7723, 3],
  228,
  231,
  c,
  [6883, 29],
  30,
  c,
  [1888, 21],
  c,
  [3823, 165],
  c,
  [89, 178],
  c,
  [3792, 129],
  19,
  c,
  [836, 43],
  c,
  [262, 96],
  c,
  [3941, 173],
  c,
  [2097, 4],
  c,
  [1386, 24],
  c,
  [7978, 94],
  c,
  [390, 10],
  17,
  19,
  23,
  26,
  c,
  [383, 9],
  c,
  [381, 22],
  77,
  c,
  [3751, 10],
  143,
  20,
  c,
  [11435, 11],
  20,
  23,
  c,
  [505, 28],
  c,
  [56, 14],
  c,
  [8091, 120],
  c,
  [790, 38],
  c,
  [349, 53],
  c,
  [347, 33],
  16,
  c,
  [348, 4],
  c,
  [4289, 4],
  c,
  [351, 31],
  80,
  c,
  [653, 8],
  c,
  [4288, 9],
  c,
  [415, 12],
  c,
  [414, 30],
  c,
  [711, 8],
  c,
  [407, 11],
  c,
  [406, 43],
  c,
  [5607, 4],
  15,
  25,
  c,
  [645, 3],
  249,
  250,
  c,
  [417, 9],
  c,
  [648, 31],
  c,
  [415, 116],
  c,
  [414, 85],
  19,
  c,
  [248, 3],
  c,
  [346, 28],
  c,
  [296, 8],
  c,
  [4400, 34],
  c,
  [6651, 92],
  c,
  [819, 5],
  c,
  [8736, 17],
  c,
  [405, 44],
  250,
  30,
  232,
  c,
  [8854, 3],
  132,
  223,
  224,
  226,
  c,
  [194, 113],
  15,
  26,
  38,
  135,
  179,
  c,
  [113, 3],
  c,
  [2088, 25],
  c,
  [33, 3],
  39,
  79,
  115,
  134,
  135,
  c,
  [8, 4],
  115,
  135,
  c,
  [42, 22],
  260,
  261,
  262,
  265,
  268,
  115,
  c,
  [2159, 23],
  c,
  [29, 5],
  269,
  38,
  c,
  [2932, 3],
  266,
  267,
  s,
  [125, 4, 1],
  219,
  220,
  222,
  c,
  [5801, 209],
  c,
  [96, 576],
  c,
  [5901, 116],
  c,
  [6087, 13],
  c,
  [6086, 37],
  c,
  [6085, 18],
  c,
  [280, 89],
  c,
  [9079, 115],
  c,
  [868, 473],
  c,
  [281, 192],
  c,
  [8075, 44],
  116,
  c,
  [2315, 8],
  c,
  [1967, 3],
  76,
  c,
  [3256, 40],
  c,
  [8856, 77],
  c,
  [2494, 11],
  c,
  [2493, 30],
  76,
  c,
  [2494, 129],
  c,
  [345, 10],
  c,
  [14800, 44],
  c,
  [1547, 111],
  c,
  [6200, 106],
  c,
  [378, 160],
  c,
  [53, 53],
  c,
  [5016, 116],
  c,
  [5307, 54],
  c,
  [4733, 209],
  c,
  [113, 565],
  c,
  [8795, 14],
  c,
  [4507, 5],
  c,
  [8796, 50],
  c,
  [897, 10],
  c,
  [8671, 30],
  c,
  [8670, 17],
  c,
  [352, 139],
  c,
  [8674, 95],
  26,
  39,
  16,
  26,
  c,
  [6183, 3],
  93,
  182,
  c,
  [5518, 42],
  91,
  c,
  [1200, 7],
  182,
  c,
  [1364, 126],
  c,
  [1362, 28],
  c,
  [163, 8],
  c,
  [1267, 7],
  c,
  [16761, 4],
  c,
  [14364, 7],
  c,
  [11641, 77],
  c,
  [11640, 49],
  c,
  [126, 252],
  c,
  [734, 115],
  c,
  [8970, 136],
  c,
  [3174, 96],
  c,
  [7547, 73],
  182,
  c,
  [8977, 97],
  c,
  [96, 89],
  c,
  [8129, 24],
  c,
  [9579, 38],
  c,
  [15238, 33],
  c,
  [95, 4],
  c,
  [5525, 115],
  c,
  [8912, 3],
  c,
  [3952, 205],
  28,
  c,
  [90, 89],
  c,
  [9746, 65],
  c,
  [9837, 91],
  c,
  [91, 6],
  c,
  [3538, 116],
  26,
  39,
  17,
  26,
  c,
  [582, 5],
  c,
  [10492, 117],
  28,
  16,
  24,
  c,
  [4092, 3],
  c,
  [9565, 4],
  c,
  [9745, 4],
  26,
  38,
  c,
  [14492, 304],
  c,
  [113, 151],
  23,
  114,
  c,
  [7950, 5],
  20,
  c,
  [6, 4],
  39,
  118,
  c,
  [10054, 3],
  c,
  [7320, 3],
  c,
  [7319, 3],
  16,
  24,
  c,
  [10055, 7],
  c,
  [8831, 15],
  c,
  [8317, 11],
  c,
  [4017, 43],
  26,
  39,
  141,
  276,
  8,
  16,
  c,
  [9788, 4],
  139,
  90,
  c,
  [6708, 3],
  284,
  285,
  38,
  c,
  [9803, 9],
  26,
  c,
  [8, 3],
  26,
  39,
  c,
  [247, 113],
  39,
  39,
  c,
  [1419, 96],
  c,
  [337, 3],
  c,
  [342, 5],
  39,
  139,
  c,
  [9882, 5],
  c,
  [13576, 27],
  c,
  [228, 85],
  c,
  [17224, 6],
  c,
  [7137, 4],
  179,
  39,
  139,
  16,
  38,
  253,
  26,
  39,
  116,
  c,
  [242, 96],
  c,
  [9397, 6],
  232,
  c,
  [9378, 29],
  c,
  [7323, 5],
  c,
  [2753, 126],
  11,
  12,
  47,
  48,
  c,
  [104, 7],
  173,
  c,
  [6660, 122],
  c,
  [1317, 156],
  c,
  [1690, 49],
  c,
  [4893, 54],
  c,
  [1138, 3],
  c,
  [11485, 9],
  c,
  [791, 17],
  c,
  [9096, 69],
  c,
  [9095, 24],
  c,
  [791, 5],
  c,
  [8168, 7],
  c,
  [125, 13],
  c,
  [8169, 11],
  c,
  [17547, 206],
  c,
  [8576, 14],
  c,
  [8575, 43],
  c,
  [9337, 10],
  c,
  [9395, 36],
  c,
  [8932, 15],
  25,
  c,
  [8524, 19],
  c,
  [356, 12],
  c,
  [1274, 80],
  c,
  [8929, 10],
  c,
  [1275, 7],
  249,
  250,
  c,
  [8825, 42],
  c,
  [5786, 24],
  c,
  [57, 48],
  15,
  c,
  [116, 10],
  c,
  [6621, 35],
  129,
  c,
  [55, 8],
  c,
  [1564, 4],
  c,
  [1336, 22],
  c,
  [1335, 3],
  c,
  [207, 7],
  144,
  240,
  c,
  [1373, 29],
  13,
  14,
  22,
  c,
  [7025, 173],
  c,
  [3752, 6],
  116,
  c,
  [9482, 5],
  c,
  [8837, 27],
  269,
  c,
  [116, 3],
  c,
  [387, 4],
  c,
  [2217, 5],
  c,
  [8819, 5],
  c,
  [661, 10],
  c,
  [354, 44],
  c,
  [7963, 13],
  c,
  [5254, 36],
  c,
  [14049, 34],
  c,
  [20785, 401],
  c,
  [8214, 37],
  c,
  [575, 11],
  20,
  c,
  [6775, 59],
  c,
  [20727, 98],
  38,
  76,
  c,
  [2615, 18],
  c,
  [1343, 8],
  c,
  [16522, 52],
  c,
  [7665, 41],
  c,
  [1134, 5],
  c,
  [7670, 42],
  c,
  [7125, 25],
  c,
  [22357, 45],
  c,
  [9200, 196],
  c,
  [6008, 9],
  21,
  23,
  c,
  [3999, 12],
  c,
  [20482, 8],
  c,
  [20480, 25],
  c,
  [2044, 4],
  88,
  c,
  [462, 3],
  c,
  [20469, 3],
  c,
  [464, 8],
  115,
  c,
  [465, 17],
  c,
  [20459, 12],
  c,
  [10029, 143],
  c,
  [95, 9],
  c,
  [15170, 29],
  c,
  [552, 25],
  c,
  [52, 27],
  85,
  c,
  [53, 24],
  c,
  [11882, 48],
  c,
  [57, 66],
  c,
  [6778, 31],
  88,
  c,
  [292, 5],
  c,
  [6779, 11],
  192,
  c,
  [6780, 114],
  c,
  [15563, 55],
  c,
  [3970, 28],
  c,
  [6103, 110],
  c,
  [120, 63],
  c,
  [6222, 156],
  84,
  94,
  95,
  191,
  c,
  [4, 4],
  c,
  [7019, 126],
  c,
  [1427, 44],
  c,
  [18655, 127],
  c,
  [7374, 4],
  50,
  81,
  93,
  c,
  [7, 14],
  26,
  c,
  [4538, 97],
  c,
  [13815, 117],
  c,
  [6291, 116],
  c,
  [18026, 90],
  182,
  c,
  [3581, 3],
  c,
  [327, 116],
  82,
  c,
  [1225, 13],
  c,
  [5917, 106],
  c,
  [7325, 212],
  c,
  [775, 117],
  c,
  [5751, 5],
  c,
  [6241, 4],
  c,
  [10, 6],
  c,
  [15997, 5],
  c,
  [2236, 105],
  c,
  [4322, 3],
  c,
  [15954, 5],
  c,
  [4133, 52],
  c,
  [59, 100],
  118,
  c,
  [60, 8],
  c,
  [6068, 3],
  c,
  [16135, 7],
  c,
  [16122, 6],
  216,
  241,
  c,
  [4129, 3],
  16,
  17,
  c,
  [6561, 6],
  118,
  c,
  [6072, 5],
  c,
  [1101, 113],
  20,
  25,
  c,
  [16253, 4],
  26,
  c,
  [6199, 7],
  247,
  250,
  26,
  c,
  [21901, 30],
  c,
  [6162, 3],
  139,
  144,
  240,
  c,
  [5925, 10],
  c,
  [6169, 7],
  141,
  276,
  c,
  [6183, 6],
  c,
  [19115, 45],
  c,
  [457, 8],
  26,
  c,
  [67, 3],
  282,
  26,
  c,
  [79, 5],
  144,
  240,
  90,
  c,
  [94, 3],
  26,
  c,
  [5094, 7],
  c,
  [264, 105],
  c,
  [6006, 4],
  c,
  [15811, 115],
  c,
  [4668, 24],
  c,
  [4415, 5],
  16,
  253,
  17,
  30,
  38,
  113,
  114,
  134,
  144,
  148,
  254,
  255,
  256,
  22,
  c,
  [13340, 6],
  c,
  [6607, 4],
  c,
  [8034, 58],
  c,
  [12265, 48],
  c,
  [13323, 282],
  c,
  [17373, 121],
  c,
  [14520, 11],
  c,
  [6066, 43],
  c,
  [3811, 157],
  c,
  [15313, 92],
  c,
  [23290, 29],
  c,
  [15429, 112],
  c,
  [5383, 3],
  c,
  [15017, 50],
  c,
  [11914, 123],
  c,
  [173, 173],
  20,
  c,
  [117, 8],
  c,
  [15665, 9],
  c,
  [118, 51],
  c,
  [14962, 56],
  c,
  [15364, 114],
  c,
  [118, 102],
  c,
  [117, 10],
  39,
  c,
  [14999, 24],
  c,
  [2068, 3],
  c,
  [27, 27],
  c,
  [15018, 4],
  c,
  [15059, 30],
  c,
  [15018, 4],
  c,
  [6464, 23],
  c,
  [90, 5],
  c,
  [28, 25],
  26,
  38,
  c,
  [1854, 29],
  c,
  [5386, 5],
  26,
  38,
  26,
  c,
  [15084, 4],
  267,
  c,
  [13, 5],
  c,
  [7219, 6],
  38,
  39,
  c,
  [50, 24],
  c,
  [15113, 305],
  c,
  [4960, 75],
  c,
  [6205, 99],
  c,
  [12978, 69],
  c,
  [875, 58],
  c,
  [6083, 41],
  c,
  [13864, 116],
  c,
  [790, 3],
  c,
  [13042, 338],
  c,
  [25886, 329],
  c,
  [1128, 59],
  26,
  39,
  c,
  [5441, 136],
  c,
  [5440, 44],
  c,
  [10157, 56],
  49,
  82,
  c,
  [23361, 186],
  c,
  [5242, 4],
  c,
  [11839, 61],
  c,
  [194, 39],
  c,
  [21004, 17],
  c,
  [23768, 285],
  c,
  [96, 103],
  c,
  [9688, 10],
  c,
  [1112, 108],
  c,
  [4994, 6],
  c,
  [6, 6],
  c,
  [12375, 114],
  c,
  [11192, 4],
  117,
  144,
  c,
  [3428, 57],
  c,
  [21297, 10],
  c,
  [5055, 3],
  c,
  [5053, 9],
  c,
  [2927, 5],
  125,
  141,
  276,
  144,
  240,
  141,
  276,
  26,
  c,
  [5018, 4],
  285,
  c,
  [4951, 8],
  144,
  240,
  c,
  [4952, 6],
  125,
  39,
  144,
  240,
  c,
  [4975, 4],
  144,
  240,
  82,
  c,
  [374, 5],
  c,
  [12812, 90],
  c,
  [9241, 26],
  c,
  [27, 27],
  c,
  [9261, 6],
  30,
  c,
  [4855, 8],
  30,
  134,
  144,
  231,
  20,
  30,
  c,
  [13, 3],
  c,
  [4858, 6],
  228,
  c,
  [1058, 100],
  c,
  [4451, 54],
  17,
  26,
  c,
  [30808, 91],
  c,
  [807, 12],
  c,
  [1565, 54],
  c,
  [1799, 59],
  c,
  [1324, 111],
  c,
  [10240, 7],
  25,
  39,
  c,
  [9, 5],
  c,
  [11517, 90],
  c,
  [3733, 24],
  c,
  [3792, 26],
  265,
  268,
  c,
  [141, 141],
  c,
  [865, 54],
  c,
  [10132, 7],
  25,
  c,
  [3863, 4],
  c,
  [4, 4],
  17,
  c,
  [1147, 4],
  c,
  [17, 3],
  c,
  [78, 54],
  c,
  [8547, 172],
  c,
  [593, 6],
  76,
  c,
  [8840, 114],
  c,
  [4072, 201],
  c,
  [21028, 64],
  c,
  [483, 97],
  82,
  c,
  [1568, 100],
  c,
  [582, 3],
  c,
  [7172, 60],
  c,
  [61, 13],
  c,
  [2035, 46],
  c,
  [1796, 6],
  39,
  c,
  [2016, 3],
  125,
  c,
  [2012, 5],
  c,
  [1988, 3],
  c,
  [7055, 3],
  141,
  276,
  13,
  14,
  c,
  [4031, 90],
  26,
  c,
  [6788, 7],
  255,
  256,
  c,
  [11468, 7],
  30,
  144,
  240,
  257,
  c,
  [1042, 27],
  c,
  [11896, 13],
  c,
  [5686, 161],
  39,
  135,
  39,
  115,
  c,
  [315, 89],
  c,
  [91, 91],
  c,
  [1478, 7],
  c,
  [505, 3],
  c,
  [4, 3],
  c,
  [1472, 5],
  c,
  [11, 3],
  c,
  [5313, 209],
  c,
  [215, 3],
  c,
  [4437, 248],
  c,
  [9820, 109],
  c,
  [1496, 48],
  s,
  [125, 3],
  c,
  [2978, 6],
  c,
  [2977, 3],
  c,
  [8, 7],
  17,
  30,
  232,
  c,
  [2121, 34],
  c,
  [11360, 246],
  c,
  [20752, 218],
  c,
  [667, 90],
  s,
  [39, 4],
  20,
  c,
  [593, 7],
  c,
  [14591, 97],
  c,
  [2861, 29],
  c,
  [130, 4]
]),
  type: u([
  s,
  [2, 67],
  s,
  [0, 50],
  1,
  c,
  [103, 59],
  s,
  [2, 96],
  c,
  [100, 94],
  c,
  [91, 159],
  s,
  [0, 47],
  c,
  [204, 156],
  c,
  [203, 113],
  c,
  [113, 452],
  c,
  [114, 228],
  c,
  [113, 52],
  c,
  [119, 114],
  c,
  [1118, 71],
  c,
  [1233, 203],
  c,
  [226, 25],
  c,
  [236, 11],
  c,
  [1818, 94],
  c,
  [401, 115],
  c,
  [116, 5],
  c,
  [121, 7],
  c,
  [419, 14],
  c,
  [2057, 97],
  c,
  [856, 101],
  c,
  [198, 19],
  c,
  [1118, 124],
  c,
  [116, 5],
  c,
  [5, 3],
  c,
  [123, 120],
  c,
  [808, 97],
  c,
  [103, 8],
  c,
  [384, 27],
  c,
  [1123, 172],
  c,
  [1365, 165],
  c,
  [116, 183],
  c,
  [472, 117],
  c,
  [464, 117],
  c,
  [584, 54],
  c,
  [123, 11],
  c,
  [137, 20],
  c,
  [1110, 18],
  c,
  [764, 73],
  c,
  [524, 227],
  c,
  [3149, 453],
  c,
  [681, 275],
  c,
  [2137, 116],
  c,
  [797, 407],
  c,
  [3005, 188],
  c,
  [485, 232],
  c,
  [4437, 184],
  c,
  [2377, 121],
  c,
  [5816, 92],
  c,
  [209, 118],
  c,
  [328, 210],
  c,
  [6137, 116],
  c,
  [90, 46],
  c,
  [331, 196],
  c,
  [96, 261],
  c,
  [1156, 305],
  c,
  [4859, 127],
  c,
  [286, 114],
  c,
  [1447, 73],
  c,
  [306, 183],
  c,
  [714, 102],
  c,
  [2138, 125],
  c,
  [7760, 161],
  c,
  [207, 117],
  c,
  [324, 138],
  c,
  [5639, 9],
  c,
  [5880, 9],
  c,
  [5419, 190],
  c,
  [8315, 114],
  c,
  [6071, 93],
  c,
  [3092, 193],
  c,
  [1073, 57],
  c,
  [4516, 120],
  c,
  [1689, 51],
  c,
  [168, 10],
  c,
  [67, 12],
  c,
  [1876, 191],
  c,
  [2376, 138],
  c,
  [6831, 14],
  c,
  [6014, 15],
  c,
  [7224, 83],
  c,
  [6157, 50],
  c,
  [118, 11],
  c,
  [1451, 94],
  c,
  [9332, 203],
  c,
  [8112, 97],
  c,
  [7626, 4],
  c,
  [556, 7],
  c,
  [2354, 123],
  c,
  [278, 50],
  c,
  [1401, 119],
  c,
  [7698, 13],
  c,
  [868, 8],
  c,
  [1421, 11],
  c,
  [6883, 30],
  c,
  [3823, 186],
  c,
  [5551, 185],
  c,
  [3792, 159],
  c,
  [4054, 152],
  c,
  [3941, 128],
  c,
  [1110, 119],
  c,
  [6298, 298],
  c,
  [10503, 116],
  c,
  [336, 108],
  c,
  [10030, 75],
  c,
  [6713, 214],
  c,
  [6324, 192],
  c,
  [1979, 8],
  c,
  [3200, 134],
  c,
  [227, 42],
  c,
  [41, 29],
  c,
  [7069, 23],
  c,
  [5801, 278],
  c,
  [96, 577],
  c,
  [1911, 117],
  c,
  [2185, 204],
  c,
  [868, 473],
  c,
  [281, 238],
  c,
  [3256, 79],
  c,
  [1111, 100],
  c,
  [3870, 318],
  c,
  [7754, 184],
  c,
  [776, 106],
  c,
  [1610, 159],
  c,
  [8734, 282],
  c,
  [11975, 568],
  c,
  [15815, 236],
  c,
  [8674, 63],
  c,
  [130, 51],
  c,
  [1364, 163],
  c,
  [15372, 79],
  c,
  [5575, 137],
  c,
  [126, 244],
  c,
  [9408, 119],
  c,
  [3647, 233],
  c,
  [14936, 72],
  c,
  [191, 122],
  c,
  [9904, 95],
  c,
  [8725, 281],
  c,
  [7585, 204],
  c,
  [18152, 205],
  c,
  [16502, 80],
  c,
  [2142, 58],
  c,
  [9878, 122],
  c,
  [2972, 345],
  c,
  [120, 14],
  c,
  [9707, 10],
  c,
  [8848, 14],
  c,
  [3847, 60],
  c,
  [73, 11],
  c,
  [10332, 11],
  c,
  [17146, 126],
  c,
  [1419, 96],
  c,
  [17686, 80],
  c,
  [10690, 55],
  c,
  [10000, 98],
  c,
  [587, 26],
  c,
  [7290, 20],
  c,
  [2753, 138],
  c,
  [1936, 165],
  c,
  [1317, 161],
  c,
  [4893, 130],
  c,
  [17894, 126],
  c,
  [3274, 214],
  c,
  [173, 64],
  c,
  [482, 77],
  c,
  [11965, 58],
  c,
  [249, 107],
  c,
  [10629, 55],
  c,
  [8555, 36],
  c,
  [8787, 13],
  c,
  [8663, 54],
  c,
  [2988, 174],
  c,
  [1458, 27],
  c,
  [1136, 123],
  c,
  [20785, 454],
  c,
  [14320, 103],
  c,
  [2725, 140],
  c,
  [1825, 103],
  c,
  [6956, 223],
  c,
  [4476, 140],
  c,
  [5322, 189],
  c,
  [7677, 109],
  c,
  [15880, 122],
  c,
  [1075, 163],
  c,
  [17320, 126],
  c,
  [6223, 122],
  c,
  [1365, 119],
  c,
  [5755, 71],
  c,
  [8383, 181],
  c,
  [16051, 140],
  c,
  [4021, 148],
  c,
  [11586, 208],
  c,
  [7089, 188],
  c,
  [7325, 328],
  c,
  [15458, 55],
  c,
  [10, 13],
  c,
  [233, 149],
  c,
  [59, 118],
  c,
  [60, 24],
  c,
  [18, 15],
  c,
  [3245, 127],
  c,
  [12859, 40],
  c,
  [1807, 17],
  c,
  [4413, 8],
  c,
  [6247, 60],
  c,
  [15163, 15],
  c,
  [21086, 181],
  c,
  [1833, 66],
  c,
  [15381, 22],
  c,
  [9022, 14],
  c,
  [4655, 156],
  c,
  [8616, 236],
  c,
  [2935, 164],
  c,
  [3811, 232],
  c,
  [2040, 164],
  c,
  [1594, 77],
  c,
  [176, 150],
  c,
  [13634, 190],
  c,
  [698, 165],
  c,
  [700, 135],
  c,
  [28, 27],
  c,
  [26113, 33],
  c,
  [206, 31],
  c,
  [1824, 39],
  c,
  [15106, 35],
  c,
  [8367, 13],
  c,
  [312, 21],
  c,
  [22793, 214],
  c,
  [96, 160],
  c,
  [6205, 163],
  c,
  [23666, 188],
  c,
  [17119, 142],
  c,
  [24565, 415],
  c,
  [10189, 220],
  c,
  [6204, 58],
  c,
  [12203, 173],
  c,
  [11925, 102],
  c,
  [5242, 102],
  c,
  [21005, 214],
  c,
  [15983, 292],
  c,
  [12250, 119],
  c,
  [19897, 14],
  c,
  [1237, 165],
  c,
  [21478, 15],
  c,
  [5053, 16],
  c,
  [4930, 5],
  c,
  [18118, 9],
  c,
  [18134, 11],
  c,
  [6857, 11],
  c,
  [4702, 9],
  c,
  [18747, 109],
  c,
  [3121, 47],
  c,
  [1042, 17],
  c,
  [1058, 149],
  c,
  [1406, 111],
  c,
  [159, 102],
  c,
  [2143, 127],
  c,
  [11413, 26],
  c,
  [672, 100],
  c,
  [3700, 45],
  c,
  [141, 137],
  c,
  [865, 44],
  c,
  [22026, 10],
  c,
  [211, 24],
  c,
  [78, 49],
  c,
  [8547, 167],
  c,
  [4821, 58],
  c,
  [20779, 125],
  c,
  [21028, 248],
  c,
  [14252, 204],
  c,
  [17812, 70],
  c,
  [13205, 13],
  c,
  [12, 6],
  c,
  [1175, 101],
  c,
  [1426, 11],
  c,
  [1042, 80],
  c,
  [4345, 215],
  c,
  [21552, 226],
  c,
  [1241, 167],
  c,
  [30439, 329],
  c,
  [14931, 19],
  c,
  [2123, 11],
  c,
  [21142, 51],
  c,
  [20848, 489],
  c,
  [1432, 149],
  c,
  [2783, 41]
]),
  state: u([
  s,
  [1, 4, 1],
  15,
  16,
  7,
  42,
  35,
  29,
  14,
  9,
  10,
  13,
  11,
  47,
  8,
  43,
  44,
  49,
  95,
  6,
  31,
  33,
  32,
  27,
  63,
  28,
  66,
  102,
  113,
  67,
  105,
  30,
  75,
  74,
  106,
  12,
  48,
  26,
  51,
  64,
  5,
  25,
  24,
  22,
  59,
  17,
  20,
  21,
  126,
  165,
  118,
  119,
  122,
  123,
  128,
  169,
  171,
  113,
  168,
  175,
  176,
  177,
  c,
  [60, 38],
  179,
  c,
  [60, 7],
  180,
  184,
  c,
  [48, 46],
  187,
  c,
  [47, 17],
  185,
  c,
  [47, 28],
  188,
  c,
  [94, 46],
  189,
  c,
  [47, 46],
  190,
  c,
  [47, 46],
  191,
  c,
  [47, 46],
  193,
  c,
  [47, 46],
  195,
  c,
  [47, 46],
  197,
  206,
  c,
  [48, 7],
  199,
  203,
  9,
  200,
  c,
  [51, 27],
  205,
  201,
  c,
  [51, 4],
  204,
  202,
  c,
  [51, 3],
  207,
  c,
  [98, 46],
  210,
  212,
  213,
  218,
  220,
  217,
  223,
  225,
  c,
  [54, 7],
  226,
  c,
  [55, 39],
  231,
  238,
  233,
  235,
  236,
  237,
  239,
  245,
  249,
  c,
  [110, 46],
  253,
  251,
  261,
  262,
  c,
  [20, 3],
  265,
  257,
  59,
  254,
  258,
  c,
  [549, 18],
  c,
  [59, 17],
  269,
  26,
  270,
  c,
  [59, 6],
  266,
  268,
  c,
  [61, 3],
  274,
  271,
  275,
  277,
  3,
  276,
  c,
  [758, 46],
  279,
  285,
  283,
  286,
  106,
  287,
  289,
  106,
  287,
  291,
  293,
  294,
  c,
  [171, 46],
  297,
  c,
  [47, 4],
  295,
  296,
  35,
  298,
  c,
  [50, 41],
  302,
  c,
  [97, 7],
  301,
  c,
  [48, 39],
  303,
  c,
  [48, 7],
  304,
  c,
  [48, 39],
  305,
  c,
  [901, 64],
  318,
  c,
  [47, 5],
  308,
  310,
  28,
  313,
  c,
  [49, 4],
  311,
  c,
  [49, 4],
  317,
  26,
  316,
  c,
  [49, 9],
  324,
  c,
  [96, 38],
  320,
  322,
  325,
  c,
  [50, 8],
  328,
  335,
  105,
  332,
  333,
  345,
  c,
  [31, 5],
  339,
  342,
  340,
  336,
  338,
  344,
  343,
  352,
  113,
  349,
  350,
  353,
  c,
  [1178, 47],
  354,
  c,
  [216, 46],
  355,
  c,
  [47, 46],
  356,
  c,
  [47, 46],
  357,
  c,
  [47, 46],
  358,
  c,
  [47, 46],
  359,
  c,
  [47, 7],
  360,
  c,
  [48, 39],
  361,
  c,
  [499, 55],
  363,
  c,
  [1068, 28],
  364,
  c,
  [48, 5],
  362,
  c,
  [48, 3],
  367,
  c,
  [95, 10],
  365,
  c,
  [96, 36],
  368,
  c,
  [143, 46],
  369,
  c,
  [47, 46],
  370,
  c,
  [929, 51],
  373,
  c,
  [929, 44],
  374,
  c,
  [97, 46],
  375,
  c,
  [47, 46],
  376,
  377,
  113,
  379,
  c,
  [50, 46],
  384,
  c,
  [47, 6],
  381,
  383,
  c,
  [49, 40],
  c,
  [1988, 7],
  386,
  c,
  [103, 46],
  387,
  c,
  [47, 7],
  390,
  c,
  [102, 46],
  c,
  [2090, 4],
  279,
  c,
  [12, 7],
  c,
  [7, 28],
  391,
  c,
  [142, 46],
  c,
  [54, 7],
  392,
  c,
  [54, 52],
  394,
  128,
  277,
  3,
  395,
  c,
  [1117, 46],
  396,
  c,
  [104, 46],
  397,
  223,
  c,
  [1687, 36],
  404,
  403,
  c,
  [1687, 11],
  180,
  c,
  [271, 14],
  413,
  c,
  [64, 3],
  411,
  c,
  [64, 5],
  408,
  409,
  410,
  415,
  c,
  [117, 37],
  420,
  423,
  c,
  [116, 7],
  422,
  c,
  [166, 29],
  424,
  c,
  [49, 9],
  426,
  c,
  [48, 7],
  425,
  c,
  [214, 31],
  427,
  c,
  [48, 7],
  429,
  220,
  430,
  433,
  238,
  435,
  c,
  [1969, 4],
  436,
  c,
  [58, 7],
  438,
  c,
  [58, 31],
  437,
  c,
  [58, 7],
  439,
  441,
  c,
  [215, 7],
  445,
  c,
  [2672, 48],
  446,
  c,
  [49, 19],
  c,
  [1665, 23],
  c,
  [51, 8],
  238,
  447,
  c,
  [163, 4],
  c,
  [57, 20],
  c,
  [106, 29],
  451,
  460,
  462,
  464,
  238,
  469,
  237,
  239,
  467,
  468,
  470,
  471,
  106,
  287,
  c,
  [2250, 8],
  c,
  [497, 39],
  245,
  c,
  [224, 7],
  474,
  3,
  473,
  c,
  [118, 46],
  478,
  475,
  253,
  481,
  483,
  c,
  [2254, 6],
  486,
  59,
  484,
  487,
  488,
  c,
  [119, 46],
  492,
  489,
  490,
  226,
  223,
  495,
  c,
  [2307, 44],
  496,
  c,
  [620, 4],
  223,
  274,
  497,
  274,
  498,
  499,
  500,
  c,
  [180, 7],
  503,
  c,
  [298, 48],
  504,
  508,
  c,
  [48, 7],
  507,
  c,
  [167, 39],
  285,
  509,
  510,
  293,
  285,
  511,
  285,
  512,
  293,
  c,
  [2021, 9],
  514,
  c,
  [2021, 3],
  515,
  c,
  [754, 14],
  518,
  c,
  [1025, 53],
  c,
  [7, 13],
  519,
  c,
  [985, 3],
  522,
  c,
  [204, 46],
  523,
  c,
  [2272, 24],
  525,
  c,
  [2272, 24],
  528,
  c,
  [2272, 49],
  c,
  [99, 18],
  530,
  c,
  [218, 28],
  223,
  c,
  [1331, 4],
  534,
  532,
  535,
  c,
  [2377, 39],
  536,
  c,
  [105, 10],
  537,
  c,
  [323, 53],
  539,
  c,
  [54, 46],
  540,
  542,
  335,
  105,
  544,
  545,
  c,
  [52, 46],
  548,
  c,
  [505, 9],
  549,
  c,
  [505, 3],
  c,
  [13, 6],
  554,
  552,
  553,
  555,
  c,
  [12, 9],
  559,
  c,
  [12, 4],
  557,
  564,
  560,
  562,
  352,
  113,
  566,
  567,
  c,
  [521, 66],
  c,
  [7, 29],
  c,
  [1435, 37],
  568,
  c,
  [1435, 11],
  223,
  574,
  c,
  [50, 10],
  573,
  c,
  [147, 85],
  577,
  c,
  [1988, 7],
  579,
  c,
  [1988, 48],
  581,
  c,
  [300, 60],
  445,
  3,
  583,
  c,
  [813, 46],
  584,
  c,
  [110, 60],
  588,
  c,
  [61, 7],
  587,
  c,
  [62, 53],
  590,
  c,
  [123, 46],
  591,
  c,
  [47, 46],
  592,
  c,
  [47, 46],
  593,
  c,
  [47, 46],
  594,
  c,
  [3442, 64],
  c,
  [47, 18],
  595,
  c,
  [1071, 11],
  180,
  597,
  c,
  [96, 46],
  c,
  [2139, 10],
  598,
  c,
  [2139, 40],
  603,
  607,
  608,
  c,
  [100, 7],
  609,
  c,
  [446, 46],
  175,
  c,
  [2911, 5],
  611,
  c,
  [2910, 43],
  c,
  [49, 5],
  612,
  c,
  [49, 48],
  613,
  c,
  [49, 43],
  c,
  [256, 10],
  614,
  c,
  [256, 40],
  616,
  c,
  [254, 7],
  615,
  c,
  [254, 46],
  617,
  223,
  c,
  [9, 7],
  619,
  620,
  623,
  c,
  [470, 18],
  624,
  c,
  [66, 28],
  451,
  c,
  [58, 7],
  627,
  628,
  630,
  c,
  [2249, 49],
  636,
  c,
  [48, 7],
  634,
  c,
  [174, 39],
  238,
  638,
  c,
  [2352, 3],
  642,
  c,
  [53, 7],
  641,
  c,
  [53, 39],
  643,
  c,
  [629, 46],
  644,
  c,
  [47, 46],
  645,
  c,
  [47, 46],
  650,
  656,
  654,
  535,
  238,
  657,
  237,
  239,
  285,
  658,
  285,
  659,
  293,
  c,
  [314, 7],
  663,
  478,
  665,
  671,
  668,
  669,
  478,
  674,
  679,
  c,
  [1205, 53],
  684,
  492,
  687,
  490,
  c,
  [2392, 44],
  688,
  c,
  [59, 3],
  495,
  694,
  c,
  [61, 7],
  699,
  c,
  [1775, 9],
  700,
  c,
  [1775, 3],
  548,
  c,
  [674, 5],
  702,
  c,
  [674, 43],
  703,
  c,
  [72, 7],
  705,
  c,
  [129, 7],
  704,
  c,
  [56, 31],
  706,
  c,
  [2861, 9],
  708,
  c,
  [5582, 53],
  c,
  [2308, 24],
  713,
  c,
  [2307, 23],
  715,
  716,
  c,
  [49, 7],
  717,
  c,
  [209, 39],
  720,
  c,
  [48, 7],
  721,
  c,
  [3644, 50],
  c,
  [2310, 39],
  726,
  727,
  c,
  [60, 8],
  534,
  730,
  535,
  c,
  [1595, 14],
  731,
  c,
  [8, 7],
  c,
  [405, 9],
  733,
  c,
  [404, 3],
  737,
  c,
  [14, 9],
  738,
  c,
  [419, 3],
  745,
  c,
  [2183, 12],
  747,
  749,
  564,
  751,
  562,
  c,
  [52, 7],
  223,
  755,
  c,
  [574, 46],
  756,
  c,
  [1515, 82],
  757,
  c,
  [47, 10],
  c,
  [4457, 11],
  758,
  c,
  [327, 43],
  761,
  c,
  [4176, 53],
  765,
  c,
  [48, 40],
  766,
  c,
  [2266, 28],
  768,
  c,
  [2509, 73],
  771,
  c,
  [8, 7],
  773,
  128,
  775,
  180,
  c,
  [312, 36],
  779,
  c,
  [86, 17],
  c,
  [1529, 10],
  781,
  c,
  [1529, 40],
  c,
  [51, 10],
  782,
  c,
  [50, 39],
  783,
  c,
  [155, 7],
  784,
  c,
  [242, 39],
  785,
  787,
  788,
  c,
  [50, 7],
  789,
  c,
  [292, 46],
  c,
  [1110, 5],
  790,
  c,
  [4793, 44],
  c,
  [57, 7],
  793,
  c,
  [112, 7],
  792,
  c,
  [55, 39],
  794,
  c,
  [366, 18],
  795,
  c,
  [48, 28],
  169,
  796,
  c,
  [951, 3],
  798,
  c,
  [52, 7],
  799,
  c,
  [101, 39],
  804,
  c,
  [48, 7],
  802,
  c,
  [48, 39],
  806,
  c,
  [48, 7],
  805,
  c,
  [252, 46],
  808,
  c,
  [55, 7],
  807,
  c,
  [1819, 40],
  809,
  c,
  [1819, 3],
  238,
  810,
  c,
  [4177, 4],
  c,
  [742, 28],
  814,
  464,
  238,
  817,
  237,
  239,
  820,
  c,
  [748, 46],
  c,
  [4205, 4],
  823,
  824,
  c,
  [1160, 9],
  826,
  c,
  [1160, 3],
  828,
  831,
  834,
  671,
  838,
  669,
  839,
  478,
  840,
  c,
  [88, 7],
  492,
  843,
  845,
  848,
  684,
  c,
  [1671, 44],
  850,
  c,
  [1109, 38],
  c,
  [48, 9],
  851,
  c,
  [3296, 4],
  c,
  [1277, 7],
  852,
  c,
  [1277, 4],
  855,
  857,
  859,
  860,
  548,
  866,
  868,
  c,
  [950, 53],
  446,
  3,
  869,
  c,
  [4524, 40],
  870,
  c,
  [58, 14],
  872,
  c,
  [6292, 70],
  873,
  c,
  [1712, 23],
  c,
  [48, 24],
  874,
  c,
  [4068, 24],
  c,
  [3361, 9],
  876,
  c,
  [1872, 53],
  445,
  3,
  877,
  c,
  [56, 46],
  c,
  [3971, 47],
  c,
  [1812, 39],
  879,
  c,
  [4122, 10],
  c,
  [50, 39],
  880,
  c,
  [49, 9],
  c,
  [663, 9],
  882,
  c,
  [4004, 8],
  c,
  [12, 3],
  883,
  c,
  [1849, 3],
  c,
  [13, 9],
  886,
  c,
  [4042, 10],
  888,
  c,
  [4041, 10],
  891,
  c,
  [11, 10],
  896,
  c,
  [592, 4],
  745,
  564,
  900,
  749,
  c,
  [16, 7],
  902,
  c,
  [16, 4],
  c,
  [1466, 36],
  905,
  c,
  [1552, 24],
  906,
  180,
  c,
  [1794, 11],
  907,
  c,
  [666, 43],
  c,
  [1747, 7],
  908,
  c,
  [1795, 47],
  909,
  c,
  [3983, 48],
  911,
  c,
  [456, 46],
  912,
  c,
  [47, 46],
  914,
  c,
  [47, 7],
  913,
  c,
  [48, 39],
  916,
  c,
  [48, 7],
  915,
  c,
  [48, 39],
  917,
  c,
  [143, 46],
  918,
  c,
  [5811, 8],
  c,
  [3507, 49],
  c,
  [470, 14],
  169,
  921,
  c,
  [1584, 3],
  923,
  c,
  [13, 7],
  926,
  c,
  [132, 7],
  925,
  c,
  [2097, 60],
  927,
  928,
  c,
  [202, 46],
  929,
  464,
  930,
  464,
  931,
  c,
  [1267, 53],
  c,
  [3189, 4],
  c,
  [1480, 4],
  932,
  470,
  548,
  935,
  936,
  937,
  671,
  938,
  940,
  942,
  943,
  834,
  947,
  492,
  948,
  949,
  495,
  c,
  [756, 7],
  952,
  c,
  [4836, 11],
  953,
  c,
  [12, 4],
  957,
  958,
  859,
  860,
  959,
  285,
  962,
  963,
  c,
  [184, 21],
  715,
  c,
  [15, 14],
  969,
  c,
  [147, 7],
  971,
  c,
  [148, 39],
  534,
  972,
  535,
  c,
  [927, 7],
  554,
  977,
  c,
  [119, 10],
  978,
  c,
  [11, 10],
  979,
  c,
  [11, 10],
  980,
  c,
  [11, 10],
  981,
  c,
  [164, 11],
  982,
  c,
  [12, 4],
  564,
  984,
  564,
  985,
  c,
  [16, 7],
  987,
  c,
  [28, 11],
  988,
  c,
  [12, 4],
  989,
  180,
  990,
  c,
  [297, 46],
  992,
  c,
  [205, 6],
  994,
  c,
  [213, 7],
  996,
  c,
  [1857, 21],
  999,
  128,
  1000,
  c,
  [86, 46],
  1002,
  c,
  [320, 21],
  285,
  1005,
  1008,
  671,
  1010,
  1011,
  1014,
  1015,
  1017,
  860,
  957,
  1022,
  1021,
  c,
  [182, 7],
  1023,
  c,
  [182, 4],
  c,
  [1432, 9],
  1025,
  c,
  [1432, 46],
  1033,
  c,
  [533, 53],
  1036,
  c,
  [54, 7],
  1035,
  c,
  [55, 39],
  1038,
  c,
  [48, 7],
  1037,
  c,
  [48, 39],
  1039,
  c,
  [48, 7],
  1040,
  c,
  [151, 45],
  1042,
  128,
  1046,
  860,
  1047,
  860,
  1049,
  c,
  [279, 7],
  1050,
  c,
  [279, 11],
  c,
  [7, 28],
  1052,
  c,
  [108, 7],
  1053,
  c,
  [259, 46],
  c,
  [102, 7],
  1059,
  c,
  [102, 4]
]),
  mode: u([
  2,
  s,
  [1, 66],
  2,
  1,
  c,
  [69, 10],
  c,
  [12, 3],
  2,
  c,
  [83, 36],
  s,
  [2, 5],
  c,
  [7, 7],
  s,
  [2, 12],
  c,
  [18, 18],
  s,
  [2, 18],
  c,
  [55, 19],
  c,
  [61, 9],
  c,
  [28, 25],
  s,
  [2, 71],
  c,
  [95, 90],
  c,
  [325, 11],
  c,
  [395, 59],
  c,
  [153, 84],
  c,
  [87, 4],
  s,
  [1, 669],
  c,
  [988, 138],
  c,
  [67, 27],
  c,
  [167, 14],
  c,
  [1319, 5],
  c,
  [47, 22],
  c,
  [135, 39],
  c,
  [39, 28],
  c,
  [1375, 8],
  c,
  [361, 81],
  c,
  [1502, 9],
  c,
  [106, 13],
  c,
  [1056, 4],
  c,
  [1064, 13],
  c,
  [129, 8],
  c,
  [134, 8],
  c,
  [162, 23],
  c,
  [41, 11],
  c,
  [51, 19],
  c,
  [4, 5],
  c,
  [197, 9],
  c,
  [9, 8],
  c,
  [1322, 16],
  c,
  [16, 8],
  c,
  [1186, 158],
  c,
  [440, 21],
  c,
  [697, 36],
  c,
  [35, 33],
  c,
  [251, 8],
  c,
  [1442, 491],
  c,
  [2280, 7],
  c,
  [29, 24],
  c,
  [2452, 9],
  c,
  [828, 17],
  s,
  [1, 838],
  c,
  [2104, 83],
  c,
  [66, 49],
  c,
  [1375, 350],
  c,
  [490, 12],
  c,
  [1967, 13],
  c,
  [2392, 21],
  c,
  [2298, 7],
  c,
  [459, 19],
  c,
  [2040, 15],
  c,
  [226, 163],
  c,
  [209, 10],
  c,
  [759, 26],
  c,
  [4028, 10],
  c,
  [2266, 25],
  c,
  [4047, 98],
  c,
  [89, 64],
  c,
  [841, 53],
  c,
  [84, 14],
  c,
  [538, 22],
  c,
  [277, 11],
  c,
  [350, 16],
  c,
  [538, 26],
  c,
  [89, 35],
  c,
  [366, 12],
  c,
  [89, 220],
  c,
  [960, 292],
  c,
  [1785, 128],
  c,
  [345, 15],
  c,
  [931, 38],
  c,
  [3546, 9],
  c,
  [4078, 125],
  c,
  [544, 15],
  c,
  [584, 38],
  c,
  [4308, 186],
  c,
  [1427, 20],
  c,
  [4534, 156],
  c,
  [4348, 67],
  c,
  [229, 85],
  c,
  [172, 58],
  c,
  [5776, 95],
  c,
  [118, 30],
  c,
  [1290, 300],
  c,
  [5007, 11],
  c,
  [8, 17],
  c,
  [284, 6],
  c,
  [2199, 12],
  c,
  [1062, 83],
  c,
  [430, 160],
  c,
  [140, 8],
  c,
  [511, 85],
  c,
  [5186, 10],
  c,
  [3396, 84],
  c,
  [28, 16],
  c,
  [917, 79],
  c,
  [1292, 153],
  c,
  [2710, 10],
  c,
  [165, 14],
  c,
  [961, 179],
  c,
  [5671, 9],
  c,
  [193, 27],
  c,
  [2976, 92],
  c,
  [7189, 120],
  c,
  [660, 65],
  c,
  [3555, 79],
  c,
  [3720, 86],
  c,
  [1302, 94],
  c,
  [201, 97],
  c,
  [3650, 46],
  c,
  [2589, 123],
  c,
  [727, 45],
  c,
  [2613, 163],
  c,
  [6466, 47],
  c,
  [5034, 95],
  c,
  [160, 10],
  c,
  [8458, 43],
  c,
  [6202, 112],
  c,
  [149, 104],
  c,
  [3626, 43],
  c,
  [634, 100],
  c,
  [74, 18],
  c,
  [1618, 8],
  c,
  [738, 111],
  c,
  [4989, 90],
  c,
  [89, 203],
  c,
  [1500, 63],
  c,
  [267, 117],
  c,
  [50, 9],
  c,
  [356, 141],
  c,
  [4602, 82],
  c,
  [2319, 47],
  c,
  [47, 20],
  c,
  [2353, 74],
  c,
  [913, 182],
  c,
  [3537, 63],
  c,
  [89, 115],
  c,
  [6169, 80],
  c,
  [528, 73],
  c,
  [356, 177],
  c,
  [2610, 118],
  c,
  [10656, 40],
  c,
  [2226, 122],
  c,
  [3250, 165],
  c,
  [7424, 238],
  c,
  [429, 419],
  c,
  [6640, 106],
  c,
  [6641, 54],
  c,
  [6564, 65],
  c,
  [268, 146],
  c,
  [3967, 29],
  c,
  [779, 17],
  c,
  [4899, 112],
  c,
  [1054, 132],
  c,
  [8750, 304],
  c,
  [2355, 32],
  c,
  [11118, 12],
  c,
  [10805, 37],
  c,
  [11399, 28],
  c,
  [5151, 94],
  c,
  [3028, 70],
  c,
  [4444, 29],
  c,
  [11077, 51],
  c,
  [36, 32],
  c,
  [10648, 76],
  c,
  [344, 175],
  c,
  [5840, 168],
  c,
  [90, 102],
  c,
  [7245, 76],
  c,
  [5683, 142],
  c,
  [2204, 209],
  c,
  [1374, 11],
  c,
  [290, 12],
  c,
  [301, 15],
  c,
  [316, 54],
  c,
  [1046, 78],
  c,
  [6337, 89],
  c,
  [5583, 17],
  c,
  [11762, 63],
  c,
  [76, 10],
  c,
  [4372, 91],
  c,
  [3046, 21],
  c,
  [740, 91],
  c,
  [3243, 234],
  c,
  [146, 45],
  c,
  [8136, 12],
  c,
  [558, 62],
  c,
  [651, 7],
  c,
  [2593, 138],
  c,
  [5513, 25],
  c,
  [6734, 29],
  c,
  [1601, 31],
  c,
  [6619, 14],
  c,
  [606, 21],
  c,
  [1504, 66],
  c,
  [6560, 50],
  c,
  [6610, 91],
  c,
  [1178, 22],
  c,
  [14964, 96],
  c,
  [15296, 101],
  c,
  [205, 22],
  c,
  [1003, 13],
  c,
  [10522, 106],
  c,
  [7060, 107],
  c,
  [4745, 210],
  c,
  [114, 87],
  c,
  [1567, 10],
  c,
  [972, 62],
  c,
  [222, 46],
  c,
  [109, 37],
  c,
  [7143, 178],
  c,
  [41, 12],
  c,
  [2842, 8],
  c,
  [21, 7],
  c,
  [4698, 9],
  c,
  [14886, 25],
  c,
  [2892, 8],
  c,
  [346, 13],
  c,
  [313, 28],
  c,
  [5275, 279],
  c,
  [16367, 46],
  c,
  [5002, 86],
  c,
  [11632, 156],
  c,
  [3328, 178],
  c,
  [10113, 117],
  c,
  [4676, 13],
  c,
  [14983, 14],
  c,
  [9632, 196],
  c,
  [15804, 37],
  c,
  [10344, 15],
  c,
  [2607, 25],
  c,
  [10710, 24],
  c,
  [3680, 78],
  c,
  [5387, 164],
  c,
  [1402, 141],
  c,
  [7642, 98],
  c,
  [16769, 52],
  c,
  [52, 94],
  c,
  [3263, 12],
  c,
  [3512, 12],
  c,
  [646, 78],
  c,
  [1503, 31],
  c,
  [756, 60],
  c,
  [388, 8],
  c,
  [1578, 158],
  c,
  [2217, 9],
  c,
  [1306, 8],
  c,
  [3310, 89],
  c,
  [14853, 172],
  c,
  [6147, 75],
  c,
  [3169, 119],
  c,
  [2749, 105],
  c,
  [5483, 154],
  c,
  [117, 229],
  c,
  [2699, 228],
  c,
  [1412, 59],
  c,
  [58, 14],
  c,
  [4423, 10],
  c,
  [794, 16],
  c,
  [11052, 252],
  c,
  [3431, 131],
  c,
  [2615, 342],
  c,
  [19813, 297],
  c,
  [730, 28],
  c,
  [3317, 124],
  c,
  [21144, 39],
  c,
  [8659, 108],
  c,
  [3658, 75],
  c,
  [14910, 158],
  c,
  [12444, 246],
  c,
  [336, 22],
  c,
  [4090, 143],
  c,
  [205, 16],
  c,
  [2426, 43],
  c,
  [6920, 12],
  c,
  [3482, 11],
  c,
  [3496, 19],
  c,
  [9412, 12],
  c,
  [6626, 80],
  c,
  [17847, 40],
  c,
  [19732, 7],
  c,
  [724, 10],
  c,
  [1657, 100],
  c,
  [6099, 40],
  c,
  [140, 90],
  c,
  [16046, 60],
  c,
  [13590, 107],
  c,
  [3895, 10],
  c,
  [7247, 88],
  c,
  [22330, 108],
  c,
  [18530, 56],
  c,
  [926, 30],
  c,
  [199, 76],
  c,
  [2688, 84],
  c,
  [1242, 102],
  c,
  [13878, 115],
  c,
  [5835, 182],
  c,
  [2905, 101],
  c,
  [5252, 45],
  c,
  [1637, 51],
  c,
  [7463, 20],
  c,
  [1610, 88],
  c,
  [240, 13],
  c,
  [439, 28],
  c,
  [4254, 112],
  c,
  [1181, 91],
  c,
  [91, 96],
  c,
  [1210, 41],
  c,
  [3630, 387],
  c,
  [22899, 9],
  c,
  [23013, 12],
  c,
  [2077, 62],
  c,
  [15420, 204],
  c,
  [1631, 227],
  c,
  [14676, 73],
  c,
  [169, 38],
  s,
  [2, 5]
]),
  goto: u([
  1,
  36,
  82,
  83,
  84,
  87,
  100,
  65,
  101,
  s,
  [52, 4, 1],
  s,
  [37, 5, 1],
  88,
  80,
  81,
  85,
  86,
  73,
  50,
  77,
  45,
  46,
  18,
  110,
  94,
  s,
  [89, 5, 1],
  111,
  34,
  78,
  79,
  s,
  [68, 5, 1],
  103,
  112,
  116,
  104,
  114,
  76,
  115,
  107,
  108,
  109,
  62,
  96,
  19,
  23,
  61,
  60,
  97,
  98,
  99,
  56,
  57,
  58,
  2,
  117,
  6,
  138,
  140,
  136,
  142,
  146,
  155,
  156,
  162,
  163,
  6,
  130,
  s,
  [6, 3],
  120,
  121,
  124,
  125,
  127,
  147,
  149,
  134,
  s,
  [135, 5, 2],
  144,
  145,
  148,
  s,
  [150, 5, 1],
  s,
  [157, 5, 1],
  164,
  129,
  131,
  132,
  c,
  [83, 4],
  133,
  s,
  [7, 5],
  166,
  167,
  s,
  [8, 17],
  172,
  s,
  [8, 35],
  170,
  174,
  s,
  [8, 23],
  173,
  8,
  8,
  112,
  116,
  s,
  [8, 6],
  s,
  [428, 88],
  96,
  428,
  s,
  [430, 88],
  96,
  430,
  c,
  [394, 16],
  178,
  c,
  [395, 50],
  s,
  [251, 84],
  181,
  182,
  183,
  251,
  251,
  c,
  [550, 66],
  c,
  [66, 22],
  186,
  c,
  [66, 65],
  c,
  [132, 66],
  c,
  [66, 126],
  192,
  c,
  [67, 66],
  194,
  c,
  [67, 56],
  196,
  c,
  [200, 59],
  198,
  c,
  [37, 4],
  c,
  [271, 82],
  208,
  c,
  [67, 9],
  209,
  c,
  [68, 41],
  s,
  [209, 71],
  211,
  s,
  [209, 17],
  s,
  [198, 49],
  216,
  s,
  [198, 26],
  214,
  215,
  s,
  [198, 11],
  136,
  221,
  s,
  [136, 3],
  219,
  136,
  96,
  s,
  [380, 20],
  222,
  362,
  s,
  [380, 37],
  224,
  s,
  [380, 27],
  115,
  s,
  [380, 5],
  c,
  [347, 5],
  229,
  c,
  [347, 10],
  228,
  c,
  [347, 9],
  227,
  c,
  [347, 41],
  232,
  230,
  228,
  227,
  243,
  244,
  234,
  241,
  242,
  240,
  247,
  53,
  54,
  248,
  352,
  246,
  352,
  352,
  513,
  c,
  [87, 5],
  s,
  [513, 8],
  100,
  s,
  [513, 4],
  65,
  513,
  513,
  101,
  513,
  513,
  c,
  [103, 3],
  513,
  513,
  c,
  [105, 5],
  250,
  513,
  41,
  s,
  [513, 5],
  88,
  s,
  [513, 4],
  c,
  [115, 4],
  s,
  [513, 18],
  73,
  s,
  [513, 4],
  50,
  77,
  513,
  45,
  s,
  [513, 5],
  46,
  513,
  18,
  513,
  110,
  s,
  [513, 5],
  94,
  s,
  [513, 4],
  c,
  [151, 4],
  513,
  513,
  34,
  78,
  513,
  513,
  79,
  513,
  c,
  [156, 8],
  513,
  c,
  [157, 7],
  s,
  [513, 3],
  62,
  513,
  c,
  [161, 11],
  513,
  534,
  534,
  252,
  534,
  96,
  259,
  264,
  362,
  263,
  255,
  50,
  77,
  260,
  256,
  c,
  [36, 5],
  s,
  [96, 4, 1],
  c,
  [600, 16],
  267,
  c,
  [667, 50],
  273,
  272,
  96,
  96,
  c,
  [71, 16],
  278,
  c,
  [71, 50],
  281,
  280,
  174,
  282,
  s,
  [328, 11],
  232,
  s,
  [328, 9],
  284,
  228,
  s,
  [328, 34],
  227,
  s,
  [328, 31],
  362,
  288,
  115,
  96,
  362,
  290,
  115,
  96,
  232,
  362,
  228,
  227,
  292,
  c,
  [910, 71],
  155,
  156,
  c,
  [68, 13],
  299,
  300,
  c,
  [70, 4],
  c,
  [1989, 7],
  c,
  [77, 49],
  c,
  [640, 63],
  c,
  [68, 73],
  100,
  306,
  c,
  [1189, 65],
  307,
  65,
  314,
  c,
  [67, 8],
  309,
  c,
  [68, 7],
  315,
  c,
  [69, 15],
  312,
  c,
  [70, 33],
  326,
  c,
  [348, 3],
  319,
  c,
  [71, 8],
  321,
  c,
  [71, 7],
  323,
  c,
  [140, 43],
  221,
  327,
  351,
  331,
  351,
  351,
  329,
  330,
  351,
  334,
  104,
  114,
  348,
  341,
  347,
  337,
  c,
  [43, 10],
  96,
  346,
  112,
  116,
  351,
  4,
  c,
  [172, 6],
  4,
  65,
  4,
  101,
  4,
  c,
  [103, 8],
  4,
  c,
  [1834, 198],
  c,
  [66, 187],
  c,
  [706, 69],
  c,
  [266, 142],
  366,
  c,
  [465, 248],
  s,
  [88, 17],
  371,
  s,
  [88, 48],
  s,
  [90, 17],
  372,
  s,
  [90, 48],
  c,
  [1448, 82],
  c,
  [341, 127],
  174,
  112,
  116,
  378,
  c,
  [136, 82],
  382,
  c,
  [67, 7],
  380,
  385,
  c,
  [69, 43],
  434,
  c,
  [3789, 9],
  s,
  [434, 4],
  130,
  s,
  [434, 9],
  120,
  121,
  434,
  125,
  s,
  [434, 5],
  c,
  [3800, 15],
  434,
  434,
  c,
  [3800, 3],
  s,
  [434, 9],
  129,
  s,
  [434, 11],
  91,
  92,
  s,
  [434, 11],
  133,
  434,
  c,
  [224, 66],
  166,
  167,
  c,
  [1102, 8],
  389,
  c,
  [69, 8],
  388,
  c,
  [1103, 51],
  37,
  c,
  [226, 9],
  s,
  [37, 4],
  130,
  s,
  [37, 9],
  c,
  [4024, 7],
  37,
  37,
  c,
  [4026, 20],
  s,
  [37, 9],
  129,
  s,
  [37, 5],
  131,
  132,
  37,
  37,
  c,
  [108, 4],
  s,
  [37, 11],
  133,
  37,
  s,
  [40, 17],
  172,
  s,
  [40, 35],
  170,
  174,
  s,
  [40, 23],
  173,
  40,
  40,
  112,
  116,
  s,
  [40, 6],
  s,
  [110, 17],
  281,
  s,
  [110, 35],
  280,
  174,
  s,
  [110, 23],
  282,
  s,
  [110, 10],
  c,
  [266, 9],
  130,
  c,
  [4277, 35],
  s,
  [41, 3],
  136,
  142,
  s,
  [41, 9],
  130,
  s,
  [41, 9],
  120,
  121,
  41,
  125,
  s,
  [41, 5],
  c,
  [61, 3],
  41,
  c,
  [61, 4],
  s,
  [41, 6],
  157,
  s,
  [41, 4],
  164,
  s,
  [41, 9],
  129,
  s,
  [41, 11],
  91,
  92,
  s,
  [41, 11],
  133,
  41,
  s,
  [42, 3],
  136,
  142,
  s,
  [42, 9],
  130,
  s,
  [42, 9],
  120,
  121,
  42,
  125,
  s,
  [42, 5],
  134,
  135,
  42,
  42,
  c,
  [89, 4],
  s,
  [42, 6],
  157,
  s,
  [42, 4],
  164,
  s,
  [42, 9],
  129,
  s,
  [42, 11],
  91,
  92,
  s,
  [42, 11],
  133,
  42,
  s,
  [43, 3],
  136,
  142,
  s,
  [43, 9],
  130,
  s,
  [43, 9],
  120,
  121,
  43,
  125,
  s,
  [43, 5],
  134,
  135,
  43,
  43,
  c,
  [89, 4],
  s,
  [43, 6],
  157,
  s,
  [43, 4],
  164,
  s,
  [43, 9],
  129,
  s,
  [43, 11],
  91,
  92,
  s,
  [43, 11],
  133,
  43,
  s,
  [44, 3],
  136,
  142,
  s,
  [44, 9],
  130,
  s,
  [44, 9],
  120,
  121,
  44,
  125,
  s,
  [44, 5],
  134,
  135,
  44,
  44,
  c,
  [89, 4],
  s,
  [44, 6],
  157,
  s,
  [44, 4],
  164,
  s,
  [44, 9],
  129,
  s,
  [44, 11],
  91,
  92,
  s,
  [44, 11],
  133,
  44,
  c,
  [805, 66],
  46,
  c,
  [468, 9],
  s,
  [46, 4],
  130,
  s,
  [46, 9],
  120,
  121,
  46,
  125,
  s,
  [46, 5],
  c,
  [483, 15],
  46,
  46,
  c,
  [483, 3],
  s,
  [46, 9],
  129,
  s,
  [46, 11],
  91,
  92,
  s,
  [46, 11],
  133,
  46,
  c,
  [155, 66],
  c,
  [154, 9],
  232,
  130,
  393,
  228,
  c,
  [625, 27],
  227,
  c,
  [626, 8],
  c,
  [3199, 67],
  c,
  [182, 66],
  c,
  [36, 4],
  s,
  [398, 4, 1],
  s,
  [380, 9],
  402,
  c,
  [3746, 4],
  222,
  s,
  [362, 3],
  c,
  [3745, 30],
  c,
  [31, 14],
  c,
  [3732, 5],
  c,
  [3478, 67],
  405,
  145,
  145,
  146,
  146,
  433,
  433,
  s,
  [251, 43],
  172,
  172,
  c,
  [4813, 14],
  c,
  [390, 9],
  147,
  147,
  c,
  [1014, 28],
  147,
  c,
  [389, 8],
  c,
  [1060, 10],
  406,
  c,
  [47, 27],
  407,
  c,
  [436, 24],
  c,
  [227, 10],
  418,
  46,
  412,
  414,
  416,
  417,
  c,
  [230, 37],
  419,
  s,
  [210, 70],
  421,
  s,
  [210, 18],
  c,
  [3478, 79],
  428,
  c,
  [69, 57],
  s,
  [136, 20],
  c,
  [4375, 4],
  s,
  [136, 35],
  219,
  s,
  [136, 32],
  232,
  431,
  228,
  432,
  227,
  221,
  243,
  244,
  434,
  c,
  [4281, 3],
  c,
  [241, 68],
  s,
  [358, 20],
  221,
  s,
  [358, 37],
  440,
  s,
  [358, 32],
  s,
  [362, 85],
  115,
  s,
  [362, 5],
  22,
  c,
  [698, 9],
  s,
  [22, 4],
  130,
  s,
  [22, 9],
  120,
  121,
  22,
  125,
  s,
  [22, 5],
  c,
  [712, 15],
  22,
  22,
  c,
  [712, 3],
  s,
  [22, 9],
  129,
  s,
  [22, 11],
  91,
  92,
  s,
  [22, 11],
  133,
  22,
  443,
  442,
  c,
  [741, 16],
  444,
  c,
  [3925, 120],
  243,
  244,
  448,
  c,
  [484, 8],
  c,
  [1253, 61],
  450,
  123,
  449,
  123,
  452,
  s,
  [387, 7],
  453,
  s,
  [389, 7],
  454,
  s,
  [392, 7],
  455,
  456,
  458,
  457,
  400,
  400,
  459,
  s,
  [400, 6],
  276,
  461,
  276,
  276,
  465,
  463,
  242,
  240,
  326,
  243,
  244,
  466,
  c,
  [122, 3],
  362,
  472,
  115,
  c,
  [4645, 17],
  c,
  [126, 50],
  c,
  [4957, 4],
  514,
  c,
  [430, 9],
  s,
  [514, 4],
  130,
  s,
  [514, 9],
  120,
  121,
  514,
  125,
  s,
  [514, 5],
  c,
  [430, 15],
  514,
  514,
  c,
  [430, 3],
  s,
  [514, 9],
  129,
  s,
  [514, 11],
  91,
  92,
  s,
  [514, 11],
  133,
  514,
  c,
  [159, 66],
  477,
  479,
  476,
  480,
  96,
  s,
  [534, 4],
  96,
  482,
  123,
  c,
  [4971, 4],
  c,
  [4970, 3],
  485,
  c,
  [4970, 25],
  c,
  [95, 50],
  491,
  96,
  493,
  352,
  c,
  [5211, 4],
  232,
  228,
  227,
  s,
  [362, 58],
  224,
  c,
  [783, 33],
  s,
  [502, 10],
  494,
  s,
  [502, 78],
  c,
  [258, 66],
  s,
  [512, 20],
  222,
  362,
  s,
  [512, 37],
  224,
  s,
  [512, 27],
  115,
  s,
  [512, 5],
  96,
  96,
  c,
  [256, 4],
  115,
  c,
  [1735, 10],
  501,
  c,
  [7074, 36],
  502,
  117,
  c,
  [3542, 67],
  505,
  506,
  c,
  [5765, 69],
  284,
  c,
  [537, 6],
  224,
  c,
  [457, 3],
  115,
  c,
  [13, 4],
  232,
  362,
  c,
  [5, 3],
  513,
  c,
  [4862, 16],
  221,
  s,
  [260, 3],
  136,
  142,
  s,
  [260, 9],
  130,
  s,
  [260, 9],
  120,
  121,
  260,
  125,
  s,
  [260, 5],
  c,
  [240, 3],
  260,
  c,
  [240, 4],
  s,
  [260, 6],
  157,
  s,
  [260, 4],
  164,
  s,
  [260, 9],
  129,
  s,
  [260, 11],
  91,
  92,
  s,
  [260, 11],
  133,
  260,
  s,
  [59, 31],
  516,
  s,
  [59, 57],
  s,
  [63, 32],
  517,
  s,
  [63, 56],
  65,
  c,
  [494, 9],
  s,
  [65, 4],
  130,
  s,
  [65, 9],
  c,
  [505, 7],
  65,
  65,
  c,
  [507, 20],
  s,
  [65, 9],
  129,
  s,
  [65, 5],
  131,
  132,
  65,
  65,
  c,
  [415, 4],
  s,
  [65, 11],
  133,
  65,
  c,
  [2821, 75],
  130,
  233,
  c,
  [647, 35],
  212,
  c,
  [47, 9],
  s,
  [212, 4],
  130,
  s,
  [212, 9],
  120,
  121,
  212,
  125,
  s,
  [212, 5],
  c,
  [61, 15],
  212,
  212,
  c,
  [61, 3],
  s,
  [212, 9],
  129,
  s,
  [212, 5],
  131,
  132,
  212,
  212,
  c,
  [77, 4],
  s,
  [212, 11],
  c,
  [88, 11],
  521,
  130,
  520,
  c,
  [2956, 104],
  524,
  s,
  [123, 3],
  c,
  [71, 7],
  c,
  [1782, 9],
  c,
  [1781, 52],
  s,
  [255, 9],
  281,
  281,
  c,
  [4, 4],
  c,
  [5, 3],
  s,
  [255, 39],
  526,
  s,
  [305, 11],
  527,
  s,
  [305, 43],
  c,
  [5819, 70],
  c,
  [572, 38],
  529,
  c,
  [67, 28],
  s,
  [380, 9],
  294,
  362,
  294,
  c,
  [5, 3],
  c,
  [3205, 3],
  294,
  c,
  [8, 3],
  c,
  [3207, 40],
  c,
  [3204, 5],
  s,
  [372, 9],
  295,
  295,
  c,
  [3, 3],
  295,
  s,
  [372, 35],
  c,
  [8352, 40],
  170,
  174,
  531,
  c,
  [8330, 8],
  c,
  [8328, 3],
  533,
  421,
  c,
  [493, 7],
  c,
  [312, 4],
  c,
  [243, 15],
  c,
  [310, 82],
  c,
  [882, 37],
  419,
  130,
  s,
  [419, 4],
  c,
  [749, 27],
  538,
  c,
  [3269, 34],
  c,
  [117, 40],
  s,
  [423, 5],
  326,
  s,
  [423, 4],
  541,
  s,
  [423, 60],
  221,
  c,
  [6375, 3],
  543,
  c,
  [142, 66],
  547,
  123,
  123,
  546,
  c,
  [1584, 3],
  c,
  [1583, 12],
  s,
  [482, 4],
  550,
  471,
  551,
  482,
  s,
  [484, 4],
  473,
  484,
  c,
  [29, 15],
  556,
  c,
  [16, 3],
  558,
  c,
  [17, 12],
  561,
  563,
  96,
  112,
  116,
  565,
  351,
  c,
  [138, 66],
  39,
  c,
  [398, 9],
  s,
  [39, 4],
  130,
  s,
  [39, 9],
  c,
  [406, 7],
  39,
  39,
  c,
  [408, 20],
  s,
  [39, 9],
  129,
  s,
  [39, 5],
  131,
  132,
  39,
  39,
  c,
  [108, 4],
  s,
  [39, 11],
  133,
  39,
  50,
  c,
  [89, 9],
  s,
  [50, 4],
  130,
  s,
  [50, 9],
  c,
  [89, 7],
  50,
  50,
  c,
  [89, 20],
  s,
  [50, 9],
  129,
  s,
  [50, 5],
  131,
  132,
  50,
  50,
  c,
  [89, 4],
  s,
  [50, 11],
  133,
  50,
  51,
  c,
  [89, 9],
  s,
  [51, 4],
  130,
  s,
  [51, 9],
  c,
  [89, 7],
  51,
  51,
  c,
  [89, 20],
  s,
  [51, 9],
  129,
  s,
  [51, 5],
  131,
  132,
  51,
  51,
  c,
  [89, 4],
  s,
  [51, 11],
  133,
  51,
  52,
  c,
  [89, 9],
  s,
  [52, 4],
  130,
  s,
  [52, 9],
  120,
  121,
  52,
  125,
  s,
  [52, 5],
  c,
  [89, 15],
  52,
  52,
  c,
  [89, 3],
  s,
  [52, 9],
  129,
  s,
  [52, 5],
  131,
  132,
  52,
  52,
  c,
  [89, 4],
  s,
  [52, 11],
  133,
  52,
  53,
  c,
  [89, 9],
  s,
  [53, 4],
  130,
  s,
  [53, 9],
  c,
  [178, 7],
  53,
  53,
  c,
  [178, 20],
  s,
  [53, 9],
  129,
  s,
  [53, 5],
  131,
  132,
  53,
  53,
  c,
  [89, 4],
  s,
  [53, 11],
  133,
  53,
  56,
  c,
  [89, 9],
  s,
  [56, 4],
  130,
  s,
  [56, 9],
  c,
  [89, 4],
  56,
  147,
  149,
  56,
  56,
  c,
  [89, 20],
  s,
  [56, 9],
  129,
  s,
  [56, 5],
  131,
  132,
  56,
  56,
  c,
  [89, 4],
  s,
  [56, 11],
  133,
  56,
  227,
  c,
  [89, 9],
  s,
  [227, 4],
  130,
  s,
  [227, 9],
  c,
  [178, 7],
  227,
  227,
  c,
  [1691, 21],
  s,
  [227, 8],
  129,
  s,
  [227, 5],
  131,
  132,
  227,
  227,
  c,
  [89, 4],
  s,
  [227, 11],
  133,
  227,
  c,
  [4466, 67],
  569,
  570,
  s,
  [380, 9],
  571,
  c,
  [1357, 3],
  c,
  [4601, 47],
  c,
  [1396, 5],
  s,
  [201, 15],
  572,
  s,
  [201, 73],
  c,
  [223, 16],
  575,
  c,
  [223, 50],
  207,
  c,
  [379, 9],
  s,
  [207, 4],
  130,
  s,
  [207, 9],
  c,
  [379, 7],
  207,
  207,
  c,
  [379, 20],
  s,
  [207, 9],
  129,
  s,
  [207, 5],
  131,
  132,
  207,
  207,
  c,
  [108, 4],
  s,
  [207, 11],
  133,
  207,
  203,
  c,
  [89, 9],
  s,
  [203, 4],
  130,
  s,
  [203, 9],
  120,
  121,
  203,
  125,
  s,
  [203, 5],
  c,
  [89, 15],
  203,
  203,
  c,
  [89, 3],
  s,
  [203, 9],
  129,
  s,
  [203, 11],
  91,
  92,
  s,
  [203, 11],
  133,
  203,
  205,
  c,
  [89, 9],
  s,
  [205, 4],
  130,
  s,
  [205, 9],
  120,
  121,
  205,
  125,
  s,
  [205, 5],
  c,
  [89, 15],
  205,
  205,
  c,
  [89, 3],
  s,
  [205, 9],
  129,
  s,
  [205, 11],
  91,
  92,
  s,
  [205, 11],
  133,
  205,
  385,
  c,
  [89, 9],
  s,
  [385, 4],
  130,
  s,
  [385, 9],
  c,
  [267, 7],
  385,
  385,
  c,
  [267, 20],
  s,
  [385, 9],
  129,
  s,
  [385, 5],
  131,
  132,
  385,
  385,
  c,
  [267, 4],
  s,
  [385, 11],
  133,
  385,
  s,
  [58, 31],
  516,
  s,
  [58, 57],
  204,
  c,
  [178, 9],
  s,
  [204, 4],
  130,
  s,
  [204, 9],
  120,
  121,
  204,
  125,
  s,
  [204, 5],
  c,
  [178, 15],
  204,
  204,
  c,
  [178, 3],
  s,
  [204, 9],
  129,
  s,
  [204, 11],
  91,
  92,
  s,
  [204, 11],
  133,
  204,
  206,
  c,
  [89, 9],
  s,
  [206, 4],
  130,
  s,
  [206, 9],
  120,
  121,
  206,
  125,
  s,
  [206, 5],
  c,
  [89, 15],
  206,
  206,
  c,
  [89, 3],
  s,
  [206, 9],
  129,
  s,
  [206, 11],
  91,
  92,
  s,
  [206, 11],
  133,
  c,
  [88, 10],
  c,
  [6258, 35],
  576,
  133,
  578,
  c,
  [2610, 10],
  c,
  [1652, 16],
  c,
  [6868, 44],
  c,
  [117, 9],
  120,
  130,
  s,
  [120, 4],
  c,
  [121, 26],
  120,
  580,
  c,
  [2050, 74],
  c,
  [234, 10],
  582,
  c,
  [3049, 35],
  373,
  c,
  [47, 9],
  s,
  [373, 4],
  130,
  s,
  [373, 9],
  c,
  [59, 7],
  373,
  373,
  c,
  [61, 20],
  s,
  [373, 9],
  129,
  s,
  [373, 5],
  131,
  132,
  373,
  373,
  c,
  [77, 4],
  s,
  [373, 11],
  133,
  373,
  c,
  [4779, 73],
  c,
  [268, 70],
  585,
  c,
  [268, 35],
  c,
  [46, 10],
  586,
  c,
  [46, 35],
  c,
  [3939, 68],
  c,
  [114, 10],
  589,
  c,
  [4125, 36],
  225,
  c,
  [48, 9],
  s,
  [225, 4],
  130,
  s,
  [225, 9],
  c,
  [59, 7],
  225,
  225,
  c,
  [61, 20],
  s,
  [225, 9],
  129,
  s,
  [225, 5],
  131,
  132,
  225,
  225,
  c,
  [77, 4],
  s,
  [225, 11],
  133,
  225,
  c,
  [8824, 335],
  c,
  [66, 61],
  s,
  [380, 9],
  596,
  362,
  512,
  380,
  380,
  c,
  [4752, 3],
  c,
  [7, 4],
  c,
  [2040, 29],
  c,
  [32, 13],
  c,
  [2041, 5],
  s,
  [251, 40],
  171,
  171,
  c,
  [6564, 14],
  c,
  [256, 92],
  c,
  [6535, 43],
  599,
  601,
  600,
  232,
  604,
  602,
  228,
  227,
  605,
  s,
  [55, 9],
  232,
  55,
  606,
  228,
  s,
  [55, 27],
  227,
  s,
  [55, 9],
  c,
  [918, 78],
  c,
  [916, 28],
  610,
  c,
  [917, 7],
  188,
  188,
  c,
  [11936, 3],
  c,
  [8730, 82],
  c,
  [77, 14],
  246,
  c,
  [77, 76],
  c,
  [8884, 84],
  c,
  [478, 43],
  c,
  [419, 68],
  217,
  c,
  [420, 9],
  s,
  [217, 4],
  130,
  s,
  [217, 9],
  120,
  121,
  217,
  125,
  s,
  [217, 5],
  c,
  [435, 15],
  217,
  217,
  c,
  [435, 3],
  s,
  [217, 9],
  129,
  s,
  [217, 5],
  131,
  132,
  217,
  217,
  c,
  [108, 4],
  s,
  [217, 11],
  133,
  217,
  s,
  [380, 11],
  232,
  c,
  [11291, 11],
  618,
  228,
  c,
  [11291, 35],
  227,
  c,
  [11291, 32],
  235,
  c,
  [182, 9],
  s,
  [235, 4],
  130,
  s,
  [235, 9],
  c,
  [615, 7],
  235,
  235,
  c,
  [617, 20],
  s,
  [235, 9],
  129,
  s,
  [235, 5],
  131,
  132,
  235,
  235,
  c,
  [182, 4],
  s,
  [235, 11],
  133,
  235,
  s,
  [236, 68],
  166,
  167,
  s,
  [236, 19],
  c,
  [6172, 3],
  s,
  [125, 11],
  232,
  s,
  [125, 9],
  621,
  228,
  s,
  [125, 34],
  622,
  c,
  [59, 12],
  s,
  [125, 20],
  c,
  [93, 3],
  c,
  [6722, 68],
  625,
  123,
  19,
  c,
  [344, 9],
  s,
  [19, 4],
  130,
  s,
  [19, 9],
  c,
  [344, 7],
  19,
  19,
  c,
  [344, 20],
  s,
  [19, 9],
  129,
  s,
  [19, 5],
  131,
  132,
  19,
  19,
  c,
  [112, 4],
  s,
  [19, 11],
  133,
  19,
  s,
  [20, 68],
  166,
  167,
  s,
  [20, 19],
  s,
  [353, 20],
  626,
  s,
  [353, 69],
  s,
  [359, 20],
  221,
  s,
  [359, 69],
  s,
  [360, 20],
  221,
  s,
  [360, 69],
  c,
  [518, 16],
  629,
  c,
  [519, 50],
  117,
  631,
  632,
  117,
  450,
  123,
  633,
  c,
  [2998, 6],
  c,
  [1117, 6],
  635,
  c,
  [1118, 57],
  637,
  243,
  244,
  s,
  [124, 3],
  c,
  [7271, 3],
  639,
  640,
  c,
  [10824, 216],
  c,
  [66, 50],
  646,
  647,
  649,
  648,
  123,
  123,
  651,
  s,
  [301, 5],
  652,
  653,
  458,
  457,
  655,
  421,
  123,
  243,
  244,
  c,
  [292, 3],
  c,
  [6682, 9],
  660,
  c,
  [1848, 10],
  6,
  661,
  c,
  [2766, 35],
  117,
  662,
  664,
  666,
  479,
  480,
  96,
  667,
  672,
  670,
  96,
  673,
  676,
  479,
  675,
  480,
  96,
  535,
  535,
  124,
  s,
  [535, 3],
  677,
  678,
  c,
  [172, 66],
  680,
  681,
  528,
  c,
  [141, 9],
  s,
  [528, 4],
  130,
  s,
  [528, 9],
  120,
  121,
  528,
  125,
  s,
  [528, 5],
  c,
  [154, 15],
  528,
  528,
  c,
  [154, 3],
  s,
  [528, 9],
  129,
  s,
  [528, 5],
  131,
  132,
  528,
  528,
  c,
  [110, 4],
  s,
  [528, 11],
  133,
  528,
  683,
  682,
  123,
  685,
  s,
  [548, 4],
  686,
  491,
  c,
  [7809, 9],
  124,
  c,
  [169, 8],
  124,
  c,
  [170, 50],
  689,
  690,
  494,
  123,
  123,
  691,
  692,
  693,
  696,
  695,
  117,
  697,
  698,
  345,
  c,
  [181, 9],
  s,
  [345, 4],
  130,
  s,
  [345, 9],
  c,
  [333, 7],
  345,
  345,
  c,
  [335, 20],
  s,
  [345, 9],
  129,
  s,
  [345, 5],
  131,
  132,
  345,
  345,
  c,
  [121, 4],
  s,
  [345, 11],
  133,
  345,
  c,
  [8502, 4],
  440,
  358,
  c,
  [7098, 16],
  c,
  [5534, 3],
  701,
  c,
  [2079, 77],
  155,
  156,
  299,
  300,
  c,
  [55, 7],
  66,
  c,
  [203, 9],
  s,
  [66, 4],
  130,
  s,
  [66, 9],
  c,
  [203, 7],
  66,
  66,
  c,
  [203, 20],
  s,
  [66, 9],
  129,
  s,
  [66, 5],
  131,
  132,
  66,
  66,
  c,
  [119, 4],
  s,
  [66, 11],
  133,
  66,
  c,
  [177, 5],
  707,
  c,
  [913, 128],
  c,
  [747, 10],
  709,
  c,
  [3513, 36],
  710,
  711,
  712,
  c,
  [116, 6],
  124,
  65,
  314,
  c,
  [558, 17],
  c,
  [6788, 45],
  c,
  [6860, 3],
  714,
  c,
  [75, 5],
  291,
  229,
  291,
  65,
  101,
  291,
  c,
  [76, 8],
  718,
  291,
  c,
  [77, 7],
  719,
  c,
  [12775, 60],
  722,
  c,
  [2861, 60],
  419,
  130,
  723,
  c,
  [6373, 38],
  724,
  s,
  [8, 9],
  296,
  296,
  8,
  172,
  s,
  [296, 3],
  c,
  [14965, 36],
  c,
  [6619, 4],
  725,
  c,
  [6616, 9],
  423,
  541,
  c,
  [325, 9],
  423,
  c,
  [6620, 51],
  729,
  728,
  533,
  123,
  123,
  421,
  c,
  [186, 9],
  417,
  130,
  s,
  [417, 4],
  c,
  [4129, 44],
  420,
  130,
  s,
  [420, 4],
  c,
  [50, 35],
  326,
  c,
  [4728, 44],
  732,
  133,
  c,
  [930, 3],
  124,
  124,
  c,
  [931, 12],
  734,
  735,
  c,
  [933, 3],
  736,
  96,
  c,
  [24, 3],
  739,
  c,
  [23, 12],
  742,
  741,
  740,
  s,
  [467, 78],
  556,
  s,
  [467, 10],
  s,
  [471, 84],
  551,
  s,
  [471, 5],
  743,
  746,
  744,
  123,
  123,
  c,
  [6642, 15],
  742,
  741,
  s,
  [498, 5],
  750,
  748,
  123,
  123,
  563,
  96,
  752,
  c,
  [302, 44],
  753,
  133,
  s,
  [380, 9],
  754,
  c,
  [5883, 3],
  c,
  [3881, 36],
  c,
  [10521, 33],
  c,
  [4212, 198],
  c,
  [6030, 51],
  759,
  c,
  [378, 10],
  207,
  760,
  c,
  [4861, 40],
  c,
  [181, 61],
  763,
  764,
  762,
  c,
  [1856, 18],
  c,
  [1299, 8],
  124,
  c,
  [5478, 44],
  c,
  [5549, 4],
  c,
  [191, 9],
  121,
  130,
  s,
  [121, 3],
  c,
  [193, 27],
  121,
  c,
  [5101, 18],
  6,
  767,
  c,
  [241, 35],
  375,
  c,
  [48, 9],
  s,
  [375, 4],
  130,
  s,
  [375, 9],
  c,
  [59, 7],
  375,
  375,
  c,
  [61, 20],
  s,
  [375, 9],
  129,
  s,
  [375, 5],
  131,
  132,
  375,
  375,
  c,
  [77, 4],
  s,
  [375, 11],
  133,
  375,
  222,
  c,
  [89, 9],
  s,
  [222, 4],
  130,
  s,
  [222, 9],
  c,
  [89, 7],
  222,
  222,
  c,
  [89, 20],
  s,
  [222, 9],
  129,
  s,
  [222, 5],
  131,
  132,
  222,
  222,
  c,
  [89, 4],
  s,
  [222, 11],
  133,
  222,
  c,
  [350, 5],
  s,
  [264, 7],
  100,
  264,
  65,
  264,
  c,
  [428, 4],
  264,
  c,
  [359, 5],
  264,
  41,
  s,
  [264, 5],
  88,
  264,
  264,
  c,
  [365, 4],
  s,
  [264, 18],
  73,
  264,
  264,
  50,
  77,
  264,
  45,
  264,
  c,
  [385, 3],
  264,
  264,
  c,
  [387, 9],
  264,
  c,
  [388, 17],
  264,
  c,
  [389, 11],
  226,
  c,
  [199, 9],
  s,
  [226, 4],
  130,
  s,
  [226, 9],
  c,
  [199, 7],
  226,
  226,
  c,
  [199, 20],
  s,
  [226, 9],
  129,
  s,
  [226, 5],
  131,
  132,
  226,
  226,
  c,
  [110, 4],
  s,
  [226, 11],
  133,
  c,
  [88, 10],
  769,
  c,
  [12332, 36],
  c,
  [1089, 37],
  770,
  c,
  [46, 17],
  232,
  130,
  772,
  c,
  [8845, 37],
  c,
  [49, 11],
  774,
  c,
  [49, 37],
  s,
  [251, 41],
  776,
  777,
  778,
  c,
  [5002, 79],
  c,
  [172, 9],
  148,
  148,
  c,
  [269, 28],
  148,
  c,
  [171, 8],
  601,
  780,
  c,
  [4574, 74],
  c,
  [4643, 132],
  418,
  416,
  786,
  c,
  [3, 3],
  c,
  [5136, 78],
  185,
  185,
  c,
  [1308, 40],
  c,
  [2899, 72],
  s,
  [192, 4],
  517,
  192,
  192,
  s,
  [193, 4],
  517,
  193,
  193,
  s,
  [194, 4],
  517,
  194,
  194,
  601,
  791,
  215,
  c,
  [148, 9],
  s,
  [215, 4],
  130,
  s,
  [215, 9],
  120,
  121,
  215,
  125,
  s,
  [215, 5],
  c,
  [161, 15],
  215,
  215,
  c,
  [161, 3],
  s,
  [215, 9],
  129,
  s,
  [215, 5],
  131,
  132,
  215,
  215,
  c,
  [131, 4],
  s,
  [215, 11],
  133,
  215,
  c,
  [10297, 69],
  c,
  [4568, 68],
  s,
  [134, 11],
  232,
  s,
  [134, 5],
  172,
  s,
  [134, 3],
  797,
  228,
  s,
  [134, 30],
  170,
  174,
  134,
  134,
  227,
  s,
  [134, 20],
  173,
  134,
  134,
  112,
  116,
  s,
  [134, 6],
  c,
  [226, 68],
  800,
  117,
  801,
  c,
  [71, 11],
  803,
  c,
  [15720, 125],
  33,
  c,
  [523, 9],
  s,
  [33, 4],
  130,
  s,
  [33, 9],
  c,
  [682, 7],
  33,
  33,
  c,
  [684, 20],
  s,
  [33, 9],
  129,
  s,
  [33, 5],
  131,
  132,
  33,
  33,
  c,
  [108, 4],
  s,
  [33, 11],
  133,
  33,
  c,
  [157, 68],
  c,
  [4130, 5],
  c,
  [5, 5],
  27,
  c,
  [167, 9],
  s,
  [27, 4],
  130,
  s,
  [27, 9],
  120,
  121,
  27,
  125,
  s,
  [27, 5],
  c,
  [167, 15],
  27,
  27,
  c,
  [167, 3],
  s,
  [27, 9],
  129,
  s,
  [27, 11],
  91,
  92,
  s,
  [27, 11],
  133,
  c,
  [88, 10],
  388,
  388,
  130,
  s,
  [388, 5],
  c,
  [1575, 44],
  390,
  390,
  130,
  s,
  [390, 5],
  c,
  [52, 44],
  395,
  395,
  130,
  s,
  [395, 5],
  c,
  [52, 34],
  395,
  133,
  811,
  s,
  [396, 7],
  813,
  812,
  124,
  124,
  c,
  [11967, 4],
  815,
  816,
  299,
  243,
  299,
  244,
  s,
  [299, 3],
  819,
  242,
  818,
  c,
  [12095, 67],
  821,
  822,
  c,
  [12048, 3],
  423,
  541,
  c,
  [351, 3],
  825,
  c,
  [4061, 16],
  827,
  829,
  664,
  830,
  96,
  833,
  832,
  123,
  835,
  s,
  [561, 4],
  836,
  837,
  c,
  [4453, 3],
  664,
  c,
  [4461, 3],
  841,
  c,
  [14202, 45],
  842,
  124,
  491,
  96,
  844,
  s,
  [545, 4],
  846,
  96,
  847,
  96,
  683,
  123,
  849,
  c,
  [2797, 132],
  c,
  [232, 3],
  854,
  853,
  c,
  [233, 12],
  696,
  856,
  450,
  858,
  863,
  861,
  450,
  450,
  862,
  864,
  c,
  [3371, 3],
  865,
  232,
  363,
  867,
  228,
  227,
  s,
  [62, 32],
  517,
  s,
  [62, 56],
  c,
  [191, 66],
  240,
  c,
  [385, 9],
  s,
  [240, 4],
  130,
  s,
  [240, 9],
  c,
  [398, 7],
  240,
  240,
  c,
  [400, 20],
  s,
  [240, 9],
  129,
  s,
  [240, 5],
  131,
  132,
  240,
  240,
  c,
  [108, 4],
  s,
  [240, 11],
  133,
  240,
  s,
  [242, 68],
  166,
  167,
  s,
  [242, 19],
  c,
  [12849, 70],
  c,
  [247, 9],
  871,
  130,
  c,
  [4401, 36],
  c,
  [2749, 110],
  c,
  [11293, 68],
  c,
  [68, 68],
  875,
  711,
  712,
  c,
  [296, 9],
  282,
  282,
  130,
  s,
  [282, 3],
  c,
  [3467, 51],
  c,
  [8553, 51],
  c,
  [117, 9],
  285,
  285,
  130,
  s,
  [285, 3],
  c,
  [117, 102],
  878,
  c,
  [68, 8],
  424,
  c,
  [69, 8],
  424,
  c,
  [1104, 55],
  c,
  [11242, 68],
  c,
  [68, 63],
  881,
  c,
  [4311, 15],
  c,
  [15, 15],
  884,
  c,
  [1179, 3],
  885,
  c,
  [20, 15],
  887,
  c,
  [16, 3],
  890,
  889,
  c,
  [53, 15],
  893,
  892,
  c,
  [17, 12],
  894,
  895,
  c,
  [4625, 17],
  746,
  123,
  123,
  897,
  898,
  899,
  124,
  124,
  563,
  96,
  750,
  123,
  123,
  901,
  494,
  348,
  494,
  341,
  347,
  903,
  904,
  494,
  c,
  [34, 12],
  c,
  [1188, 66],
  168,
  c,
  [528, 9],
  s,
  [168, 4],
  130,
  s,
  [168, 9],
  c,
  [536, 7],
  168,
  168,
  c,
  [538, 20],
  s,
  [168, 9],
  129,
  s,
  [168, 5],
  131,
  132,
  168,
  168,
  c,
  [108, 4],
  s,
  [168, 11],
  133,
  168,
  169,
  c,
  [89, 9],
  s,
  [169, 4],
  130,
  s,
  [169, 9],
  c,
  [89, 7],
  169,
  169,
  c,
  [89, 20],
  s,
  [169, 9],
  129,
  s,
  [169, 5],
  131,
  132,
  169,
  169,
  c,
  [89, 4],
  s,
  [169, 11],
  133,
  169,
  c,
  [3431, 73],
  c,
  [4411, 51],
  c,
  [1874, 10],
  c,
  [4409, 59],
  c,
  [4336, 44],
  c,
  [67, 67],
  763,
  764,
  910,
  223,
  c,
  [184, 9],
  s,
  [223, 4],
  130,
  s,
  [223, 9],
  c,
  [196, 7],
  223,
  223,
  c,
  [198, 20],
  s,
  [223, 9],
  129,
  s,
  [223, 5],
  131,
  132,
  223,
  223,
  c,
  [111, 4],
  s,
  [223, 11],
  133,
  223,
  c,
  [17918, 205],
  c,
  [7162, 129],
  c,
  [730, 57],
  601,
  919,
  c,
  [665, 10],
  179,
  179,
  c,
  [3767, 112],
  c,
  [124, 10],
  182,
  182,
  c,
  [124, 35],
  187,
  187,
  516,
  920,
  220,
  c,
  [52, 9],
  s,
  [220, 4],
  130,
  s,
  [220, 9],
  120,
  121,
  220,
  125,
  s,
  [220, 5],
  c,
  [65, 15],
  220,
  220,
  c,
  [65, 3],
  s,
  [220, 9],
  129,
  s,
  [220, 5],
  131,
  132,
  220,
  220,
  c,
  [81, 4],
  s,
  [220, 11],
  133,
  220,
  s,
  [133, 11],
  232,
  s,
  [133, 5],
  172,
  s,
  [133, 3],
  922,
  228,
  s,
  [133, 30],
  170,
  174,
  133,
  133,
  227,
  s,
  [133, 20],
  173,
  133,
  133,
  112,
  116,
  c,
  [78, 7],
  228,
  227,
  341,
  c,
  [181, 9],
  s,
  [341, 4],
  130,
  s,
  [341, 9],
  120,
  121,
  341,
  125,
  s,
  [341, 5],
  c,
  [181, 15],
  341,
  341,
  c,
  [181, 3],
  s,
  [341, 9],
  129,
  s,
  [341, 11],
  91,
  92,
  s,
  [341, 11],
  133,
  341,
  924,
  c,
  [639, 68],
  29,
  c,
  [158, 9],
  s,
  [29, 4],
  130,
  s,
  [29, 9],
  c,
  [402, 7],
  29,
  29,
  c,
  [404, 20],
  s,
  [29, 9],
  129,
  s,
  [29, 5],
  131,
  132,
  29,
  29,
  c,
  [108, 4],
  s,
  [29, 11],
  133,
  29,
  34,
  c,
  [89, 9],
  s,
  [34, 4],
  130,
  s,
  [34, 9],
  c,
  [89, 7],
  34,
  34,
  c,
  [89, 20],
  s,
  [34, 9],
  129,
  s,
  [34, 5],
  131,
  132,
  34,
  34,
  c,
  [89, 4],
  s,
  [34, 11],
  133,
  34,
  26,
  c,
  [89, 9],
  s,
  [26, 4],
  130,
  s,
  [26, 9],
  120,
  121,
  26,
  125,
  s,
  [26, 5],
  c,
  [89, 15],
  26,
  26,
  c,
  [89, 3],
  s,
  [26, 9],
  129,
  s,
  [26, 11],
  91,
  92,
  s,
  [26, 11],
  133,
  26,
  450,
  c,
  [11218, 26],
  c,
  [727, 43],
  c,
  [3523, 4],
  c,
  [4, 4],
  c,
  [74, 66],
  s,
  [304, 5],
  458,
  457,
  c,
  [239, 9],
  302,
  302,
  130,
  s,
  [302, 3],
  c,
  [811, 35],
  243,
  244,
  424,
  c,
  [3567, 3],
  c,
  [3575, 3],
  c,
  [6, 3],
  c,
  [2134, 3],
  933,
  934,
  664,
  96,
  664,
  124,
  c,
  [3550, 3],
  939,
  s,
  [556, 4],
  941,
  s,
  [96, 3],
  833,
  123,
  944,
  945,
  946,
  96,
  491,
  96,
  96,
  950,
  c,
  [7770, 3],
  951,
  s,
  [458, 8],
  742,
  741,
  s,
  [458, 79],
  c,
  [2289, 30],
  954,
  956,
  955,
  123,
  123,
  450,
  c,
  [3479, 5],
  c,
  [14910, 3],
  960,
  452,
  961,
  452,
  452,
  232,
  363,
  c,
  [8233, 4],
  228,
  227,
  64,
  c,
  [244, 9],
  s,
  [64, 4],
  130,
  s,
  [64, 9],
  c,
  [252, 7],
  64,
  64,
  c,
  [254, 20],
  s,
  [64, 9],
  129,
  s,
  [64, 5],
  131,
  132,
  64,
  64,
  c,
  [270, 4],
  s,
  [64, 11],
  133,
  c,
  [88, 10],
  964,
  c,
  [3171, 37],
  965,
  c,
  [22281, 3],
  241,
  c,
  [52, 9],
  s,
  [241, 4],
  130,
  s,
  [241, 9],
  c,
  [63, 7],
  241,
  241,
  c,
  [65, 20],
  s,
  [241, 9],
  129,
  s,
  [241, 5],
  131,
  132,
  241,
  241,
  c,
  [81, 4],
  s,
  [241, 11],
  133,
  241,
  c,
  [7591, 3],
  966,
  c,
  [6242, 11],
  967,
  c,
  [5819, 45],
  6,
  968,
  c,
  [11391, 51],
  970,
  c,
  [1056, 51],
  c,
  [7430, 4],
  973,
  974,
  c,
  [582, 3],
  975,
  976,
  s,
  [461, 78],
  556,
  s,
  [461, 10],
  c,
  [552, 30],
  s,
  [462, 78],
  556,
  s,
  [462, 10],
  c,
  [119, 30],
  c,
  [15, 30],
  742,
  741,
  s,
  [501, 5],
  983,
  563,
  96,
  563,
  96,
  986,
  742,
  741,
  s,
  [491, 5],
  c,
  [50, 30],
  c,
  [6119, 123],
  991,
  c,
  [6911, 4],
  993,
  c,
  [6297, 11],
  995,
  c,
  [6346, 48],
  997,
  c,
  [49, 37],
  159,
  c,
  [50, 9],
  s,
  [159, 4],
  130,
  s,
  [159, 9],
  120,
  121,
  159,
  125,
  s,
  [159, 5],
  c,
  [62, 15],
  159,
  c,
  [62, 4],
  s,
  [159, 9],
  129,
  s,
  [159, 5],
  131,
  132,
  159,
  159,
  c,
  [77, 4],
  s,
  [159, 11],
  133,
  159,
  160,
  c,
  [89, 9],
  s,
  [160, 4],
  130,
  s,
  [160, 9],
  120,
  121,
  160,
  125,
  s,
  [160, 5],
  c,
  [89, 15],
  s,
  [160, 3],
  161,
  164,
  s,
  [160, 9],
  129,
  s,
  [160, 5],
  131,
  132,
  160,
  160,
  c,
  [89, 4],
  s,
  [160, 11],
  133,
  c,
  [88, 10],
  232,
  130,
  998,
  c,
  [15467, 53],
  c,
  [397, 50],
  1001,
  c,
  [1248, 3],
  30,
  c,
  [120, 9],
  s,
  [30, 4],
  130,
  s,
  [30, 9],
  c,
  [130, 7],
  30,
  30,
  c,
  [132, 20],
  s,
  [30, 9],
  129,
  s,
  [30, 5],
  131,
  132,
  30,
  30,
  c,
  [112, 4],
  s,
  [30, 11],
  133,
  30,
  639,
  640,
  1003,
  c,
  [91, 9],
  397,
  397,
  130,
  s,
  [397, 5],
  c,
  [1065, 34],
  397,
  133,
  1004,
  c,
  [54, 9],
  300,
  300,
  130,
  s,
  [300, 3],
  c,
  [1117, 35],
  c,
  [1452, 5],
  1006,
  1007,
  664,
  1009,
  c,
  [1625, 3],
  96,
  1012,
  1013,
  664,
  664,
  742,
  741,
  1016,
  s,
  [460, 8],
  742,
  741,
  s,
  [460, 79],
  124,
  450,
  124,
  c,
  [1577, 5],
  1018,
  1019,
  956,
  123,
  123,
  1020,
  453,
  c,
  [8429, 4],
  c,
  [860, 12],
  1024,
  c,
  [191, 9],
  288,
  288,
  130,
  s,
  [288, 3],
  c,
  [4254, 102],
  1026,
  1027,
  1028,
  556,
  s,
  [465, 78],
  c,
  [79, 11],
  1029,
  556,
  s,
  [466, 78],
  c,
  [79, 11],
  742,
  741,
  s,
  [499, 5],
  742,
  741,
  1030,
  1031,
  742,
  741,
  s,
  [492, 5],
  742,
  741,
  1032,
  c,
  [729, 66],
  170,
  c,
  [389, 9],
  s,
  [170, 4],
  130,
  s,
  [170, 9],
  c,
  [397, 7],
  170,
  170,
  c,
  [399, 20],
  s,
  [170, 9],
  129,
  s,
  [170, 5],
  131,
  132,
  170,
  170,
  c,
  [108, 4],
  s,
  [170, 11],
  133,
  170,
  763,
  764,
  1034,
  c,
  [3501, 141],
  c,
  [7211, 72],
  232,
  130,
  1041,
  c,
  [1140, 37],
  1043,
  1044,
  1045,
  c,
  [2343, 6],
  c,
  [6, 6],
  1048,
  221,
  742,
  741,
  s,
  [448, 5],
  c,
  [773, 15],
  c,
  [2077, 11],
  1051,
  c,
  [769, 35],
  167,
  c,
  [48, 9],
  s,
  [167, 4],
  130,
  s,
  [167, 9],
  c,
  [59, 7],
  167,
  167,
  c,
  [61, 20],
  s,
  [167, 9],
  129,
  s,
  [167, 5],
  131,
  132,
  167,
  167,
  c,
  [77, 4],
  s,
  [167, 11],
  133,
  167,
  151,
  c,
  [89, 9],
  s,
  [151, 4],
  130,
  s,
  [151, 9],
  120,
  121,
  151,
  125,
  s,
  [151, 5],
  c,
  [89, 15],
  151,
  151,
  c,
  [89, 3],
  s,
  [151, 9],
  129,
  s,
  [151, 5],
  131,
  132,
  151,
  151,
  c,
  [89, 4],
  s,
  [151, 11],
  133,
  151,
  154,
  c,
  [89, 9],
  s,
  [154, 4],
  130,
  s,
  [154, 9],
  120,
  121,
  154,
  125,
  s,
  [154, 5],
  c,
  [89, 15],
  154,
  154,
  c,
  [89, 3],
  s,
  [154, 9],
  129,
  s,
  [154, 5],
  131,
  132,
  154,
  154,
  c,
  [89, 4],
  s,
  [154, 11],
  133,
  154,
  161,
  c,
  [89, 9],
  s,
  [161, 4],
  130,
  s,
  [161, 9],
  120,
  121,
  161,
  125,
  s,
  [161, 5],
  c,
  [89, 15],
  161,
  161,
  c,
  [89, 3],
  s,
  [161, 9],
  129,
  s,
  [161, 5],
  131,
  132,
  161,
  161,
  c,
  [89, 4],
  s,
  [161, 11],
  133,
  161,
  c,
  [559, 68],
  s,
  [1054, 5, 1],
  742,
  741,
  s,
  [449, 5],
  164,
  c,
  [169, 9],
  s,
  [164, 4],
  130,
  s,
  [164, 9],
  120,
  121,
  164,
  125,
  s,
  [164, 5],
  c,
  [169, 15],
  164,
  164,
  c,
  [169, 3],
  s,
  [164, 9],
  129,
  s,
  [164, 5],
  131,
  132,
  164,
  164,
  c,
  [120, 4],
  s,
  [164, 11],
  133,
  164,
  c,
  [2270, 17],
  s,
  [447, 5]
])
}),
defaultActions: bda({
  idx: u([
  3,
  s,
  [7, 11, 1],
  20,
  21,
  22,
  24,
  25,
  s,
  [27, 8, 1],
  42,
  48,
  62,
  63,
  64,
  s,
  [66, 7, 1],
  s,
  [79, 9, 1],
  s,
  [89, 4, 1],
  s,
  [96, 4, 1],
  s,
  [102, 4, 1],
  s,
  [108, 6, 1],
  118,
  120,
  121,
  126,
  s,
  [134, 13, 1],
  148,
  s,
  [150, 15, 1],
  168,
  169,
  171,
  175,
  176,
  181,
  182,
  183,
  212,
  214,
  215,
  216,
  220,
  226,
  231,
  235,
  236,
  237,
  245,
  254,
  257,
  258,
  261,
  262,
  268,
  269,
  271,
  279,
  283,
  285,
  291,
  299,
  300,
  s,
  [301, 4, 3],
  319,
  322,
  s,
  [328, 4, 1],
  333,
  335,
  338,
  s,
  [343, 4, 1],
  350,
  352,
  353,
  360,
  371,
  372,
  376,
  377,
  378,
  380,
  383,
  390,
  394,
  409,
  415,
  420,
  422,
  425,
  430,
  433,
  434,
  438,
  442,
  444,
  455,
  457,
  461,
  462,
  466,
  468,
  469,
  478,
  490,
  498,
  501,
  502,
  504,
  s,
  [505, 4, 2],
  512,
  515,
  519,
  531,
  535,
  538,
  540,
  542,
  543,
  544,
  546,
  555,
  562,
  564,
  565,
  566,
  576,
  580,
  582,
  585,
  586,
  587,
  600,
  603,
  607,
  609,
  615,
  617,
  619,
  620,
  623,
  625,
  627,
  628,
  631,
  632,
  634,
  638,
  641,
  648,
  657,
  658,
  659,
  661,
  662,
  664,
  669,
  677,
  678,
  680,
  681,
  682,
  688,
  691,
  692,
  694,
  698,
  699,
  704,
  710,
  713,
  717,
  719,
  721,
  724,
  725,
  726,
  731,
  732,
  733,
  737,
  743,
  744,
  748,
  753,
  758,
  760,
  762,
  765,
  767,
  771,
  773,
  776,
  777,
  s,
  [778, 4, 2],
  785,
  787,
  789,
  792,
  794,
  796,
  799,
  800,
  802,
  s,
  [805, 5, 2],
  814,
  817,
  821,
  822,
  823,
  827,
  832,
  842,
  843,
  845,
  847,
  848,
  850,
  856,
  859,
  863,
  864,
  866,
  871,
  873,
  875,
  880,
  882,
  884,
  885,
  900,
  908,
  913,
  915,
  920,
  921,
  923,
  924,
  925,
  929,
  932,
  938,
  940,
  942,
  943,
  s,
  [948, 4, 1],
  954,
  955,
  s,
  [962, 7, 1],
  971,
  973,
  974,
  976,
  983,
  984,
  986,
  991,
  993,
  994,
  996,
  999,
  s,
  [1001, 7, 1],
  s,
  [1009, 5, 1],
  1016,
  1017,
  1022,
  s,
  [1026, 7, 1],
  1034,
  1035,
  1037,
  1040,
  1042,
  1046,
  1048,
  1051,
  s,
  [1053, 5, 1]
]),
  goto: u([
  5,
  s,
  [9, 10, 1],
  426,
  431,
  432,
  433,
  436,
  437,
  s,
  [252, 8, 1],
  55,
  372,
  381,
  382,
  383,
  s,
  [305, 7, 1],
  263,
  s,
  [67, 8, 1],
  s,
  [228, 4, 1],
  391,
  504,
  505,
  506,
  312,
  313,
  321,
  322,
  349,
  350,
  246,
  247,
  314,
  315,
  38,
  48,
  49,
  54,
  s,
  [75, 13, 1],
  89,
  s,
  [91, 15, 1],
  384,
  106,
  111,
  427,
  429,
  377,
  378,
  379,
  199,
  248,
  249,
  250,
  138,
  340,
  35,
  367,
  371,
  386,
  36,
  526,
  530,
  532,
  551,
  552,
  507,
  511,
  455,
  107,
  329,
  344,
  337,
  88,
  90,
  232,
  213,
  269,
  272,
  405,
  411,
  361,
  346,
  347,
  348,
  324,
  327,
  478,
  468,
  469,
  470,
  472,
  317,
  320,
  3,
  57,
  60,
  61,
  108,
  112,
  401,
  113,
  116,
  376,
  224,
  177,
  189,
  211,
  216,
  234,
  128,
  137,
  365,
  21,
  139,
  140,
  394,
  393,
  268,
  277,
  403,
  408,
  415,
  537,
  542,
  457,
  264,
  265,
  109,
  261,
  343,
  330,
  331,
  333,
  356,
  238,
  297,
  422,
  418,
  424,
  357,
  323,
  325,
  363,
  473,
  490,
  495,
  316,
  318,
  402,
  122,
  435,
  45,
  47,
  221,
  174,
  181,
  184,
  186,
  214,
  218,
  237,
  126,
  129,
  366,
  355,
  354,
  142,
  144,
  31,
  368,
  25,
  267,
  416,
  332,
  335,
  515,
  516,
  525,
  553,
  536,
  527,
  531,
  533,
  540,
  508,
  503,
  456,
  438,
  262,
  353,
  239,
  270,
  273,
  283,
  293,
  286,
  292,
  406,
  412,
  425,
  326,
  479,
  483,
  475,
  496,
  485,
  319,
  200,
  208,
  114,
  117,
  374,
  155,
  156,
  195,
  196,
  197,
  173,
  178,
  180,
  190,
  191,
  183,
  219,
  127,
  132,
  342,
  141,
  23,
  32,
  24,
  369,
  399,
  398,
  278,
  298,
  303,
  404,
  409,
  517,
  538,
  529,
  543,
  546,
  549,
  550,
  509,
  440,
  443,
  451,
  266,
  338,
  243,
  274,
  271,
  414,
  480,
  364,
  476,
  488,
  118,
  157,
  158,
  176,
  130,
  135,
  143,
  28,
  279,
  410,
  554,
  557,
  559,
  560,
  544,
  547,
  541,
  510,
  439,
  441,
  334,
  339,
  244,
  245,
  275,
  284,
  287,
  290,
  407,
  481,
  474,
  497,
  487,
  486,
  202,
  115,
  149,
  152,
  163,
  175,
  131,
  370,
  280,
  336,
  519,
  520,
  522,
  555,
  558,
  539,
  518,
  459,
  444,
  454,
  413,
  477,
  463,
  464,
  500,
  489,
  493,
  119,
  150,
  153,
  162,
  166,
  445,
  442,
  289,
  165,
  524,
  521,
  523,
  446
])
}),
parseError: function parseError(str, hash, ExceptionClass) {
    if (hash.recoverable) {
        if (typeof this.trace === 'function') {
            this.trace(str);
        }
        hash.destroy();             // destroy... well, *almost*!
    } else {
        if (typeof this.trace === 'function') {
            this.trace(str);
        }
        if (!ExceptionClass) {
            ExceptionClass = this.JisonParserError;
        }
        throw new ExceptionClass(str, hash);
    }
},
parse: function parse(input) {
    var self = this;
    var stack = new Array(128);         // token stack: stores token which leads to state at the same index (column storage)
    var sstack = new Array(128);        // state stack: stores states (column storage)

    var vstack = new Array(128);        // semantic value stack
    var lstack = new Array(128);        // location stack
    var table = this.table;
    var sp = 0;                         // 'stack pointer': index into the stacks
    var yyloc;

    


    var symbol = 0;



    var TERROR = this.TERROR;
    var EOF = this.EOF;
    var ERROR_RECOVERY_TOKEN_DISCARD_COUNT = (this.options.errorRecoveryTokenDiscardCount | 0) || 3;
    var NO_ACTION = [0, 1060 /* === table.length :: ensures that anyone using this new state will fail dramatically! */];

    var lexer;
    if (this.__lexer__) {
        lexer = this.__lexer__;
    } else {
        lexer = this.__lexer__ = Object.create(this.lexer);
    }

    var sharedState_yy = {
        parseError: undefined,
        quoteName: undefined,
        lexer: undefined,
        parser: undefined,
        pre_parse: undefined,
        post_parse: undefined,
        pre_lex: undefined,
        post_lex: undefined      // WARNING: must be written this way for the code expanders to work correctly in both ES5 and ES6 modes!
    };

    var ASSERT;
    if (typeof assert !== 'function') {
        ASSERT = function JisonAssert(cond, msg) {
            if (!cond) {
                throw new Error('assertion failed: ' + (msg || '***'));
            }
        };
    } else {
        ASSERT = assert;
    }

    this.yyGetSharedState = function yyGetSharedState() {
        return sharedState_yy;
    };


    // shallow clone objects, straight copy of simple `src` values
    // e.g. `lexer.yytext` MAY be a complex value object,
    // rather than a simple string/value.
    function shallow_copy(src) {
        if (typeof src === 'object') {
            var dst = {};
            for (var k in src) {
                if (Object.prototype.hasOwnProperty.call(src, k)) {
                    dst[k] = src[k];
                }
            }
            return dst;
        }
        return src;
    }
    function shallow_copy_noclobber(dst, src) {
        for (var k in src) {
            if (typeof dst[k] === 'undefined' && Object.prototype.hasOwnProperty.call(src, k)) {
                dst[k] = src[k];
            }
        }
    }
    function copy_yylloc(loc) {
        var rv = shallow_copy(loc);
        if (rv && rv.range) {
            rv.range = rv.range.slice(0);
        }
        return rv;
    }

    // copy state
    shallow_copy_noclobber(sharedState_yy, this.yy);

    sharedState_yy.lexer = lexer;
    sharedState_yy.parser = this;






    // Does the shared state override the default `parseError` that already comes with this instance?
    if (typeof sharedState_yy.parseError === 'function') {
        this.parseError = function parseErrorAlt(str, hash, ExceptionClass) {
            if (!ExceptionClass) {
                ExceptionClass = this.JisonParserError;
            }
            return sharedState_yy.parseError.call(this, str, hash, ExceptionClass);
        };
    } else {
        this.parseError = this.originalParseError;
    }

    // Does the shared state override the default `quoteName` that already comes with this instance?
    if (typeof sharedState_yy.quoteName === 'function') {
        this.quoteName = function quoteNameAlt(id_str) {
            return sharedState_yy.quoteName.call(this, id_str);
        };
    } else {
        this.quoteName = this.originalQuoteName;
    }

    // set up the cleanup function; make it an API so that external code can re-use this one in case of
    // calamities or when the `%options no-try-catch` option has been specified for the grammar, in which
    // case this parse() API method doesn't come with a `finally { ... }` block any more!
    //
    // NOTE: as this API uses parse() as a closure, it MUST be set again on every parse() invocation,
    //       or else your `sharedState`, etc. references will be *wrong*!
    this.cleanupAfterParse = function parser_cleanupAfterParse(resultValue, invoke_post_methods, do_not_nuke_errorinfos) {
        var rv;

        if (invoke_post_methods) {
            var hash;

            if (sharedState_yy.post_parse || this.post_parse) {
                // create an error hash info instance: we re-use this API in a **non-error situation**
                // as this one delivers all parser internals ready for access by userland code.
                hash = this.constructParseErrorInfo(null /* no error! */, null /* no exception! */, null, false);
            }

            if (sharedState_yy.post_parse) {
                rv = sharedState_yy.post_parse.call(this, sharedState_yy, resultValue, hash);
                if (typeof rv !== 'undefined') resultValue = rv;
            }
            if (this.post_parse) {
                rv = this.post_parse.call(this, sharedState_yy, resultValue, hash);
                if (typeof rv !== 'undefined') resultValue = rv;
            }

            // cleanup:
            if (hash && hash.destroy) {
                hash.destroy();
            }
        }




        // clean up the lingering lexer structures as well:
        if (lexer.cleanupAfterLex) {
            lexer.cleanupAfterLex(do_not_nuke_errorinfos);
        }

        // prevent lingering circular references from causing memory leaks:
        if (sharedState_yy) {
            sharedState_yy.lexer = undefined;
            sharedState_yy.parser = undefined;
            if (lexer.yy === sharedState_yy) {
                lexer.yy = undefined;
            }
        }
        sharedState_yy = undefined;
        this.parseError = this.originalParseError;
        this.quoteName = this.originalQuoteName;

        // nuke the vstack[] array at least as that one will still reference obsoleted user values.
        // To be safe, we nuke the other internal stack columns as well...
        stack.length = 0;               // fastest way to nuke an array without overly bothering the GC
        sstack.length = 0;
        lstack.length = 0;
        vstack.length = 0;
        sp = 0;

        // nuke the error hash info instances created during this run.
        // Userland code must COPY any data/references
        // in the error hash instance(s) it is more permanently interested in.
        if (!do_not_nuke_errorinfos) {
            for (var i = this.__error_infos.length - 1; i >= 0; i--) {
                var el = this.__error_infos[i];
                if (el && typeof el.destroy === 'function') {
                    el.destroy();
                }
            }
            this.__error_infos.length = 0;


        }

        return resultValue;
    };

    // merge yylloc info into a new yylloc instance.
    //
    // `first_index` and `last_index` MAY be UNDEFINED/NULL or these are indexes into the `lstack[]` location stack array.
    //
    // `first_yylloc` and `last_yylloc` MAY be UNDEFINED/NULL or explicit (custom or regular) `yylloc` instances, in which
    // case these override the corresponding first/last indexes.
    //
    // `dont_look_back` is an optional flag (default: FALSE), which instructs this merge operation NOT to search
    // through the parse location stack for a location, which would otherwise be used to construct the new (epsilon!)
    // yylloc info.
    //
    // Note: epsilon rule's yylloc situation is detected by passing both `first_index` and `first_yylloc` as UNDEFINED/NULL.
    this.yyMergeLocationInfo = function parser_yyMergeLocationInfo(first_index, last_index, first_yylloc, last_yylloc, dont_look_back) {
        var i1 = first_index | 0,
            i2 = last_index | 0;
        var l1 = first_yylloc,
            l2 = last_yylloc;
        var rv;

        // rules:
        // - first/last yylloc entries override first/last indexes

        if (!l1) {
            if (first_index != null) {
                for (var i = i1; i <= i2; i++) {
                    l1 = lstack[i];
                    if (l1) {
                        break;
                    }
                }
            }
        }

        if (!l2) {
            if (last_index != null) {
                for (var i = i2; i >= i1; i--) {
                    l2 = lstack[i];
                    if (l2) {
                        break;
                    }
                }
            }
        }

        // - detect if an epsilon rule is being processed and act accordingly:
        if (!l1 && first_index == null) {
            // epsilon rule span merger. With optional look-ahead in l2.
            if (!dont_look_back) {
                for (var i = (i1 || sp) - 1; i >= 0; i--) {
                    l1 = lstack[i];
                    if (l1) {
                        break;
                    }
                }
            }
            if (!l1) {
                if (!l2) {
                    // when we still don't have any valid yylloc info, we're looking at an epsilon rule
                    // without look-ahead and no preceding terms and/or `dont_look_back` set:
                    // in that case we ca do nothing but return NULL/UNDEFINED:
                    return undefined;
                } else {
                    // shallow-copy L2: after all, we MAY be looking
                    // at unconventional yylloc info objects...
                    rv = shallow_copy(l2);
                    if (rv.range) {
                        // shallow copy the yylloc ranges info to prevent us from modifying the original arguments' entries:
                        rv.range = rv.range.slice(0);
                    }
                    return rv;
                }
            } else {
                // shallow-copy L1, then adjust first col/row 1 column past the end.
                rv = shallow_copy(l1);
                rv.first_line = rv.last_line;
                rv.first_column = rv.last_column;
                if (rv.range) {
                    // shallow copy the yylloc ranges info to prevent us from modifying the original arguments' entries:
                    rv.range = rv.range.slice(0);
                    rv.range[0] = rv.range[1];
                }

                if (l2) {
                    // shallow-mixin L2, then adjust last col/row accordingly.
                    shallow_copy_noclobber(rv, l2);
                    rv.last_line = l2.last_line;
                    rv.last_column = l2.last_column;
                    if (rv.range && l2.range) {
                        rv.range[1] = l2.range[1];
                    }
                }
                return rv;
            }
        }

        if (!l1) {
            l1 = l2;
            l2 = null;
        }
        if (!l1) {
            return undefined;
        }

        // shallow-copy L1|L2, before we try to adjust the yylloc values: after all, we MAY be looking
        // at unconventional yylloc info objects...
        rv = shallow_copy(l1);

        // first_line: ...,
        // first_column: ...,
        // last_line: ...,
        // last_column: ...,
        if (rv.range) {
            // shallow copy the yylloc ranges info to prevent us from modifying the original arguments' entries:
            rv.range = rv.range.slice(0);
        }

        if (l2) {
            shallow_copy_noclobber(rv, l2);
            rv.last_line = l2.last_line;
            rv.last_column = l2.last_column;
            if (rv.range && l2.range) {
                rv.range[1] = l2.range[1];
            }
        }

        return rv;
    };

    // NOTE: as this API uses parse() as a closure, it MUST be set again on every parse() invocation,
    //       or else your `lexer`, `sharedState`, etc. references will be *wrong*!
    this.constructParseErrorInfo = function parser_constructParseErrorInfo(msg, ex, expected, recoverable) {
        var pei = {
            errStr: msg,
            exception: ex,
            text: lexer.match,
            value: lexer.yytext,
            token: this.describeSymbol(symbol) || symbol,
            token_id: symbol,
            line: lexer.yylineno,
            loc: copy_yylloc(lexer.yylloc),
            expected: expected,
            recoverable: recoverable,
            state: state,
            action: action,
            new_state: newState,
            symbol_stack: stack,
            state_stack: sstack,
            value_stack: vstack,
            location_stack: lstack,
            stack_pointer: sp,
            yy: sharedState_yy,
            lexer: lexer,
            parser: this,

            // and make sure the error info doesn't stay due to potential
            // ref cycle via userland code manipulations.
            // These would otherwise all be memory leak opportunities!
            //
            // Note that only array and object references are nuked as those
            // constitute the set of elements which can produce a cyclic ref.
            // The rest of the members is kept intact as they are harmless.
            destroy: function destructParseErrorInfo() {
                // remove cyclic references added to error info:
                // info.yy = null;
                // info.lexer = null;
                // info.value = null;
                // info.value_stack = null;
                // ...
                var rec = !!this.recoverable;
                for (var key in this) {
                    if (this.hasOwnProperty(key) && typeof key === 'object') {
                        this[key] = undefined;
                    }
                }
                this.recoverable = rec;
            }
        };
        // track this instance so we can `destroy()` it once we deem it superfluous and ready for garbage collection!
        this.__error_infos.push(pei);
        return pei;
    };













    function getNonTerminalFromCode(symbol) {
        var tokenName = self.getSymbolName(symbol);
        if (!tokenName) {
            tokenName = symbol;
        }
        return tokenName;
    }


    function stdLex() {
        var token = lexer.lex();
        // if token isn't its numeric value, convert
        if (typeof token !== 'number') {
            token = self.symbols_[token] || token;
        }

        return token || EOF;
    }

    function fastLex() {
        var token = lexer.fastLex();
        // if token isn't its numeric value, convert
        if (typeof token !== 'number') {
            token = self.symbols_[token] || token;
        }

        return token || EOF;
    }

    var lex = stdLex;


    var state, action, r, t;
    var yyval = {
        $: true,
        _$: undefined,
        yy: sharedState_yy
    };
    var p;
    var yyrulelen;
    var this_production;
    var newState;
    var retval = false;




    lexer.setInput(input, sharedState_yy);

    // NOTE: we *assume* no lexer pre/post handlers are set up *after* 
    // this initial `setInput()` call: hence we can now check and decide
    // whether we'll go with the standard, slower, lex() API or the
    // `fast_lex()` one:
    if (typeof lexer.canIUse === 'function') {
        var lexerInfo = lexer.canIUse();
        if (lexerInfo.fastLex && typeof fastLex === 'function') {
            lex = fastLex;
        }
    } 

    yyloc = lexer.yylloc;
    lstack[sp] = yyloc;
    vstack[sp] = null;
    sstack[sp] = 0;
    stack[sp] = 0;
    ++sp;





    if (this.pre_parse) {
        this.pre_parse.call(this, sharedState_yy);
    }
    if (sharedState_yy.pre_parse) {
        sharedState_yy.pre_parse.call(this, sharedState_yy);
    }

    newState = sstack[sp - 1];
    for (;;) {
        // retrieve state number from top of stack
        state = newState;               // sstack[sp - 1];

        // use default actions if available
        if (this.defaultActions[state]) {
            action = 2;
            newState = this.defaultActions[state];
        } else {
            // The single `==` condition below covers both these `===` comparisons in a single
            // operation:
            //
            //     if (symbol === null || typeof symbol === 'undefined') ...
            if (!symbol) {
                symbol = lex();
            }
            // read action for current state and first input
            t = (table[state] && table[state][symbol]) || NO_ACTION;
            newState = t[1];
            action = t[0];











            // handle parse error
            if (!action) {
                var errStr;
                var errSymbolDescr = (this.describeSymbol(symbol) || symbol);
                var expected = this.collect_expected_token_set(state);

                // Report error
                if (typeof lexer.yylineno === 'number') {
                    errStr = 'Parse error on line ' + (lexer.yylineno + 1) + ': ';
                } else {
                    errStr = 'Parse error: ';
                }
                if (typeof lexer.showPosition === 'function') {
                    errStr += '\n' + lexer.showPosition(79 - 10, 10) + '\n';
                }
                if (expected.length) {
                    errStr += 'Expecting ' + expected.join(', ') + ', got unexpected ' + errSymbolDescr;
                } else {
                    errStr += 'Unexpected ' + errSymbolDescr;
                }
                // we cannot recover from the error!
                p = this.constructParseErrorInfo(errStr, null, expected, false);
                r = this.parseError(p.errStr, p, this.JisonParserError);
                if (typeof r !== 'undefined') {
                    retval = r;
                }
                break;
            }


        }










        switch (action) {
        // catch misc. parse failures:
        default:
            // this shouldn't happen, unless resolve defaults are off
            if (action instanceof Array) {
                p = this.constructParseErrorInfo('Parse Error: multiple actions possible at state: ' + state + ', token: ' + symbol, null, null, false);
                r = this.parseError(p.errStr, p, this.JisonParserError);
                if (typeof r !== 'undefined') {
                    retval = r;
                }
                break;
            }
            // Another case of better safe than sorry: in case state transitions come out of another error recovery process
            // or a buggy LUT (LookUp Table):
            p = this.constructParseErrorInfo('Parsing halted. No viable error recovery approach available due to internal system failure.', null, null, false);
            r = this.parseError(p.errStr, p, this.JisonParserError);
            if (typeof r !== 'undefined') {
                retval = r;
            }
            break;

        // shift:
        case 1:
            stack[sp] = symbol;
            vstack[sp] = lexer.yytext;
            lstack[sp] = copy_yylloc(lexer.yylloc);
            sstack[sp] = newState; // push state

            ++sp;
            symbol = 0;




            // Pick up the lexer details for the current symbol as that one is not 'look-ahead' any more:



            yyloc = lexer.yylloc;
            continue;

        // reduce:
        case 2:



            this_production = this.productions_[newState - 1];  // `this.productions_[]` is zero-based indexed while states start from 1 upwards...
            yyrulelen = this_production[1];










            r = this.performAction.call(yyval, yyloc, newState, sp - 1, vstack, lstack);

            if (typeof r !== 'undefined') {
                retval = r;
                break;
            }

            // pop off stack
            sp -= yyrulelen;

            // don't overwrite the `symbol` variable: use a local var to speed things up:
            var ntsymbol = this_production[0];    // push nonterminal (reduce)
            stack[sp] = ntsymbol;
            vstack[sp] = yyval.$;
            lstack[sp] = yyval._$;
            // goto new state = table[STATE][NONTERMINAL]
            newState = table[sstack[sp - 1]][ntsymbol];
            sstack[sp] = newState;
            ++sp;









            continue;

        // accept:
        case 3:
            if (sp !== -2) {
                retval = true;
                // Return the `$accept` rule's `$$` result, if available.
                //
                // Also note that JISON always adds this top-most `$accept` rule (with implicit,
                // default, action):
                //
                //     $accept: <startSymbol> $end
                //                  %{ $$ = $1; @$ = @1; %}
                //
                // which, combined with the parse kernel's `$accept` state behaviour coded below,
                // will produce the `$$` value output of the <startSymbol> rule as the parse result,
                // IFF that result is *not* `undefined`. (See also the parser kernel code.)
                //
                // In code:
                //
                //                  %{
                //                      @$ = @1;            // if location tracking support is included
                //                      if (typeof $1 !== 'undefined')
                //                          return $1;
                //                      else
                //                          return true;           // the default parse result if the rule actions don't produce anything
                //                  %}
                sp--;
                if (typeof vstack[sp] !== 'undefined') {
                    retval = vstack[sp];
                }
            }
            break;
        }

        // break out of loop: we accept or fail with error
        break;
    }
    
    // ... AND FINALLY ...

    retval = this.cleanupAfterParse(retval, true, true);


    

    return retval;
}
};
parser.originalParseError = parser.parseError;
parser.originalQuoteName = parser.quoteName;



function Parser() {
  this.yy = {};
}
Parser.prototype = parser;
parser.Parser = Parser;

return new Parser();
})();

        


if (typeof require !== 'undefined' && typeof exports !== 'undefined') {
  exports.parser = Elysion;
  exports.Parser = Elysion.Parser;
  exports.parse = function () {
    return Elysion.parse.apply(Elysion, arguments);
  };
  
}
